This directory contains The Wave Ifremer-SHOM Tool for visualization. 
The GUI is launched by typing @visu in front of the idl prompt (using 
a licence or the demo version). Without a licence, please 
download the rt_visumain.sav compile version and use the (free) 
IDL runtime application. 

All information and how to use the GUI can be found here: 
https://forge.ifremer.fr/plugins/mediawiki/wiki/ww3/index.php/En:idl_tool

This is distributed under the Cecill licence version 2.1 ( http://www.cecill.info/ ) 

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
!     This module contains routines for writing the remapping data to 
!     a file.  Before writing the data for each mapping, the links are 
!     sorted by destination grid address.
!
!-----------------------------------------------------------------------
!
!     CVS:$Id: remap_write.f,v 1.7 2001/08/21 21:06:42 pwjones Exp $
!
!     Copyright (c) 1997, 1998 the Regents of the University of 
!       California.
!
!     This software and ancillary information (herein called software) 
!     called SCRIP is made available under the terms described here.  
!     The software has been approved for release with associated 
!     LA-CC Number 98-45.
!
!     Unless otherwise indicated, this software has been authored
!     by an employee or employees of the University of California,
!     operator of the Los Alamos National Laboratory under Contract
!     No. W-7405-ENG-36 with the U.S. Department of Energy.  The U.S.
!     Government has rights to use, reproduce, and distribute this
!     software.  The public may copy and use this software without
!     charge, provided that this Notice and any statement of authorship
!     are reproduced on all copies.  Neither the Government nor the
!     University makes any warranty, express or implied, or assumes
!     any liability or responsibility for the use of this software.
!
!     If software is modified to produce derivative works, such modified
!     software should be clearly marked, so as not to confuse it with 
!     the version available from Los Alamos National Laboratory.
!
!     This code has been modified from the version available from 
!     Los Alamos National Laboratory, for the purpose of running it
!     within WW3.
!
!***********************************************************************

      module scrip_remap_write

!-----------------------------------------------------------------------

      use SCRIP_KindsMod  ! defines common data types
      use SCRIP_ErrorMod  ! SCRIP  error handler
      use SCRIP_NetcdfMod ! netCDF error handler
      use netcdf          ! netCDF library

      use SCRIP_constants     ! defines common scalar constants
      use scrip_grids         ! module containing grid information
      use scrip_remap_vars    ! module containing remap information

      implicit none

!-----------------------------------------------------------------------
!
!     module variables
!
!-----------------------------------------------------------------------

      character(SCRIP_charLength), private :: 
     &   map_method       ! character string for map_type
     &,  normalize_opt    ! character string for normalization option
     &,  history          ! character string for history information
     &,  convention       ! character string for output convention

      character(8), private :: 
     &   cdate            ! character date string

      integer (SCRIP_i4), dimension(:), allocatable, private ::
     &   src_mask_int     ! integer masks to determine
     &,  dst_mask_int     ! cells that participate in map

!-----------------------------------------------------------------------
!
!     various netCDF identifiers used by output routines
!
!-----------------------------------------------------------------------

      integer (SCRIP_i4), private ::
     &   ncstat               ! error flag for netCDF calls 
     &,  nc_file_id           ! id for netCDF file
     &,  nc_srcgrdsize_id     ! id for source grid size
     &,  nc_dstgrdsize_id     ! id for destination grid size
     &,  nc_srcgrdcorn_id     ! id for number of source grid corners
     &,  nc_dstgrdcorn_id     ! id for number of dest grid corners
     &,  nc_srcgrdrank_id     ! id for source grid rank
     &,  nc_dstgrdrank_id     ! id for dest grid rank
     &,  nc_numlinks_id       ! id for number of links in mapping
     &,  nc_numwgts_id        ! id for number of weights for mapping
     &,  nc_srcgrddims_id     ! id for source grid dimensions
     &,  nc_dstgrddims_id     ! id for dest grid dimensions
     &,  nc_srcgrdcntrlat_id  ! id for source grid center latitude
     &,  nc_dstgrdcntrlat_id  ! id for dest grid center latitude
     &,  nc_srcgrdcntrlon_id  ! id for source grid center longitude
     &,  nc_dstgrdcntrlon_id  ! id for dest grid center longitude
     &,  nc_srcgrdimask_id    ! id for source grid mask
     &,  nc_dstgrdimask_id    ! id for dest grid mask
     &,  nc_srcgrdcrnrlat_id  ! id for latitude of source grid corners
     &,  nc_srcgrdcrnrlon_id  ! id for longitude of source grid corners
     &,  nc_dstgrdcrnrlat_id  ! id for latitude of dest grid corners
     &,  nc_dstgrdcrnrlon_id  ! id for longitude of dest grid corners
     &,  nc_srcgrdarea_id     ! id for area of source grid cells
     &,  nc_dstgrdarea_id     ! id for area of dest grid cells
     &,  nc_srcgrdfrac_id     ! id for area fraction on source grid
     &,  nc_dstgrdfrac_id     ! id for area fraction on dest grid
     &,  nc_srcadd_id         ! id for map source address
     &,  nc_dstadd_id         ! id for map destination address
     &,  nc_rmpmatrix_id      ! id for remapping matrix

      integer (SCRIP_i4), dimension(2), private ::
     &   nc_dims2_id  ! netCDF ids for 2d array dims

!***********************************************************************

      contains

!***********************************************************************

      subroutine write_remap(map1_name, map2_name, interp_file1, 
     &                    interp_file2, output_opt, l_master, errorCode)

!-----------------------------------------------------------------------
!
!     calls correct output routine based on output format choice
!
!-----------------------------------------------------------------------

!-----------------------------------------------------------------------
!
!     input variables
!
!-----------------------------------------------------------------------

      character(SCRIP_charLength), intent(in) ::
     &            map1_name,    ! name for mapping grid1 to grid2
     &            map2_name,    ! name for mapping grid2 to grid1
     &            interp_file1, ! filename for map1 remap data
     &            interp_file2, ! filename for map2 remap data
     &            output_opt    ! option for output conventions

      logical, intent(in) ::
     &            l_master      ! Am I the master processor?

!-----------------------------------------------------------------------
!
!     output variables
!
!-----------------------------------------------------------------------

      integer (SCRIP_i4), intent(out) ::
     &   errorCode              ! returned error code

!-----------------------------------------------------------------------
!
!     local variables
!
!-----------------------------------------------------------------------

      character (11), parameter :: rtnName = 'write_remap'

!-----------------------------------------------------------------------
!
!     define some common variables to be used in all routines
!
!-----------------------------------------------------------------------

      errorCode = SCRIP_Success

      select case(norm_opt)
      case (norm_opt_none)
        normalize_opt = 'none'
      case (norm_opt_frcarea)
        normalize_opt = 'fracarea'
      case (norm_opt_dstarea)
        normalize_opt = 'destarea'
      end select

      select case(map_type)
      case(map_type_conserv)
        map_method = 'Conservative remapping'
      case(map_type_bilinear)
        map_method = 'Bilinear remapping'
      case(map_type_distwgt)
        map_method = 'Distance weighted avg of nearest neighbors'
      case(map_type_bicubic)
        map_method = 'Bicubic remapping'
      case(map_type_particle)
        map_method = 'Particle remapping'
      case default
         call SCRIP_ErrorSet(errorCode, rtnName, 'Invalid Map Type')
         return
      end select

      call date_and_time(date=cdate)
      write (history,1000) cdate(5:6),cdate(7:8),cdate(1:4)
 1000 format('Created: ',a2,'-',a2,'-',a4)

!-----------------------------------------------------------------------
!
!     sort address and weight arrays
!
!-----------------------------------------------------------------------

! New Apr4 2013: sort_add is instead called from scrip_interface.ftn
!     prior to entering this routine...no need to call it again here.

!     call sort_add(grid2_add_map1, grid1_add_map1, wts_map1)
      if (num_maps > 1) then
         call sort_add(grid1_add_map2, grid2_add_map2, wts_map2)
      endif

!-----------------------------------------------------------------------
!
!     call appropriate output routine
!
!-----------------------------------------------------------------------

      select case(output_opt)
      case ('scrip')
         if (l_master)  
     &   call write_remap_scrip(map1_name, interp_file1, 1, errorCode)
         if (SCRIP_ErrorCheck(errorCode, rtnName,
     &       'error in write_remap_scrip')) return
      case ('ncar-csm')
         call write_remap_csm  (map1_name, interp_file1, 1, errorCode)
         if (SCRIP_ErrorCheck(errorCode, rtnName,
     &       'error in write_remap_csm')) return
      case default
         call SCRIP_ErrorSet(errorCode, rtnName, 
     &                       'unknown output file convention')
         return
      end select

!-----------------------------------------------------------------------
!
!     call appropriate output routine for second mapping if required
!
!-----------------------------------------------------------------------

      if (num_maps > 1) then
        select case(output_opt)
        case ('scrip')
          if (l_master)  
     &    call write_remap_scrip(map2_name, interp_file2, 2, errorCode)
          if (SCRIP_ErrorCheck(errorCode, rtnName,
     &        'error in write_remap_scrip')) return
        case ('ncar-csm')
          call write_remap_csm  (map2_name, interp_file2, 2, errorCode)
          if (SCRIP_ErrorCheck(errorCode, rtnName,
     &        'error in write_remap_csm')) return
        case default
          call SCRIP_ErrorSet(errorCode, rtnName,
     &                        'unknown output file convention')
          return
        end select
      endif

!-----------------------------------------------------------------------

      end subroutine write_remap

!***********************************************************************

      subroutine write_remap_scrip(map_name, interp_file, direction,
     &                             errorCode)

!-----------------------------------------------------------------------
!
!     writes remap data to a netCDF file using SCRIP conventions
!
!-----------------------------------------------------------------------

!-----------------------------------------------------------------------
!
!     input variables
!
!-----------------------------------------------------------------------

      character(SCRIP_charLength), intent(in) ::
     &            map_name     ! name for mapping 
     &,           interp_file  ! filename for remap data

      integer (SCRIP_i4), intent(in) ::
     &  direction              ! direction of map (1=grid1 to grid2
                               !                   2=grid2 to grid1)

!-----------------------------------------------------------------------
!
!     output variables
!
!-----------------------------------------------------------------------

      integer (SCRIP_i4), intent(out) ::
     &   errorCode              ! returned error code

!-----------------------------------------------------------------------
!
!     local variables
!
!-----------------------------------------------------------------------

      character(SCRIP_charLength) ::
     &  grid1_ctmp        ! character temp for grid1 names
     &, grid2_ctmp        ! character temp for grid2 names

      integer (SCRIP_i4) ::
     &  itmp1             ! integer temp
     &, itmp2             ! integer temp
     &, itmp3             ! integer temp
     &, itmp4             ! integer temp

      character (17), parameter :: rtnName = 'write_remap_scrip'

!-----------------------------------------------------------------------
!
!     create netCDF file for mapping and define some global attributes
!
!-----------------------------------------------------------------------

      errorCode = SCRIP_Success

      ncstat = nf90_create (interp_file, NF90_CLOBBER, nc_file_id)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &                           'error creating remap file')) return

      !***
      !*** map name
      !***
      ncstat = nf90_put_att(nc_file_id, NF90_GLOBAL, 'title', map_name)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &                           'error writing remap name')) return

      !***
      !*** normalization option
      !***
      ncstat = nf90_put_att(nc_file_id, NF90_GLOBAL, 'normalization',
     &                      normalize_opt)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &                     'error writing normalize option')) return

      !***
      !*** map method
      !***
      ncstat = nf90_put_att(nc_file_id, NF90_GLOBAL, 'map_method',
     &                      map_method)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &                         'error writing remap method')) return

      !***
      !*** history
      !***
      ncstat = nf90_put_att(nc_file_id, NF90_GLOBAL, 'history',
     &                      history)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &                           'error writing history')) return

      !***
      !*** file convention
      !***
      convention = 'SCRIP'
      ncstat = nf90_put_att(nc_file_id, NF90_GLOBAL, 'conventions',
     &                                                convention)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &                  'error writing output convention')) return

      !***
      !*** source and destination grid names
      !***

      if (direction == 1) then
        grid1_ctmp = 'source_grid'
        grid2_ctmp = 'dest_grid'
      else
        grid1_ctmp = 'dest_grid'
        grid2_ctmp = 'source_grid'
      endif

      ncstat = nf90_put_att(nc_file_id, NF90_GLOBAL, trim(grid1_ctmp),
     &                      grid1_name)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &                      'error writing source grid name')) return

      ncstat = nf90_put_att(nc_file_id, NF90_GLOBAL, trim(grid2_ctmp),
     &                      grid2_name)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &                   'error writing destination grid name')) return

!-----------------------------------------------------------------------
!
!     prepare netCDF dimension info
!
!-----------------------------------------------------------------------

      !***
      !*** define grid size dimensions
      !***

      if (direction == 1) then
        itmp1 = grid1_size
        itmp2 = grid2_size
      else
        itmp1 = grid2_size
        itmp2 = grid1_size
      endif

      ncstat = nf90_def_dim(nc_file_id, 'src_grid_size', itmp1, 
     &                      nc_srcgrdsize_id)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &                 'error defining source grid size')) return

      ncstat = nf90_def_dim(nc_file_id, 'dst_grid_size', itmp2, 
     &                      nc_dstgrdsize_id)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &            'error defining destination grid size')) return

      !***
      !*** define grid corner dimension
      !***

      if (direction == 1) then
        itmp1 = grid1_corners
        itmp2 = grid2_corners
      else
        itmp1 = grid2_corners
        itmp2 = grid1_corners
      endif

      ncstat = nf90_def_dim(nc_file_id, 'src_grid_corners', 
     &                      itmp1, nc_srcgrdcorn_id)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &         'error defining num corners on source grid')) return

      ncstat = nf90_def_dim(nc_file_id, 'dst_grid_corners', 
     &                      itmp2, nc_dstgrdcorn_id)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &     'error defining num corners on destination grid')) return

      !***
      !*** define grid rank dimension
      !***

      if (direction == 1) then
        itmp1 = grid1_rank
        itmp2 = grid2_rank
      else
        itmp1 = grid2_rank
        itmp2 = grid1_rank
      endif

      ncstat = nf90_def_dim(nc_file_id, 'src_grid_rank', 
     &                      itmp1, nc_srcgrdrank_id)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &                    'error defining source grid rank')) return

      ncstat = nf90_def_dim(nc_file_id, 'dst_grid_rank', 
     &                      itmp2, nc_dstgrdrank_id)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &               'error defining destination grid rank')) return

      !***
      !*** define map size dimensions
      !***

      if (direction == 1) then
        itmp1 = num_links_map1
      else
        itmp1 = num_links_map2
      endif

      ncstat = nf90_def_dim(nc_file_id, 'num_links', 
     &                      itmp1, nc_numlinks_id)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &                           'error defining remap size')) return

      ncstat = nf90_def_dim(nc_file_id, 'num_wgts', 
     &                      num_wts, nc_numwgts_id)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &                    'error defining number of weights')) return

      !***
      !*** define grid dimensions
      !***

      ncstat = nf90_def_var(nc_file_id, 'src_grid_dims', NF90_INT,
     &                      nc_srcgrdrank_id, nc_srcgrddims_id)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &         'error defining source grid dims')) return

      ncstat = nf90_def_var(nc_file_id, 'dst_grid_dims', NF90_INT,
     &                      nc_dstgrdrank_id, nc_dstgrddims_id)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &         'error defining destination grid dims')) return

!-----------------------------------------------------------------------
!
!     define all arrays for netCDF descriptors
!
!-----------------------------------------------------------------------

      !***
      !*** define grid center latitude array
      !***

      ncstat = nf90_def_var(nc_file_id, 'src_grid_center_lat', 
     &                      NF90_DOUBLE, nc_srcgrdsize_id, 
     &                      nc_srcgrdcntrlat_id)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &         'error defining source grid center lat')) return

      ncstat = nf90_def_var(nc_file_id, 'dst_grid_center_lat', 
     &                      NF90_DOUBLE, nc_dstgrdsize_id, 
     &                      nc_dstgrdcntrlat_id)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &         'error defining destination grid center lat')) return

      !***
      !*** define grid center longitude array
      !***

      ncstat = nf90_def_var(nc_file_id, 'src_grid_center_lon', 
     &                      NF90_DOUBLE, nc_srcgrdsize_id, 
     &                      nc_srcgrdcntrlon_id)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &         'error defining source grid center lon')) return

      ncstat = nf90_def_var(nc_file_id, 'dst_grid_center_lon', 
     &                      NF90_DOUBLE, nc_dstgrdsize_id, 
     &                      nc_dstgrdcntrlon_id)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &         'error defining destination grid center lon')) return

      !***
      !*** define grid corner lat/lon arrays
      !***

      nc_dims2_id(1) = nc_srcgrdcorn_id
      nc_dims2_id(2) = nc_srcgrdsize_id

      ncstat = nf90_def_var(nc_file_id, 'src_grid_corner_lat', 
     &                      NF90_DOUBLE, nc_dims2_id, 
     &                      nc_srcgrdcrnrlat_id)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &         'error defining source grid corner lats')) return

      ncstat = nf90_def_var(nc_file_id, 'src_grid_corner_lon', 
     &                      NF90_DOUBLE, nc_dims2_id, 
     &                      nc_srcgrdcrnrlon_id)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &         'error defining source grid corner lons')) return

      nc_dims2_id(1) = nc_dstgrdcorn_id
      nc_dims2_id(2) = nc_dstgrdsize_id

      ncstat = nf90_def_var(nc_file_id, 'dst_grid_corner_lat', 
     &                      NF90_DOUBLE, nc_dims2_id, 
     &                      nc_dstgrdcrnrlat_id)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &         'error defining destination grid corner lats')) return

      ncstat = nf90_def_var(nc_file_id, 'dst_grid_corner_lon', 
     &                      NF90_DOUBLE, nc_dims2_id, 
     &                      nc_dstgrdcrnrlon_id)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &         'error defining destination grid corner lons')) return

      !***
      !*** define units for all coordinate arrays
      !***

      if (direction == 1) then
        grid1_ctmp = grid1_units
        grid2_ctmp = grid2_units
      else
        grid1_ctmp = grid2_units
        grid2_ctmp = grid1_units
      endif

      ncstat = nf90_put_att(nc_file_id, nc_srcgrdcntrlat_id, 
     &                      'units', grid1_ctmp)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &         'error writing source grid units')) return

      ncstat = nf90_put_att(nc_file_id, nc_dstgrdcntrlat_id, 
     &                      'units', grid2_ctmp)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &         'error writing destination grid units')) return

      ncstat = nf90_put_att(nc_file_id, nc_srcgrdcntrlon_id, 
     &                      'units', grid1_ctmp)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &         'error writing source grid units')) return

      ncstat = nf90_put_att(nc_file_id, nc_dstgrdcntrlon_id, 
     &                      'units', grid2_ctmp)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &         'error writing destination grid units')) return

      ncstat = nf90_put_att(nc_file_id, nc_srcgrdcrnrlat_id, 
     &                      'units', grid1_ctmp)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &         'error writing source grid units')) return

      ncstat = nf90_put_att(nc_file_id, nc_srcgrdcrnrlon_id, 
     &                      'units', grid1_ctmp)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &         'error writing source grid units')) return

      ncstat = nf90_put_att(nc_file_id, nc_dstgrdcrnrlat_id, 
     &                      'units', grid2_ctmp)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &         'error writing destination grid units')) return

      ncstat = nf90_put_att(nc_file_id, nc_dstgrdcrnrlon_id, 
     &                      'units', grid2_ctmp)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &         'error writing destination grid units')) return

      !***
      !*** define grid mask
      !***

      ncstat = nf90_def_var(nc_file_id, 'src_grid_imask', NF90_INT,
     &                      nc_srcgrdsize_id, nc_srcgrdimask_id)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &         'error defining source grid mask')) return

      ncstat = nf90_put_att(nc_file_id, nc_srcgrdimask_id, 
     &                      'units', 'unitless')
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &         'error writing source grid mask units')) return

      ncstat = nf90_def_var(nc_file_id, 'dst_grid_imask', NF90_INT,
     &                      nc_dstgrdsize_id, nc_dstgrdimask_id)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &         'error defining destination grid mask')) return

      ncstat = nf90_put_att(nc_file_id, nc_dstgrdimask_id, 
     &                      'units', 'unitless')
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &         'error writing destination grid mask units')) return

      !***
      !*** define grid area arrays
      !***

      ncstat = nf90_def_var(nc_file_id, 'src_grid_area', 
     &                      NF90_DOUBLE, nc_srcgrdsize_id, 
     &                      nc_srcgrdarea_id)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &         'error defining source grid area')) return

      ncstat = nf90_put_att(nc_file_id, nc_srcgrdarea_id, 
     &                      'units', 'square radians')
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &         'error writing source area units')) return

      ncstat = nf90_def_var(nc_file_id, 'dst_grid_area', 
     &                      NF90_DOUBLE, nc_dstgrdsize_id, 
     &                      nc_dstgrdarea_id)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &         'error defining destination grid area')) return

      ncstat = nf90_put_att(nc_file_id, nc_dstgrdarea_id, 
     &                      'units', 'square radians')
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &         'error writing destination area units')) return

      !***
      !*** define grid fraction arrays
      !***

      ncstat = nf90_def_var(nc_file_id, 'src_grid_frac', 
     &                      NF90_DOUBLE, nc_srcgrdsize_id, 
     &                      nc_srcgrdfrac_id)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &         'error defining source grid fraction')) return

      ncstat = nf90_put_att(nc_file_id, nc_srcgrdfrac_id, 
     &                      'units', 'unitless')
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &         'error writing source fraction units')) return

      ncstat = nf90_def_var(nc_file_id, 'dst_grid_frac', 
     &                      NF90_DOUBLE, nc_dstgrdsize_id, 
     &                      nc_dstgrdfrac_id)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &         'error defining destination fraction')) return

      ncstat = nf90_put_att(nc_file_id, nc_dstgrdfrac_id, 
     &                      'units', 'unitless')
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &         'error writing destination frac units')) return

      !***
      !*** define mapping arrays
      !***

      ncstat = nf90_def_var(nc_file_id, 'src_address', 
     &                      NF90_INT, nc_numlinks_id, 
     &                      nc_srcadd_id)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &         'error defining source addresses')) return

      ncstat = nf90_def_var(nc_file_id, 'dst_address', 
     &                      NF90_INT, nc_numlinks_id, 
     &                      nc_dstadd_id)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &         'error defining destination addresses')) return

      nc_dims2_id(1) = nc_numwgts_id
      nc_dims2_id(2) = nc_numlinks_id

      ncstat = nf90_def_var(nc_file_id, 'remap_matrix', 
     &                      NF90_DOUBLE, nc_dims2_id, 
     &                      nc_rmpmatrix_id)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &         'error defining remapping weights')) return

      !***
      !*** end definition stage
      !***

      ncstat = nf90_enddef(nc_file_id)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &                         'error ending definition phase')) return

!-----------------------------------------------------------------------
!
!     compute integer masks
!
!-----------------------------------------------------------------------

      if (direction == 1) then
        allocate (src_mask_int(grid1_size),
     &            dst_mask_int(grid2_size))

        where (grid2_mask)
          dst_mask_int = 1
        elsewhere
          dst_mask_int = 0
        endwhere

        where (grid1_mask)
          src_mask_int = 1
        elsewhere
          src_mask_int = 0
        endwhere
      else
        allocate (src_mask_int(grid2_size),
     &            dst_mask_int(grid1_size))

        where (grid1_mask)
          dst_mask_int = 1
        elsewhere
          dst_mask_int = 0
        endwhere

        where (grid2_mask)
          src_mask_int = 1
        elsewhere
          src_mask_int = 0
        endwhere
      endif

!-----------------------------------------------------------------------
!
!     change units of lat/lon coordinates if input units different
!     from radians
!
!-----------------------------------------------------------------------

      if (grid1_units(1:7) == 'degrees' .and. direction == 1) then
        grid1_center_lat = grid1_center_lat/deg2rad
        grid1_center_lon = grid1_center_lon/deg2rad
        grid1_corner_lat = grid1_corner_lat/deg2rad
        grid1_corner_lon = grid1_corner_lon/deg2rad
      endif

      if (grid2_units(1:7) == 'degrees' .and. direction == 1) then
        grid2_center_lat = grid2_center_lat/deg2rad
        grid2_center_lon = grid2_center_lon/deg2rad
        grid2_corner_lat = grid2_corner_lat/deg2rad
        grid2_corner_lon = grid2_corner_lon/deg2rad
      endif

!-----------------------------------------------------------------------
!
!     write mapping data
!
!-----------------------------------------------------------------------

      if (direction == 1) then
        itmp1 = nc_srcgrddims_id
        itmp2 = nc_dstgrddims_id
      else
        itmp2 = nc_srcgrddims_id
        itmp1 = nc_dstgrddims_id
      endif

      ncstat = nf90_put_var(nc_file_id, itmp1, grid1_dims)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &         'error writing source grid dims')) return

      ncstat = nf90_put_var(nc_file_id, itmp2, grid2_dims)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &         'error writing destination grid dims')) return

      ncstat = nf90_put_var(nc_file_id, nc_srcgrdimask_id, src_mask_int)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &         'error writing source grid mask')) return

      ncstat = nf90_put_var(nc_file_id, nc_dstgrdimask_id, dst_mask_int)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &         'error writing destination grid mask')) return

      deallocate(src_mask_int, dst_mask_int)

      if (direction == 1) then
        itmp1 = nc_srcgrdcntrlat_id
        itmp2 = nc_srcgrdcntrlon_id
        itmp3 = nc_srcgrdcrnrlat_id
        itmp4 = nc_srcgrdcrnrlon_id
      else
        itmp1 = nc_dstgrdcntrlat_id
        itmp2 = nc_dstgrdcntrlon_id
        itmp3 = nc_dstgrdcrnrlat_id
        itmp4 = nc_dstgrdcrnrlon_id
      endif

      ncstat = nf90_put_var(nc_file_id, itmp1, grid1_center_lat)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &         'error writing source grid center lats')) return

      ncstat = nf90_put_var(nc_file_id, itmp2, grid1_center_lon)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &         'error writing source grid center lons')) return

      ncstat = nf90_put_var(nc_file_id, itmp3, grid1_corner_lat)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &         'error writing source grid corner lats')) return

      ncstat = nf90_put_var(nc_file_id, itmp4, grid1_corner_lon)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &         'error writing source grid corner lons')) return

      if (direction == 1) then
        itmp1 = nc_dstgrdcntrlat_id
        itmp2 = nc_dstgrdcntrlon_id
        itmp3 = nc_dstgrdcrnrlat_id
        itmp4 = nc_dstgrdcrnrlon_id
      else
        itmp1 = nc_srcgrdcntrlat_id
        itmp2 = nc_srcgrdcntrlon_id
        itmp3 = nc_srcgrdcrnrlat_id
        itmp4 = nc_srcgrdcrnrlon_id
      endif

      ncstat = nf90_put_var(nc_file_id, itmp1, grid2_center_lat)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &         'error writing destination grid center lats')) return

      ncstat = nf90_put_var(nc_file_id, itmp2, grid2_center_lon)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &         'error writing destination grid center lons')) return

      ncstat = nf90_put_var(nc_file_id, itmp3, grid2_corner_lat)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &         'error writing destination grid corner lats')) return

      ncstat = nf90_put_var(nc_file_id, itmp4, grid2_corner_lon)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &         'error writing destination grid corner lons')) return

      if (direction == 1) then
        itmp1 = nc_srcgrdarea_id
        itmp2 = nc_srcgrdfrac_id
        itmp3 = nc_dstgrdarea_id
        itmp4 = nc_dstgrdfrac_id
      else
        itmp1 = nc_dstgrdarea_id
        itmp2 = nc_dstgrdfrac_id
        itmp3 = nc_srcgrdarea_id
        itmp4 = nc_srcgrdfrac_id
      endif

      if (luse_grid1_area) then
        ncstat = nf90_put_var(nc_file_id, itmp1, grid1_area_in)
      else
        ncstat = nf90_put_var(nc_file_id, itmp1, grid1_area)
      endif
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &         'error writing grid1 area')) return

      ncstat = nf90_put_var(nc_file_id, itmp2, grid1_frac)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &         'error writing grid1 frac')) return

      if (luse_grid2_area) then
        ncstat = nf90_put_var(nc_file_id, itmp3, grid2_area_in)
      else
        ncstat = nf90_put_var(nc_file_id, itmp3, grid2_area)
      endif
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &         'error writing grid2 area')) return

      ncstat = nf90_put_var(nc_file_id, itmp4, grid2_frac)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &         'error writing grid2 frac')) return

      if (direction == 1) then
        ncstat = nf90_put_var(nc_file_id, nc_srcadd_id, 
     &                        grid1_add_map1)
        if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &           'error writing source addresses')) return

        ncstat = nf90_put_var(nc_file_id, nc_dstadd_id, 
     &                        grid2_add_map1)
        if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &           'error writing destination addresses')) return

        ncstat = nf90_put_var(nc_file_id, nc_rmpmatrix_id, wts_map1)
        if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &           'error writing weights')) return
      else
        ncstat = nf90_put_var(nc_file_id, nc_srcadd_id, 
     &                        grid2_add_map2)
        if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &           'error writing source addresses')) return

        ncstat = nf90_put_var(nc_file_id, nc_dstadd_id, 
     &                          grid1_add_map2)
        if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &           'error writing destination addresses')) return

        ncstat = nf90_put_var(nc_file_id, nc_rmpmatrix_id, wts_map2)
        if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &           'error writing weights')) return
      endif

      ncstat = nf90_close(nc_file_id)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &                           'error closing file')) return

!-----------------------------------------------------------------------

      end subroutine write_remap_scrip

!***********************************************************************

      subroutine write_remap_ww3(map1_name, interp_file1, 
     &                           output_opt, l_master, errorCode)

!-----------------------------------------------------------------------
!
!     calls correct output routine for WW3 based on output format choice
!
!     only output variables needed for WW3 remapping
!
!-----------------------------------------------------------------------
      use netcdf

!-----------------------------------------------------------------------
!
!     input variables
!
!-----------------------------------------------------------------------

      character(SCRIP_charLength), intent(in) ::
     &            map1_name,    ! name for mapping grid1 to grid2
     &            interp_file1, ! filename for map1 remap data
     &            output_opt    ! option for output conventions
      logical, intent(in) ::
     &            l_master      ! Am I the master processor?

!-----------------------------------------------------------------------
!
!     output variables
!
!-----------------------------------------------------------------------

      integer (SCRIP_i4), intent(out) ::
     &   errorCode              ! returned error code

!-----------------------------------------------------------------------
!
!     local variables
!
!-----------------------------------------------------------------------

      character (15), parameter :: rtnName = 'write_remap_ww3'
      character(SCRIP_charLength) ::
     &            map1_name_pass,    ! name for mapping grid1 to grid2
     &            interp_file1_pass  ! filename for map1 remap data

!-----------------------------------------------------------------------
!
!     define some common variables to be used in all routines
!
!-----------------------------------------------------------------------

      errorCode = SCRIP_Success
      map1_name_pass = map1_name
      interp_file1_pass = interp_file1

      select case(norm_opt)
      case (norm_opt_none)
        normalize_opt = 'none'
      case (norm_opt_frcarea)
        normalize_opt = 'fracarea'
      case (norm_opt_dstarea)
        normalize_opt = 'destarea'
      end select

      select case(map_type)
      case(map_type_conserv)
        map_method = 'Conservative remapping'
      case(map_type_bilinear)
        map_method = 'Bilinear remapping'
      case(map_type_distwgt)
        map_method = 'Distance weighted avg of nearest neighbors'
      case(map_type_bicubic)
        map_method = 'Bicubic remapping'
      case(map_type_particle)
        map_method = 'Particle remapping'
      case default
         call SCRIP_ErrorSet(errorCode, rtnName, 'Invalid Map Type')
         return
      end select

      call date_and_time(date=cdate)
      write (history,1000) cdate(5:6),cdate(7:8),cdate(1:4)
 1000 format('Created: ',a2,'-',a2,'-',a4)

!-----------------------------------------------------------------------
!
!     sort address and weight arrays
!
!-----------------------------------------------------------------------

      call sort_add(grid2_add_map1, grid1_add_map1, wts_map1)
      if (num_maps > 1) then
        call sort_add(grid1_add_map2, grid2_add_map2, wts_map2)
      endif

!-----------------------------------------------------------------------
!
!     call appropriate output routine
!
!-----------------------------------------------------------------------

      select case(output_opt)
      case ('scrip')
         if (l_master) then
            call write_remap_scrip_ww3(map1_name_pass, 
     &           interp_file1_pass, errorCode)
         endif
         if (SCRIP_ErrorCheck(errorCode, rtnName,
     &       'error in write_remap_scrip')) return
      case default
         call SCRIP_ErrorSet(errorCode, rtnName, 
     &                       'unknown output file convention')
         return
      end select

!-----------------------------------------------------------------------

      end subroutine write_remap_ww3

!***********************************************************************

      subroutine write_remap_scrip_ww3(map_name, interp_file, errorCode)

!-----------------------------------------------------------------------
!
!     writes remap data to a netCDF file using SCRIP conventions
!     only writes variables needed for WW3 remap
!
!-----------------------------------------------------------------------

!-----------------------------------------------------------------------
!
!     input variables
!
!-----------------------------------------------------------------------

      character(SCRIP_charLength), intent(in) ::
     &            map_name     ! name for mapping 
     &,           interp_file  ! filename for remap data

!-----------------------------------------------------------------------
!
!     output variables
!
!-----------------------------------------------------------------------

      integer (SCRIP_i4), intent(out) ::
     &   errorCode              ! returned error code

!-----------------------------------------------------------------------
!
!     local variables
!
!-----------------------------------------------------------------------

      character(SCRIP_charLength) ::
     &  grid1_ctmp        ! character temp for grid1 names
     &, grid2_ctmp        ! character temp for grid2 names
     &, map_name_ctmp     ! character temp for name for mapping 
     &, interp_file_ctmp  ! character temp filename for remap data

      integer (SCRIP_i4) ::
     &  nc_file_id        ! netCDF file id
     &, itmp1             ! integer temp
     &, itmp2             ! integer temp
     &, itmp3             ! integer temp
     &, itmp4             ! integer temp

      character (21), parameter :: rtnName = 'write_remap_scrip_ww3'

!-----------------------------------------------------------------------
!
!     create netCDF file for mapping and define some global attributes
!
!-----------------------------------------------------------------------

      errorCode = SCRIP_Success
      map_name_ctmp = map_name
      interp_file_ctmp = trim(interp_file)

      itmp1 = len(interp_file_ctmp)
      itmp2 = len_trim(interp_file_ctmp)
      ncstat = nf90_create(interp_file_ctmp, NF90_CLOBBER, nc_file_id)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &                           'error creating remap file')) return

      !***
      !*** map name
      !***
      ncstat = nf90_put_att(nc_file_id, NF90_GLOBAL, 'title', map_name)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &                           'error writing remap name')) return

      !***
      !*** normalization option
      !***
      ncstat = nf90_put_att(nc_file_id, NF90_GLOBAL, 'normalization',
     &                      normalize_opt)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &                     'error writing normalize option')) return

      !***
      !*** map method
      !***
      ncstat = nf90_put_att(nc_file_id, NF90_GLOBAL, 'map_method',
     &                      map_method)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &                         'error writing remap method')) return

      !***
      !*** history
      !***
      ncstat = nf90_put_att(nc_file_id, NF90_GLOBAL, 'history',
     &                      history)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &                           'error writing history')) return

      !***
      !*** file convention
      !***
      convention = 'SCRIP'
      ncstat = nf90_put_att(nc_file_id, NF90_GLOBAL, 'conventions',
     &                                                convention)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &                  'error writing output convention')) return

      !***
      !*** source and destination grid names
      !***

      grid1_ctmp = 'source_grid'
      grid2_ctmp = 'dest_grid'

      ncstat = nf90_put_att(nc_file_id, NF90_GLOBAL, trim(grid1_ctmp),
     &                      grid1_name)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &                      'error writing source grid name')) return

      ncstat = nf90_put_att(nc_file_id, NF90_GLOBAL, trim(grid2_ctmp),
     &                      grid2_name)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &                   'error writing destination grid name')) return

!-----------------------------------------------------------------------
!
!     prepare netCDF dimension info
!
!-----------------------------------------------------------------------

      !***
      !*** define grid size dimensions
      !***

      itmp2 = grid2_size

      ncstat = nf90_def_dim(nc_file_id, 'dst_grid_size', itmp2, 
     &                      nc_dstgrdsize_id)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &            'error defining destination grid size')) return

      !***
      !*** define map size dimensions
      !***

      itmp1 = num_links_map1

      ncstat = nf90_def_dim(nc_file_id, 'num_links', 
     &                      itmp1, nc_numlinks_id)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &                           'error defining remap size')) return

      ncstat = nf90_def_dim(nc_file_id, 'num_wgts', 
     &                      num_wts, nc_numwgts_id)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &                    'error defining number of weights')) return

!-----------------------------------------------------------------------
!
!     define all arrays for netCDF descriptors
!
!-----------------------------------------------------------------------


      !***
      !*** define grid fraction arrays
      !***


      ncstat = nf90_def_var(nc_file_id, 'dst_grid_frac', 
     &                      NF90_DOUBLE, nc_dstgrdsize_id, 
     &                      nc_dstgrdfrac_id)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &         'error defining destination fraction')) return

      ncstat = nf90_put_att(nc_file_id, nc_dstgrdfrac_id, 
     &                      'units', 'unitless')
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &         'error writing destination frac units')) return

      !***
      !*** define mapping arrays
      !***

      ncstat = nf90_def_var(nc_file_id, 'src_address', 
     &                      NF90_INT, nc_numlinks_id, 
     &                      nc_srcadd_id)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &         'error defining source addresses')) return

      ncstat = nf90_def_var(nc_file_id, 'dst_address', 
     &                      NF90_INT, nc_numlinks_id, 
     &                      nc_dstadd_id)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &         'error defining destination addresses')) return

      nc_dims2_id(1) = nc_numwgts_id
      nc_dims2_id(2) = nc_numlinks_id

      ncstat = nf90_def_var(nc_file_id, 'remap_matrix', 
     &                      NF90_DOUBLE, nc_dims2_id, 
     &                      nc_rmpmatrix_id)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &         'error defining remapping weights')) return

      !***
      !*** end definition stage
      !***

      ncstat = nf90_enddef(nc_file_id)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &                         'error ending definition phase')) return


      !***
      !*** write variable arrays
      !***

      itmp4 = nc_dstgrdfrac_id

      ncstat = nf90_put_var(nc_file_id, itmp4, grid2_frac)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &         'error writing grid2 frac')) return

      ncstat = nf90_put_var(nc_file_id, nc_srcadd_id, 
     &                        grid1_add_map1)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &           'error writing source addresses')) return

      ncstat = nf90_put_var(nc_file_id, nc_dstadd_id, 
     &                        grid2_add_map1)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &           'error writing destination addresses')) return

      ncstat = nf90_put_var(nc_file_id, nc_rmpmatrix_id, wts_map1)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &           'error writing weights')) return


      ncstat = nf90_close(nc_file_id)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &                           'error closing file')) return


!-----------------------------------------------------------------------

      end subroutine write_remap_scrip_ww3

!***********************************************************************

      subroutine write_remap_csm(map_name, interp_file, direction,
     &                           errorCode)

!-----------------------------------------------------------------------
!
!     writes remap data to a netCDF file using NCAR-CSM conventions
!
!-----------------------------------------------------------------------

!-----------------------------------------------------------------------
!
!     input variables
!
!-----------------------------------------------------------------------

      character(SCRIP_charLength), intent(in) ::
     &            map_name     ! name for mapping 
     &,           interp_file  ! filename for remap data

      integer (SCRIP_i4), intent(in) ::
     &  direction              ! direction of map (1=grid1 to grid2
                               !                   2=grid2 to grid1)

!-----------------------------------------------------------------------
!
!     output variables
!
!-----------------------------------------------------------------------

      integer (SCRIP_i4), intent(out) ::
     &   errorCode              ! returned error code

!-----------------------------------------------------------------------
!
!     local variables
!
!-----------------------------------------------------------------------

      character(SCRIP_charLength) ::
     &  grid1_ctmp        ! character temp for grid1 names
     &, grid2_ctmp        ! character temp for grid2 names

      integer (SCRIP_i4) ::
     &  itmp1             ! integer temp
     &, itmp2             ! integer temp
     &, itmp3             ! integer temp
     &, itmp4             ! integer temp
     &, nc_numwgts1_id    ! extra netCDF id for additional weights
     &, nc_src_isize_id   ! extra netCDF id for ni_a
     &, nc_src_jsize_id   ! extra netCDF id for nj_a
     &, nc_dst_isize_id   ! extra netCDF id for ni_b
     &, nc_dst_jsize_id   ! extra netCDF id for nj_b
     &, nc_rmpmatrix2_id  ! extra netCDF id for high-order remap matrix

      real (SCRIP_r8), dimension(:),allocatable ::
     &  wts1              ! CSM wants single array for 1st-order wts

      real (SCRIP_r8), dimension(:,:),allocatable ::
     &  wts2              ! write remaining weights in different array

      character (15), parameter :: rtnName = 'write_remap_csm'

!-----------------------------------------------------------------------
!
!     create netCDF file for mapping and define some global attributes
!
!-----------------------------------------------------------------------

      errorCode = SCRIP_Success

      ncstat = nf90_create(interp_file, NF90_CLOBBER, nc_file_id)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &                           'error opening file')) return

      !***
      !*** map name
      !***
      ncstat = nf90_put_att(nc_file_id, NF90_GLOBAL, 'title', map_name)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &                           'error writing remap name')) return

      !***
      !*** normalization option
      !***
      ncstat = nf90_put_att(nc_file_id, NF90_GLOBAL, 'normalization',
     &                      normalize_opt)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &         'error writing normalization option')) return

      !***
      !*** map method
      !***
      ncstat = nf90_put_att(nc_file_id, NF90_GLOBAL, 'map_method',
     &                      map_method)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &         'error writing remap method')) return

      !***
      !*** history
      !***
      ncstat = nf90_put_att(nc_file_id, NF90_GLOBAL, 'history',
     &                      history)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &                           'error writing history')) return

      !***
      !*** file convention
      !***
      convention = 'NCAR-CSM'
      ncstat = nf90_put_att(nc_file_id, NF90_GLOBAL, 'conventions',
     &                      convention)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &         'error writing output convention')) return

      !***
      !*** source and destination grid names
      !***

      if (direction == 1) then
        grid1_ctmp = 'domain_a'
        grid2_ctmp = 'domain_b'
      else
        grid1_ctmp = 'domain_b'
        grid2_ctmp = 'domain_a'
      endif

      ncstat = nf90_put_att(nc_file_id, NF90_GLOBAL, trim(grid1_ctmp),
     &                      grid1_name)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &                           'error writing grid1 name')) return

      ncstat = nf90_put_att(nc_file_id, NF90_GLOBAL, trim(grid2_ctmp),
     &                      grid2_name)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &                           'error writing grid2 name')) return

!-----------------------------------------------------------------------
!
!     prepare netCDF dimension info
!
!-----------------------------------------------------------------------

      !***
      !*** define grid size dimensions
      !***

      if (direction == 1) then
        itmp1 = grid1_size
        itmp2 = grid2_size
      else
        itmp1 = grid2_size
        itmp2 = grid1_size
      endif

      ncstat = nf90_def_dim(nc_file_id, 'n_a', itmp1, nc_srcgrdsize_id)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &         'error defining source grid size')) return

      ncstat = nf90_def_dim(nc_file_id, 'n_b', itmp2, nc_dstgrdsize_id)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &         'error defining destination grid size')) return

      !***
      !*** define grid corner dimension
      !***

      if (direction == 1) then
        itmp1 = grid1_corners
        itmp2 = grid2_corners
      else
        itmp1 = grid2_corners
        itmp2 = grid1_corners
      endif

      ncstat = nf90_def_dim(nc_file_id, 'nv_a', itmp1, nc_srcgrdcorn_id)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &       'error defining number of corners on source grid')) return

      ncstat = nf90_def_dim(nc_file_id, 'nv_b', itmp2, nc_dstgrdcorn_id)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &  'error defining number of corners on destination grid')) return

      !***
      !*** define grid rank dimension
      !***

      if (direction == 1) then
        itmp1 = grid1_rank
        itmp2 = grid2_rank
      else
        itmp1 = grid2_rank
        itmp2 = grid1_rank
      endif

      ncstat = nf90_def_dim(nc_file_id, 'src_grid_rank', 
     &                      itmp1, nc_srcgrdrank_id)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &         'error defining source grid rank')) return

      ncstat = nf90_def_dim(nc_file_id, 'dst_grid_rank', 
     &                      itmp2, nc_dstgrdrank_id)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &         'error defining destination grid rank')) return

      !***
      !*** define first two dims as if 2-d cartesian domain
      !***

      if (direction == 1) then
        itmp1 = grid1_dims(1)
        if (grid1_rank > 1) then
          itmp2 = grid1_dims(2)
        else
          itmp2 = 0
        endif
        itmp3 = grid2_dims(1)
        if (grid2_rank > 1) then
          itmp4 = grid2_dims(2)
        else
          itmp4 = 0
        endif
      else
        itmp1 = grid2_dims(1)
        if (grid2_rank > 1) then
          itmp2 = grid2_dims(2)
        else
          itmp2 = 0
        endif
        itmp3 = grid1_dims(1)
        if (grid1_rank > 1) then
          itmp4 = grid1_dims(2)
        else
          itmp4 = 0
        endif
      endif

      ncstat = nf90_def_dim(nc_file_id, 'ni_a', itmp1, nc_src_isize_id)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &         'error defining source isize')) return

      ncstat = nf90_def_dim(nc_file_id, 'nj_a', itmp2, nc_src_jsize_id)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &         'error defining source jsize')) return

      ncstat = nf90_def_dim(nc_file_id, 'ni_b', itmp3, nc_dst_isize_id)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &         'error defining destination isize')) return

      ncstat = nf90_def_dim(nc_file_id, 'nj_b', itmp4, nc_dst_jsize_id)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &         'error defining destination jsize')) return

      !***
      !*** define map size dimensions
      !***

      if (direction == 1) then
        itmp1 = num_links_map1
      else
        itmp1 = num_links_map2
      endif

      ncstat = nf90_def_dim(nc_file_id, 'n_s', itmp1, nc_numlinks_id)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &         'error defining remap size')) return

      ncstat = nf90_def_dim(nc_file_id, 'num_wgts', 
     &                     num_wts, nc_numwgts_id)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &         'error defining number of weights')) return

      if (num_wts > 1) then
        ncstat = nf90_def_dim(nc_file_id, 'num_wgts1', 
     &                       num_wts-1, nc_numwgts1_id)
        if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &           'error defining number of weights1')) return
      endif

      !***
      !*** define grid dimensions
      !***

      ncstat = nf90_def_var(nc_file_id, 'src_grid_dims', NF90_INT,
     &                      nc_srcgrdrank_id, nc_srcgrddims_id)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &         'error defining source grid dims')) return

      ncstat = nf90_def_var(nc_file_id, 'dst_grid_dims', NF90_INT,
     &                      nc_dstgrdrank_id, nc_dstgrddims_id)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &         'error defining destination grid dims')) return

!-----------------------------------------------------------------------
!
!     define all arrays for netCDF descriptors
!
!-----------------------------------------------------------------------

      !***
      !*** define grid center latitude array
      !***

      ncstat = nf90_def_var(nc_file_id, 'yc_a',
     &                      NF90_DOUBLE, nc_srcgrdsize_id, 
     &                      nc_srcgrdcntrlat_id)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &         'error defining source grid center lats')) return

      ncstat = nf90_def_var(nc_file_id, 'yc_b', 
     &                      NF90_DOUBLE, nc_dstgrdsize_id, 
     &                      nc_dstgrdcntrlat_id)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &         'error defining destination grid center lats')) return

      !***
      !*** define grid center longitude array
      !***

      ncstat = nf90_def_var(nc_file_id, 'xc_a', 
     &                      NF90_DOUBLE, nc_srcgrdsize_id, 
     &                      nc_srcgrdcntrlon_id)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &         'error defining source grid center lons')) return

      ncstat = nf90_def_var(nc_file_id, 'xc_b', 
     &                      NF90_DOUBLE, nc_dstgrdsize_id, 
     &                      nc_dstgrdcntrlon_id)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &         'error defining destination grid center lons')) return

      !***
      !*** define grid corner lat/lon arrays
      !***

      nc_dims2_id(1) = nc_srcgrdcorn_id
      nc_dims2_id(2) = nc_srcgrdsize_id

      ncstat = nf90_def_var(nc_file_id, 'yv_a', 
     &                      NF90_DOUBLE, nc_dims2_id, 
     &                      nc_srcgrdcrnrlat_id)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &         'error defining source grid corner lats')) return

      ncstat = nf90_def_var(nc_file_id, 'xv_a', 
     &                      NF90_DOUBLE, nc_dims2_id, 
     &                      nc_srcgrdcrnrlon_id)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &         'error defining source grid corner lons')) return

      nc_dims2_id(1) = nc_dstgrdcorn_id
      nc_dims2_id(2) = nc_dstgrdsize_id

      ncstat = nf90_def_var(nc_file_id, 'yv_b', 
     &                      NF90_DOUBLE, nc_dims2_id, 
     &                      nc_dstgrdcrnrlat_id)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &         'error defining destination grid corner lats')) return

      ncstat = nf90_def_var(nc_file_id, 'xv_b', 
     &                      NF90_DOUBLE, nc_dims2_id, 
     &                      nc_dstgrdcrnrlon_id)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &         'error defining destination grid corner lons')) return

      !***
      !*** CSM wants all in degrees
      !***

      grid1_units = 'degrees'
      grid2_units = 'degrees'

      if (direction == 1) then
        grid1_ctmp = grid1_units
        grid2_ctmp = grid2_units
      else
        grid1_ctmp = grid2_units
        grid2_ctmp = grid1_units
      endif

      ncstat = nf90_put_att(nc_file_id, nc_srcgrdcntrlat_id, 
     &                      'units', grid1_ctmp)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &         'error writing grid units')) return

      ncstat = nf90_put_att(nc_file_id, nc_dstgrdcntrlat_id, 
     &                      'units', grid2_ctmp)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &         'error writing grid units')) return

      ncstat = nf90_put_att(nc_file_id, nc_srcgrdcntrlon_id, 
     &                      'units', grid1_ctmp)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &         'error writing grid units')) return

      ncstat = nf90_put_att(nc_file_id, nc_dstgrdcntrlon_id, 
     &                      'units', grid2_ctmp)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &         'error writing grid units')) return

      ncstat = nf90_put_att(nc_file_id, nc_srcgrdcrnrlat_id, 
     &                      'units', grid1_ctmp)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &         'error writing grid units')) return

      ncstat = nf90_put_att(nc_file_id, nc_srcgrdcrnrlon_id, 
     &                      'units', grid1_ctmp)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &         'error writing grid units')) return

      ncstat = nf90_put_att(nc_file_id, nc_dstgrdcrnrlat_id, 
     &                      'units', grid2_ctmp)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &         'error writing grid units')) return

      ncstat = nf90_put_att(nc_file_id, nc_dstgrdcrnrlon_id, 
     &                      'units', grid2_ctmp)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &         'error writing grid units')) return

      !***
      !*** define grid mask
      !***

      ncstat = nf90_def_var(nc_file_id, 'mask_a', NF90_INT,
     &                      nc_srcgrdsize_id, nc_srcgrdimask_id)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &         'error defining source grid mask')) return

      ncstat = nf90_put_att(nc_file_id, nc_srcgrdimask_id, 
     &                      'units', 'unitless')
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &         'error writing source mask units')) return

      ncstat = nf90_def_var(nc_file_id, 'mask_b', NF90_INT,
     &                      nc_dstgrdsize_id, nc_dstgrdimask_id)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &         'error defining destination grid mask')) return

      ncstat = nf90_put_att(nc_file_id, nc_dstgrdimask_id, 
     &                      'units', 'unitless')
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &         'error writing destination mask units')) return

      !***
      !*** define grid area arrays
      !***

      ncstat = nf90_def_var(nc_file_id, 'area_a', 
     &                      NF90_DOUBLE, nc_srcgrdsize_id, 
     &                      nc_srcgrdarea_id)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &         'error defining source grid area')) return

      ncstat = nf90_put_att(nc_file_id, nc_srcgrdarea_id, 
     &                      'units', 'square radians')
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &         'error defining source area units')) return

      ncstat = nf90_def_var(nc_file_id, 'area_b', 
     &                      NF90_DOUBLE, nc_dstgrdsize_id, 
     &                      nc_dstgrdarea_id)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &         'error defining destination grid area')) return

      ncstat = nf90_put_att(nc_file_id, nc_dstgrdarea_id, 
     &                      'units', 'square radians')
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &         'error defining destination area units')) return

      !***
      !*** define grid fraction arrays
      !***

      ncstat = nf90_def_var(nc_file_id, 'frac_a', 
     &                      NF90_DOUBLE, nc_srcgrdsize_id, 
     &                      nc_srcgrdfrac_id)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &         'error defining source grid frac')) return

      ncstat = nf90_put_att(nc_file_id, nc_srcgrdfrac_id, 
     &                      'units', 'unitless')
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &         'error defining source frac units')) return

      ncstat = nf90_def_var(nc_file_id, 'frac_b', 
     &                      NF90_DOUBLE, nc_dstgrdsize_id, 
     &                      nc_dstgrdfrac_id)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &         'error defining destination grid frac')) return

      ncstat = nf90_put_att(nc_file_id, nc_dstgrdfrac_id, 
     &                      'units', 'unitless')
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &         'error defining destination frac units')) return

      !***
      !*** define mapping arrays
      !***

      ncstat = nf90_def_var(nc_file_id, 'col', 
     &                      NF90_INT, nc_numlinks_id, 
     &                      nc_srcadd_id)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &         'error defining source addresses')) return

      ncstat = nf90_def_var(nc_file_id, 'row', 
     &                      NF90_INT, nc_numlinks_id, 
     &                      nc_dstadd_id)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &         'error defining destination addresses')) return

      ncstat = nf90_def_var(nc_file_id, 'S', 
     &                      NF90_DOUBLE, nc_numlinks_id, 
     &                      nc_rmpmatrix_id)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &                      'error defining weights')) return

      if (num_wts > 1) then
        nc_dims2_id(1) = nc_numwgts1_id
        nc_dims2_id(2) = nc_numlinks_id

        ncstat = nf90_def_var(nc_file_id, 'S2', 
     &                     NF90_DOUBLE, nc_dims2_id, 
     &                     nc_rmpmatrix2_id)
        if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &                     'error defining weights2')) return
      endif

      !***
      !*** end definition stage
      !***

      ncstat = nf90_enddef(nc_file_id)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &                       'error ending definition phase')) return

!-----------------------------------------------------------------------
!
!     compute integer masks
!
!-----------------------------------------------------------------------

      if (direction == 1) then
        allocate (src_mask_int(grid1_size),
     &            dst_mask_int(grid2_size))

        where (grid2_mask)
          dst_mask_int = 1
        elsewhere
          dst_mask_int = 0
        endwhere

        where (grid1_mask)
          src_mask_int = 1
        elsewhere
          src_mask_int = 0
        endwhere
      else
        allocate (src_mask_int(grid2_size),
     &            dst_mask_int(grid1_size))

        where (grid1_mask)
          dst_mask_int = 1
        elsewhere
          dst_mask_int = 0
        endwhere

        where (grid2_mask)
          src_mask_int = 1
        elsewhere
          src_mask_int = 0
        endwhere
      endif

!-----------------------------------------------------------------------
!
!     change units of lat/lon coordinates if input units different
!     from radians. if this is the second mapping, the conversion has
!     alread been done.
!
!-----------------------------------------------------------------------

      if (grid1_units(1:7) == 'degrees' .and. direction == 1) then
        grid1_center_lat = grid1_center_lat/deg2rad
        grid1_center_lon = grid1_center_lon/deg2rad
        grid1_corner_lat = grid1_corner_lat/deg2rad
        grid1_corner_lon = grid1_corner_lon/deg2rad
      endif

      if (grid2_units(1:7) == 'degrees' .and. direction == 1) then
        grid2_center_lat = grid2_center_lat/deg2rad
        grid2_center_lon = grid2_center_lon/deg2rad
        grid2_corner_lat = grid2_corner_lat/deg2rad
        grid2_corner_lon = grid2_corner_lon/deg2rad
      endif

!-----------------------------------------------------------------------
!
!     write mapping data
!
!-----------------------------------------------------------------------

      if (direction == 1) then
        itmp1 = nc_srcgrddims_id
        itmp2 = nc_dstgrddims_id
      else
        itmp2 = nc_srcgrddims_id
        itmp1 = nc_dstgrddims_id
      endif

      ncstat = nf90_put_var(nc_file_id, itmp1, grid1_dims)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &         'error writing grid1 dims')) return

      ncstat = nf90_put_var(nc_file_id, itmp2, grid2_dims)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &         'error writing grid2 dims')) return

      ncstat = nf90_put_var(nc_file_id, nc_srcgrdimask_id, 
     &                      src_mask_int)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &         'error writing source grid mask')) return

      ncstat = nf90_put_var(nc_file_id, nc_dstgrdimask_id,
     &                      dst_mask_int)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &         'error writing destination grid mask')) return

      deallocate(src_mask_int, dst_mask_int)

      if (direction == 1) then
        itmp1 = nc_srcgrdcntrlat_id
        itmp2 = nc_srcgrdcntrlon_id
        itmp3 = nc_srcgrdcrnrlat_id
        itmp4 = nc_srcgrdcrnrlon_id
      else
        itmp1 = nc_dstgrdcntrlat_id
        itmp2 = nc_dstgrdcntrlon_id
        itmp3 = nc_dstgrdcrnrlat_id
        itmp4 = nc_dstgrdcrnrlon_id
      endif

      ncstat = nf90_put_var(nc_file_id, itmp1, grid1_center_lat)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &         'error writing grid1 center lats')) return

      ncstat = nf90_put_var(nc_file_id, itmp2, grid1_center_lon)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &         'error writing grid1 center lons')) return

      ncstat = nf90_put_var(nc_file_id, itmp3, grid1_corner_lat)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &         'error writing grid1 corner lats')) return

      ncstat = nf90_put_var(nc_file_id, itmp4, grid1_corner_lon)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &         'error writing grid1 corner lons')) return

      if (direction == 1) then
        itmp1 = nc_dstgrdcntrlat_id
        itmp2 = nc_dstgrdcntrlon_id
        itmp3 = nc_dstgrdcrnrlat_id
        itmp4 = nc_dstgrdcrnrlon_id
      else
        itmp1 = nc_srcgrdcntrlat_id
        itmp2 = nc_srcgrdcntrlon_id
        itmp3 = nc_srcgrdcrnrlat_id
        itmp4 = nc_srcgrdcrnrlon_id
      endif

      ncstat = nf90_put_var(nc_file_id, itmp1, grid2_center_lat)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &         'error writing grid2 center lats')) return

      ncstat = nf90_put_var(nc_file_id, itmp2, grid2_center_lon)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &         'error writing grid2 center lons')) return

      ncstat = nf90_put_var(nc_file_id, itmp3, grid2_corner_lat)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &         'error writing grid2 corner lats')) return

      ncstat = nf90_put_var(nc_file_id, itmp4, grid2_corner_lon)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &         'error writing grid2 corner lons')) return

      if (direction == 1) then
        itmp1 = nc_srcgrdarea_id
        itmp2 = nc_srcgrdfrac_id
        itmp3 = nc_dstgrdarea_id
        itmp4 = nc_dstgrdfrac_id
      else
        itmp1 = nc_dstgrdarea_id
        itmp2 = nc_dstgrdfrac_id
        itmp3 = nc_srcgrdarea_id
        itmp4 = nc_srcgrdfrac_id
      endif

      if (luse_grid1_area) then
        ncstat = nf90_put_var(nc_file_id, itmp1, grid1_area_in)
      else
        ncstat = nf90_put_var(nc_file_id, itmp1, grid1_area)
      endif
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &         'error writing grid1 area')) return

      ncstat = nf90_put_var(nc_file_id, itmp2, grid1_frac)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &         'error writing grid1 frac')) return

      if (luse_grid2_area) then
        ncstat = nf90_put_var(nc_file_id, itmp3, grid2_area)
      else
        ncstat = nf90_put_var(nc_file_id, itmp3, grid2_area)
      endif
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &         'error writing grid2 area')) return

      ncstat = nf90_put_var(nc_file_id, itmp4, grid2_frac)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &         'error writing grid2 frac')) return

      if (direction == 1) then
        ncstat = nf90_put_var(nc_file_id, nc_srcadd_id, 
     &                        grid1_add_map1)
        if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &           'error writing source addresses')) return

        ncstat = nf90_put_var(nc_file_id, nc_dstadd_id, 
     &                        grid2_add_map1)
        if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &           'error writing destination addresses')) return

        if (num_wts == 1) then
          ncstat = nf90_put_var(nc_file_id, nc_rmpmatrix_id, 
     &                               wts_map1(1,:))
          if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &             'error writing weights')) return
        else
          allocate(wts1(num_links_map1),wts2(num_wts-1,num_links_map1))

          wts1 = wts_map1(1,:)
          wts2 = wts_map1(2:,:)

          ncstat = nf90_put_var(nc_file_id, nc_rmpmatrix_id, wts1)
          if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &             'error writing weights1')) return
          ncstat = nf90_put_var(nc_file_id, nc_rmpmatrix2_id, wts2)
          if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &             'error writing weights2')) return
          deallocate(wts1,wts2)
        endif
      else
        ncstat = nf90_put_var(nc_file_id, nc_srcadd_id, 
     &                        grid2_add_map2)
        if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &           'error writing source addresses')) return

        ncstat = nf90_put_var(nc_file_id, nc_dstadd_id, 
     &                        grid1_add_map2)
        if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &           'error writing destination addresses')) return

        if (num_wts == 1) then
          ncstat = nf90_put_var(nc_file_id, nc_rmpmatrix_id, 
     &                          wts_map2(1,:))
          if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &             'error writing weights')) return
        else
          allocate(wts1(num_links_map2),wts2(num_wts-1,num_links_map2))

          wts1 = wts_map2(1,:)
          wts2 = wts_map2(2:,:)

          ncstat = nf90_put_var(nc_file_id, nc_rmpmatrix_id, wts1)
          if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &             'error writing weights1')) return
          ncstat = nf90_put_var(nc_file_id, nc_rmpmatrix2_id, wts2)
          if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &             'error writing weights2')) return
          deallocate(wts1,wts2)
        endif
      endif

      ncstat = nf90_close(nc_file_id)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName,
     &         'error closing file')) return

!-----------------------------------------------------------------------

      end subroutine write_remap_csm

!***********************************************************************

      subroutine sort_add(add1, add2, weights)

!-----------------------------------------------------------------------
!
!     this routine sorts address and weight arrays based on the
!     destination address with the source address as a secondary
!     sorting criterion.  the method is a standard heap sort.
!
!-----------------------------------------------------------------------

      implicit none

!-----------------------------------------------------------------------
!
!     Input and Output arrays
!
!-----------------------------------------------------------------------

      integer (SCRIP_i4), intent(inout), dimension(:) ::
     &        add1,       ! destination address array (num_links)
     &        add2        ! source      address array

      real (SCRIP_r8), intent(inout), dimension(:,:) ::
     &        weights     ! remapping weights (num_wts, num_links)

!-----------------------------------------------------------------------
!
!     local variables
!
!-----------------------------------------------------------------------

      integer (SCRIP_i4) ::
     &          num_links,          ! num of links for this mapping
     &          num_wts,            ! num of weights for this mapping
     &          add1_tmp, add2_tmp, ! temp for addresses during swap
     &          lvl, final_lvl,     ! level indexes for heap sort levels
     &          chk_lvl1, chk_lvl2, max_lvl

      real (SCRIP_r8), dimension(SIZE(weights,DIM=1)) ::
     &          wgttmp              ! temp for holding wts during swap

!-----------------------------------------------------------------------
!
!     determine total number of links to sort and number of weights
!
!-----------------------------------------------------------------------

      num_links = SIZE(add1)
      num_wts   = SIZE(weights, DIM=1)

!-----------------------------------------------------------------------
!
!     start at the lowest level (N/2) of the tree and sift lower 
!     values to the bottom of the tree, promoting the larger numbers
!
!-----------------------------------------------------------------------

      do lvl=num_links/2,1,-1

        final_lvl = lvl
        add1_tmp = add1(lvl)
        add2_tmp = add2(lvl)
        wgttmp(:) = weights(:,lvl)

        !***
        !*** loop until proper level is found for this link, or reach
        !*** bottom
        !***

        sift_loop1: do

          !***
          !*** find the largest of the two daughters
          !***

          chk_lvl1 = 2*final_lvl
          chk_lvl2 = 2*final_lvl+1
          if (chk_lvl1 .EQ. num_links) chk_lvl2 = chk_lvl1

          if ((add1(chk_lvl1) >  add1(chk_lvl2)) .OR.
     &       ((add1(chk_lvl1) == add1(chk_lvl2)) .AND.
     &        (add2(chk_lvl1) >  add2(chk_lvl2)))) then
            max_lvl = chk_lvl1
          else 
            max_lvl = chk_lvl2
          endif

          !***
          !*** if the parent is greater than both daughters,
          !*** the correct level has been found
          !***

          if ((add1_tmp .GT. add1(max_lvl)) .OR.
     &       ((add1_tmp .EQ. add1(max_lvl)) .AND.
     &        (add2_tmp .GT. add2(max_lvl)))) then
            add1(final_lvl) = add1_tmp
            add2(final_lvl) = add2_tmp
            weights(:,final_lvl) = wgttmp(:)
            exit sift_loop1

          !***
          !*** otherwise, promote the largest daughter and push
          !*** down one level in the tree.  if haven't reached
          !*** the end of the tree, repeat the process.  otherwise
          !*** store last values and exit the loop
          !***

          else 
            add1(final_lvl) = add1(max_lvl)
            add2(final_lvl) = add2(max_lvl)
            weights(:,final_lvl) = weights(:,max_lvl)

            final_lvl = max_lvl
            if (2*final_lvl > num_links) then
              add1(final_lvl) = add1_tmp
              add2(final_lvl) = add2_tmp
              weights(:,final_lvl) = wgttmp(:)
              exit sift_loop1
            endif
          endif
        end do sift_loop1
      end do

!-----------------------------------------------------------------------
!
!     now that the heap has been sorted, strip off the top (largest)
!     value and promote the values below
!
!-----------------------------------------------------------------------

      do lvl=num_links,3,-1

        !***
        !*** move the top value and insert it into the correct place
        !***

        add1_tmp = add1(lvl)
        add1(lvl) = add1(1)

        add2_tmp = add2(lvl)
        add2(lvl) = add2(1)

        wgttmp(:) = weights(:,lvl)
        weights(:,lvl) = weights(:,1)

        !***
        !*** as above this loop sifts the tmp values down until proper 
        !*** level is reached
        !***

        final_lvl = 1

        sift_loop2: do

          !***
          !*** find the largest of the two daughters
          !***

          chk_lvl1 = 2*final_lvl
          chk_lvl2 = 2*final_lvl+1
          if (chk_lvl2 >= lvl) chk_lvl2 = chk_lvl1

          if ((add1(chk_lvl1) >  add1(chk_lvl2)) .OR.
     &       ((add1(chk_lvl1) == add1(chk_lvl2)) .AND.
     &        (add2(chk_lvl1) >  add2(chk_lvl2)))) then
            max_lvl = chk_lvl1
          else 
            max_lvl = chk_lvl2
          endif

          !***
          !*** if the parent is greater than both daughters,
          !*** the correct level has been found
          !***

          if ((add1_tmp >  add1(max_lvl)) .OR.
     &       ((add1_tmp == add1(max_lvl)) .AND.
     &        (add2_tmp >  add2(max_lvl)))) then
            add1(final_lvl) = add1_tmp
            add2(final_lvl) = add2_tmp
            weights(:,final_lvl) = wgttmp(:)
            exit sift_loop2

          !***
          !*** otherwise, promote the largest daughter and push
          !*** down one level in the tree.  if haven't reached
          !*** the end of the tree, repeat the process.  otherwise
          !*** store last values and exit the loop
          !***

          else 
            add1(final_lvl) = add1(max_lvl)
            add2(final_lvl) = add2(max_lvl)
            weights(:,final_lvl) = weights(:,max_lvl)

            final_lvl = max_lvl
            if (2*final_lvl >= lvl) then
              add1(final_lvl) = add1_tmp
              add2(final_lvl) = add2_tmp
              weights(:,final_lvl) = wgttmp(:)
              exit sift_loop2
            endif
          endif
        end do sift_loop2
      end do

      !***
      !*** swap the last two entries
      !***


      add1_tmp = add1(2)
      add1(2)  = add1(1)
      add1(1)  = add1_tmp

      add2_tmp = add2(2)
      add2(2)  = add2(1)
      add2(1)  = add2_tmp

      wgttmp (:)   = weights(:,2)
      weights(:,2) = weights(:,1)
      weights(:,1) = wgttmp (:)

!-----------------------------------------------------------------------

      end subroutine sort_add

!***********************************************************************

      end module scrip_remap_write

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||

 module SCRIP_NetCDFMod

!BOP
! !MODULE: SCRIP_NetCDFMod
!
! !DESCRIPTION:
! This module contains netCDF error handling functions and the
! use of the netCDF module for all netCDF functions.
!
! !REVISION HISTORY:
! SVN:$Id: $
!
! !USES:

   use SCRIP_KindsMod
   use SCRIP_ErrorMod
   use netcdf

   implicit none
   private
   save

! !DEFINED PARAMETERS:

! !PUBLIC MEMBER FUNCTIONS:

   public :: SCRIP_NetcdfErrorCheck

!EOP
!BOC
!EOC
!***********************************************************************

 contains

!***********************************************************************
!BOP
! !IROUTINE: SCRIP_NetcdfErrorCheck
! !INTERFACE:

   function SCRIP_NetcdfErrorCheck(netcdfStat, errorCode, rtnName, &
                                   errorMsg)

! !DESCRIPTION:
! This routine checks netCDF status flags from netCDF routines.
! On error, it adds an error message to the error log and returns
! both a true value to the calling routines as well as setting the
! error code to fail. It is used in the same manner is the
! SCRIP\_ErrorCheck function.
!
! !REVISION HISTORY:
! same as module

! !OUTPUT PARAMETERS:

   logical (SCRIP_logical) :: &
      SCRIP_NetcdfErrorCheck

   integer (SCRIP_i4), intent(out) :: &
      errorCode ! returned SCRIP error flag

! !INPUT PARAMETERS:

   integer (SCRIP_i4), intent(in) :: &
      netcdfStat ! status flag from netCDF call

   character (*), intent(in) :: &
      rtnName, &! name of calling routine
      errorMsg ! error message for logging

!EOP
!BOC
!-----------------------------------------------------------------------
!
! local variables
!
!-----------------------------------------------------------------------

   character (SCRIP_charLength) :: &
      ncErrMsg ! netCDF error message

!-----------------------------------------------------------------------
!
! if no error, return false and a successful errorCode
!
!-----------------------------------------------------------------------

   if (netcdfStat == NF90_NOERR) then
      errorCode = SCRIP_Success
      SCRIP_NetcdfErrorCheck = .false.

!-----------------------------------------------------------------------
!
! if an error is detected, return a true value and call the SCRIP
! error handlers to log the error. Log both the netCDF error msg
! as well as the error passed by the calling routine.
!
!-----------------------------------------------------------------------

   else

      SCRIP_NetcdfErrorCheck = .true.
      ncErrMsg = nf90_strerror(netcdfStat)
      call SCRIP_ErrorSet(errorCode, rtnName, ncErrMsg)
      call SCRIP_ErrorSet(errorCode, rtnName, errorMsg)

   endif

!-----------------------------------------------------------------------
!EOC

 end function SCRIP_NetcdfErrorCheck

!***********************************************************************

 end module SCRIP_NetCDFMod

!|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
!     This module defines common constants used in many routines.
!
!-----------------------------------------------------------------------
!
!     CVS:$Id: constants.f,v 1.2 2000/04/19 21:56:25 pwjones Exp $
!
!     Copyright (c) 1997, 1998 the Regents of the University of 
!       California.
!
!     This software and ancillary information (herein called software) 
!     called SCRIP is made available under the terms described here.  
!     The software has been approved for release with associated 
!     LA-CC Number 98-45.
!
!     Unless otherwise indicated, this software has been authored
!     by an employee or employees of the University of California,
!     operator of the Los Alamos National Laboratory under Contract
!     No. W-7405-ENG-36 with the U.S. Department of Energy.  The U.S.
!     Government has rights to use, reproduce, and distribute this
!     software.  The public may copy and use this software without
!     charge, provided that this Notice and any statement of authorship
!     are reproduced on all copies.  Neither the Government nor the
!     University makes any warranty, express or implied, or assumes
!     any liability or responsibility for the use of this software.
!
!     If software is modified to produce derivative works, such modified
!     software should be clearly marked, so as not to confuse it with 
!     the version available from Los Alamos National Laboratory.
!
!     This code has been modified from the version available from 
!     Los Alamos National Laboratory, for the purpose of running it
!     within WW3.
!
!***********************************************************************

      module SCRIP_constants

!-----------------------------------------------------------------------

      use SCRIP_KindsMod  ! defines common data types

      implicit none

      save

!-----------------------------------------------------------------------

      real (kind = SCRIP_r8), parameter :: 
     &                        zero   = 0.0_SCRIP_r8,
     &                        one    = 1.0_SCRIP_r8,
     &                        two    = 2.0_SCRIP_r8,
     &                        three  = 3.0_SCRIP_r8,
     &                        four   = 4.0_SCRIP_r8,
     &                        five   = 5.0_SCRIP_r8,
     &                        half   = 0.5_SCRIP_r8,
     &                        quart  = 0.25_SCRIP_r8,
     &                        bignum = 1.e+20_SCRIP_r8,
     &                        tiny   = 1.e-14_SCRIP_r8,
     &                        pi     = 3.14159265359_SCRIP_r8,
     &                        pi2    = two*pi,
     &                        pih    = half*pi

!-----------------------------------------------------------------------

      end module SCRIP_constants

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

C/ ------------------------------------------------------------------- /
      PROGRAM W3SPLT
C/
C/                  +-----------------------------------+
C/                  | WAVEWATCH III           NOAA/NCEP |
C/                  |           H. L. Tolman            |
C/                  |                        FORTRAN 77 |
C/                  | Last update :         19-May-1999 |
C/                  +-----------------------------------+
C/
C  1. Purpose :
C
C     Read a WAVEWATCH III version 1.17 point output data file and
C     produces a table of mean parameters for all individual wave
C     systems.
C
C  2. Method :
C
C     Partitioning as devised by Gerling and similar to used in
C     WAM model. From standard input the following data is read :
C
C        name of output point to be considered.
C        name of run of model.
C        name of input file.
C        logical to indentify FORMATTED input file.
C        name of output file.
C
C     All strings are read as characters, therefore no quotes are
C     needed.
C
C  3. Parameters :
C
C     Parameter statements
C     ----------------------------------------------------------------
C       NFR     Int.   Number of frequencies in spectrum.
C       NTH     Int.   Number of directions in spectrum.
C       NPMAX   Int.   Maximum number of peaks to be looked for.
C       NPTAB   Int.   Number of columns in table.
C       HSMIN   Real   Minimum wave height for includion in table.
C       HSDROP  Real   Minimum wave high for system to be considered
C                      as separate wave system.
C       DHSMAX  Real   Max. change in Hs for system to be considered
C                      related to previous time.
C       DTPAX   Real   Id. Tp.
C       DDMMAX  Real   Id. Dm.
C       DDWMAX  Real   Maximum differences in wind and wave direction
C                      for marking of system as under the influence
C                      of the local wind,
C       AGEMIN  Real   Id. wave age.
C     ----------------------------------------------------------------
C
C  4. Subroutines used :
C
C       MPARS   Calculate mean parameters
C       FNDPRT  Get mask for partition.
C       WAVNU2  Solve dispersion relation.
C
C  5. Called by :
C
C     None, main program,
C
C  6. Error messages :
C
C     See "Error escape locations" at end of code.
C
C  7. Remarks :
C
C  8. Structure :
C
C     See source code.
C
C 10. Source code :
C
C/ ------------------------------------------------------------------- /
C/ Parameter statements
C/
      INTEGER         NFR, NTH, NPMAX, NPTAB
      REAL            XFR, HSMIN, HSDROP,
     &                DHSMAX, DTPAX, DDMMAX, DDWMAX, AGEMIN
*
      PARAMETER     ( NFR    =  25    )
      PARAMETER     ( NTH    =  24    )
      PARAMETER     ( NPMAX  =  20    )
      PARAMETER     ( NPTAB  =   6    )
      PARAMETER     ( XFR    =   1.1  )
      PARAMETER     ( HSMIN  =   0.15 )
      PARAMETER     ( HSDROP =   0.05 )
      PARAMETER     ( DHSMAX =   1.5  )
      PARAMETER     ( DTPMAX =   1.5  )
      PARAMETER     ( DDMMAX =  15.   )
      PARAMETER     ( DDWMAX =  30.   )
      PARAMETER     ( AGEMIN =   0.8  )
*
      INTEGER         NDSI, NDSO, IERR, NFRF, NTHF, IFR, ITH
      INTEGER         NPNTS, IP, TIME(2), IREAD
      INTEGER         IFL, IFH, ITHL, ITHH
      INTEGER         NPEAK, NFRP(NPMAX), NTHP(NPMAX), IPNOW, IOUT, ITAB
      INTEGER         NZERO
      REAL            PI, RADE, FR(NFR), TH(NTH), DTH, DFR(NFR),
     &                TAILF, SPEC(NFR,NTH), W1(NFR,NTH), W2(NFR,NTH),
     &                SP1D(NFR), HS, TP, DM, XFRV, STMAX, HMAX
      REAL            HSTOT, HSP(NPMAX), TPP(NPMAX), DMP(NPMAX)
      REAL            HST(NPMAX,2), TPT(NPMAX,2), DMT(NPMAX,2)
      REAL            D, UA, UD, UABS, UDIR, DELDW, DELHS, DELTP, DELDM
      REAL            AFR, WN, CG, AGE, Y, X
      LOGICAL         FORMI, DATA, FLAG(NPMAX), HEADER
      CHARACTER       POINT*10, PID*10, FNAMEI*40, FNAMEO*40, IDSTR*21
      CHARACTER       MODEL*40, RUN*20, GNAME*30, IDLAT*1, IDLON*1
      CHARACTER*129   BLANK, TAIL, STRING
      CHARACTER*15    PART
C/
C/ ------------------------------------------------------------------- /
C/
*
* 1.  Initializations ------------------------------------------------ *
* 1.a Constants etc.
*
      NDSI   = 10
      NDSO   = 50
*
      PI     = 4. * ATAN(1.)
      RADE   = 180. / PI
      XFRV   = XFR
*
      IREAD  = 0
*
      TAIL (  1: 40) = '+-------+-----------+-----------------+-'
      TAIL ( 41: 80) = '----------------+-----------------+-----'
      TAIL ( 81:120) = '------------+-----------------+---------'
      TAIL (120:129) = '---------+'
      BLANK(  1: 40) = '| nn nn |      nn   |                 | '
      BLANK( 41: 80) = '                |                 |     '
      BLANK( 81:120) = '            |                 |         '
      BLANK(120:129) = '         |'
      STRING       = BLANK
*
      DO 100, IP=1, NPTAB
        HST(IP,1) = -1.
        TPT(IP,1) = -1.
        DMT(IP,1) = -1.
  100   CONTINUE
*
* 1.b Initial I/O
*
      WRITE (*,900)
      READ (*,'(A)') POINT
      READ (*,'(A)') RUN
      WRITE (*,901) POINT, RUN
      READ (*,'(A)') FNAMEI
      READ (*,*) FORMI
      WRITE (*,902) FNAMEI, FORMI
      READ (*,'(A)') FNAMEO
      WRITE (*,903) FNAMEO
*
* 1.c Open input file and process header
*
      IF ( FORMI ) THEN
          OPEN (NDSI,FILE=FNAMEI,STATUS='OLD',ERR=800,IOSTAT=IERR)
        ELSE
          OPEN (NDSI,FILE=FNAMEI,STATUS='OLD',
     &               FORM='UNFORMATTED',ERR=800,IOSTAT=IERR)
        ENDIF
      WRITE (*,904)
*
      IF ( FORMI ) THEN
          READ (NDSI,*,END=801,ERR=802,IOSTAT=IERR)
     &          IDSTR, NFRF, NTHF, NPNTS, GNAME
        ELSE
          READ (NDSI , END=801,ERR=802,IOSTAT=IERR)
     &          IDSTR, NFRF, NTHF, NPNTS, GNAME
        ENDIF
*
      IF ( IDSTR .NE. 'WAVEWATCH III SPECTRA' ) GOTO 803
      IF ( NFR.NE.NFRF .OR. NTH.NE.NTHF ) GOTO 804
      WRITE (*,905)
*
      IF ( FORMI ) THEN
          READ (NDSI,*,END=801,ERR=802,IOSTAT=IERR) FR
        ELSE
          READ (NDSI , END=801,ERR=802,IOSTAT=IERR) FR
        ENDIF
      WRITE (*,906)
*
      IF ( FORMI ) THEN
          READ (NDSI,*,END=801,ERR=802,IOSTAT=IERR) TH
        ELSE
          READ (NDSI , END=801,ERR=802,IOSTAT=IERR) TH
        ENDIF
      WRITE (*,907)
*
      DTH    = 2. * PI / REAL(NTH)
      TAILF  = 0.25 * FR(NFR)
*
      DO 110, IFR=1, NFR
        DFR(IFR) = 0.5 * (XFR-1./XFR) * FR(IFR)
  110   CONTINUE
      DFR(NFR) = 0.5 * DFR(NFR)
      WRITE (*,908)
*
* 1.d Open output file and process header
*
      OPEN (NDSO,FILE=FNAMEO,ERR=810,IOSTAT=IERR)
      WRITE (*,909)
      HEADER = .TRUE.
*
* === LOOP OVER DATA ================================================= *
*
  200 CONTINUE
*
* 2.  Read next data ------------------------------------------------- *
*
      IF ( FORMI ) THEN
          READ (NDSI,*,END=888,ERR=802,IOSTAT=IERR) TIME
        ELSE
          READ (NDSI , END=888,ERR=802,IOSTAT=IERR) TIME
        ENDIF
*
      DATA   = .FALSE.
      DO 210, IP=1, NPNTS
        IF ( FORMI ) THEN
            READ (NDSI,*,END=801,ERR=802,IOSTAT=IERR)
     &                                     PID, Y, X, D, UA, UD
          ELSE
            READ (NDSI , END=801,ERR=802,IOSTAT=IERR)
     &                                     PID, Y, X, D, UA, UD
          ENDIF
        IF ( PID .EQ. POINT ) THEN
            IF ( FORMI ) THEN
                READ (NDSI,*,END=801,ERR=802,IOSTAT=IERR) SPEC
              ELSE
                READ (NDSI , END=801,ERR=802,IOSTAT=IERR) SPEC
              ENDIF
            DATA   = .TRUE.
            UABS   = UA
            UDIR   = MOD( UD+180., 360. )
          ELSE
            IF ( FORMI ) THEN
                READ (NDSI,*,END=801,ERR=802,IOSTAT=IERR) W1
              ELSE
                READ (NDSI , END=801,ERR=802,IOSTAT=IERR) W1
              ENDIF
          ENDIF
  210   CONTINUE
*
      IF ( .NOT. DATA ) GOTO 805
      IREAD  = IREAD + 1
*
      IF ( HEADER ) THEN
          X      = MOD ( X+720. , 360. )
          IF ( X .LE. 180. ) THEN
              IDLON  = 'E'
            ELSE
              X      = 360. - X
              IDLON  = 'W'
            ENDIF
          IF ( ABS(Y) .LE. 0.0049 ) THEN
              IDLAT  = ' '
            ELSE IF ( Y .GT. 0. ) THEN
              IDLAT  = 'N'
            ELSE
              IDLAT  = 'S'
              X      = -X
            ENDIF
          WRITE (NDSO,950) POINT, Y, IDLAT, X, IDLON, GNAME, RUN
          WRITE (NDSO,951) TAIL
          WRITE (NDSO,952)
          WRITE (NDSO,951) TAIL
          HEADER = .FALSE.
        ENDIF
*
* 3.  Get overall wave height ---------------------------------------- *
*
      DO 310, ITH=1, NTH
        DO 300, IFR=1, NFR
          W1(IFR,ITH) = 1.
  300     CONTINUE
  310   CONTINUE
*
      CALL MPARS ( NFR, NTH, SPEC, W1, FR, TH, DFR, DTH, TAILF, XFRV,
     &             SP1D, HS, TP, DM )
*
      HSTOT  = HS
*
* 4.  Determine maxima ----------------------------------------------- *
*
      NPEAK  = 0
*
      DO 410, IFR=NFR, 1, -1
        IFL    = MAX ( 1 , IFR-1 )
        IFH    = MIN ( NFR , IFR+1 )
        DO 400, ITH=1, NTH
          ITHL   = 1 + MOD(NTH+ITH-2,NTH)
          ITHH   = 1 + MOD(ITH,NTH)
          IF ( SPEC(IFR,ITH) .GE. SPEC(IFL,ITH ) .AND.
     &         SPEC(IFR,ITH) .GE. SPEC(IFH,ITH ) .AND.
     &         SPEC(IFR,ITH) .GE. SPEC(IFL,ITHL) .AND.
     &         SPEC(IFR,ITH) .GE. SPEC(IFR,ITHL) .AND.
     &         SPEC(IFR,ITH) .GE. SPEC(IFH,ITHL) .AND.
     &         SPEC(IFR,ITH) .GE. SPEC(IFL,ITHH) .AND.
     &         SPEC(IFR,ITH) .GE. SPEC(IFR,ITHH) .AND.
     &         SPEC(IFR,ITH) .GE. SPEC(IFH,ITHH) .AND.
     &         SPEC(IFR,ITH) .GT. 0.             ) THEN
              NPEAK  = NPEAK + 1
              NFRP(NPEAK) = IFR
              NTHP(NPEAK) = ITH
            ENDIF
          W1(IFR,ITH) = 0.
  400     CONTINUE
  410   CONTINUE
*
      IF ( NPEAK .LE. NPMAX ) THEN
          WRITE (*,910) TIME, NPEAK
        ELSE
          NPEAK  = NPMAX
          WRITE (*,911) TIME, NPEAK
        ENDIF
*
* 5.  Process all partial fields ------------------------------------- *
*
      NZERO  = 0
*
      DO 500, IP=1, NPEAK
*
        CALL FNDPRT ( NFR, NTH, NFRP(IP), NTHP(IP), SPEC, W1, W2 )
*
        CALL MPARS ( NFR, NTH, SPEC, W2, FR, TH, DFR, DTH, TAILF, XFRV,
     &               SP1D, HSP(IP), TPP(IP), DMP(IP) )
        IF ( HSP(IP) .LE. HSDROP ) NZERO = NZERO + 1
*
  500   CONTINUE
*
      DO 510, IP=NPEAK+1, NPMAX
        HSP(IP) =    0.00
        TPP(IP) = -999.99
        DMP(IP) = -999.99
  510   CONTINUE
*
      DO 520, IP=1, NPTAB
        HST(IP,2) = HST(IP,1)
        TPT(IP,2) = TPT(IP,1)
        DMT(IP,2) = DMT(IP,1)
        HST(IP,1) = -1.
        TPT(IP,1) = -1.
        DMT(IP,1) = -1.
  520   CONTINUE
*
* 6.  Generate output table ------------------------------------------ *
* 6.a Time and overall wave height to string
*
      STRING = BLANK
*
      WRITE (STRING(3:4),'(I2)') MOD(TIME(1),100)
      WRITE (STRING(6:7),'(I2)') TIME(2)/10000
      IF ( HSTOT .GT. 0. ) WRITE (STRING(11:14),'(F4.1)') HSTOT
      WRITE (STRING(16:17),'(I2)') NPEAK - NZERO
      IF ( NPEAK.EQ.0 .OR. HSTOT.LT.0.1 ) GOTO 699
*
* 6.b Switch off peak with too low wave height
*
      DO 600, IP=1, NPEAK
        FLAG(IP) = HSP(IP) .GT. HSMIN
  600   CONTINUE
*
* 6.c Find next highest wave height
*
      IOUT   = 0
  601 CONTINUE
*
      HMAX   = 0.
      IPNOW  = 0
      DO 610, IP=1, NPEAK
        IF ( HSP(IP).GT.HMAX .AND. FLAG(IP) ) THEN
            IPNOW  = IP
            HMAX   = HSP(IP)
          ENDIF
  610   CONTINUE
*
* 6.d No more peaks, skip to output
*
      IF ( IPNOW .EQ. 0 ) GOTO 699
*
* 6.e Find matching field
*
      ITAB   = 0
*
      DO 620, IP=1, NPTAB
        IF ( TPT(IP,2) .GT. 0. ) THEN
            DELHS  = ABS ( HST(IP,2) - HSP(IPNOW) )
            DELTP  = ABS ( TPT(IP,2) - TPP(IPNOW) )
            DELDM  = ABS ( DMT(IP,2) - DMP(IPNOW) )
            IF ( DELDM .GT. 180. ) DELDM = 360. - DELDM
            IF ( DELHS.LT.DHSMAX .AND. 
     &           DELTP.LT.DTPMAX .AND. 
     &           DELDM.LT.DDMMAX ) ITAB = IP
          ENDIF
  620   CONTINUE
*
* 6.f No matching field, find empty fields
*
      IF ( ITAB .EQ. 0 ) THEN
          DO 630, IP=NPTAB, 1, -1
            IF ( TPT(IP,1).LT.0. .AND. TPT(IP,2).LT.0. ) ITAB = IP
  630       CONTINUE
        ENDIF
*
* 6.g Slot in table found, write
*
      IF ( ITAB .NE. 0 ) THEN
*
          WRITE (PART,'(2X,F4.1,F5.1,I4)')
     &           HSP(IPNOW), TPP(IPNOW), NINT(DMP(IPNOW))
          DELDW  = MOD ( ABS ( UDIR - DMP(IPNOW) ) , 360. )
          IF ( DELDW .GT. 180. ) DELDW = 360. - DELDW
          AFR    = 2.*PI/TPP(IPNOW)
          CALL WAVNU2 ( AFR, D, WN, CG, 1.E-5, 15, ICON )
          AGE    = UABS * WN / AFR
          IF ( DELDW.LT.DDWMAX .AND. AGE.GT.AGEMIN ) PART(1:1) = '*'
*
          STRING(5+ITAB*18:19+ITAB*18) = PART
*
          HST(ITAB,1) = HSP(IPNOW)
          TPT(ITAB,1) = TPP(IPNOW)
          DMT(ITAB,1) = DMP(IPNOW)
*
* 6.g No slot in table found, write
*
        ELSE
*
          IOUT   = IOUT + 1
          WRITE (STRING(19:19),'(I1)') IOUT
*
        ENDIF
*
      FLAG(IPNOW) = .FALSE.
      GOTO 601
*
* 6.h End of processing, write line in table
*
  699 CONTINUE
*
      WRITE (NDSO,951) STRING
*
* === BRANCH BACK IN DATA LOOP ======================================= *
*
      GOTO 200
*
*     Error escape locations ----------------------------------------- *
*
c     GOTO 888
*
  800 CONTINUE
      WRITE (*,1000) FNAMEI, IERR
      STOP
*
  801 CONTINUE
      WRITE (*,1001) FNAMEI
      STOP
*
  802 CONTINUE
      WRITE (*,1002) FNAMEI, IERR
      STOP
*
  803 CONTINUE
      WRITE (*,1003) IDSTR, 'WAVEWATCH III SPECTRA'
      STOP
*
  804 CONTINUE
      WRITE (*,1004) NFR, NTH, NFRF, NTHF
      STOP
*
  805 CONTINUE
      WRITE (*,1005) POINT
      STOP
*
  810 CONTINUE
      WRITE (*,1010) FNAMEO, IERR
      STOP
*
  888 CONTINUE
      WRITE (NDSO,951) TAIL
      WRITE (NDSO,953) HSDROP, HSMIN
      WRITE (*,999)
*
*     Format statements ---------------------------------------------- *
*
  900 FORMAT (/' Splitting WAVEWATCH III spectra : '/
     &         ' ----------------------------------')
  901 FORMAT ( '    Location    : ',A/
     &         '    Run ID      : ',A)
  902 FORMAT ( '    Input file  : ',A,'  FORMATTED : ',L1)
  903 FORMAT ( '    Output file : ',A)
*
  904 FORMAT (/'    Input file opened ...')
  905 FORMAT ( '       Header read and processed.')
  906 FORMAT ( '       Frequency info read.')
  907 FORMAT ( '       Direction info read.')
  908 FORMAT ( '       Bin sizes preprocessed.')
*
  909 FORMAT (/'    Output file opened ...')
  910 FORMAT ( '       Processing ',I8.8,' ',I6.6,
     &         '  Number of peaks :',I3)
  911 FORMAT ( '       Processing ',I8.8,' ',I6.6,
     &         '  Number of peaks :',I3,'  (TRUNCATED)')
*
  950 FORMAT ( '  Location : ',A,' (',F5.2,A,1X,F6.2,A,')'/
     &         '  Model    : ',A/
     &         '  Cycle    : ',A)
  951 FORMAT (1X,A)
  952 FORMAT (' | day & |  Hst  n x |     Hs   Tp dir |',
     &                              '     Hs   Tp dir |',
     &                              '     Hs   Tp dir |',
     &                              '     Hs   Tp dir |',
     &                              '     Hs   Tp dir |',
     &                              '     Hs   Tp dir |'/
     &        ' |  hour |  (m)  - - |    (m)  (s) (d) |',
     &                              '    (m)  (s) (d) |',
     &                              '    (m)  (s) (d) |',
     &                              '    (m)  (s) (d) |',
     &                              '    (m)  (s) (d) |',
     &                              '    (m)  (s) (d) |')
  953 FORMAT (
     &  75X,'Hst : Total sigificant wave height.'/
     &  75X,'n   : Number of fields with Hs > ',f6.2,
     &           ' in 2-D spectrum.'/
     &  75X,'x   : Number of fields with Hs > ',f6.2,
     &           ' not in table.'/
     &  75X,'Hs  : Significant wave height of separate wave field.'/
     &  75X,'Tp  : Peak period of separate wave field.'/
     &  75X,'dir : Mean direction of separate wave field.'/
     &  75X,'*   : Wave generation due to local wind probable.')
*
  999 FORMAT (/' End of program '/)
*
 1000 FORMAT (/' *** ERROR IN OPENING INPUT FILE ',A/
     &         '     IOSTAT = ',I8/)
 1001 FORMAT (/' *** PREMATURE END OF INPUT FILE ',A/)
 1002 FORMAT (/' *** ERROR IN READING FROM INPUT FILE ',A/
     &         '     IOSTAT = ',I8/)
 1003 FORMAT (/' *** UNEXPECTED HEADER IN FILE : '/
     &         '     READ     : ',A/
     &         '     EXPECTED : ',A)
 1004 FORMAT (/' *** UNEXPECTED SPECTRAL DIMENSIONS : '/
     &         '     IN PROGRAM :',2I6/
     &         '     IN FILE    :',2I6/)
 1005 FORMAT (/' *** NO DATA FOUND FOR POINT ',A/)
*
 1010 FORMAT (/' *** ERROR IN OPENING OUTPUT FILE ',A/
     &         '     IOSTAT = ',I8/)
C/
C/ End of W3SPLT ----------------------------------------------------- /
C/
      END
C/ ------------------------------------------------------------------- /
      SUBROUTINE MPARS ( NFR, NTH, SPEC, MASK, FREQ, DIR, DFR, DTH,
     &                   TAILF, XFR, SP1D, HS, TP, DM )
C/
C/                  +-----------------------------------+
C/                  | WAVEWATCH III           NOAA/NCEP |
C/                  |           H. L. Tolman            |
C/                  |                        FORTRAN 77 |
C/                  | Last update :         15-Oct-1998 |
C/                  +-----------------------------------+
C/
C  1. Purpose :
C
C     Calculate mean parameters of a spectrum using a mask.
C
C  2. Method :
C
C     Wave height HS : Integral over spectrum using par. tail.
C     Peak period TP : Parabolic fit to 1-D spectrum.
C     Mean direction DM : From first Fourier components.
C
C  3. Parameters :
C
C     Parameter list
C     ----------------------------------------------------------------
C       NFR     Int.   I   Number of frequencies.
C       NTH     Int.   I   Number of directions.
C       SPEC    R.A.   I   Spectrum.
C       MASK    R.A.   I   Mask for spectrumi (real weight function).
C       FREQ    R.A.   I   Frequencies.
C       DIR     R.A.   I   Directions (radians).
C       DFR     R.A.   I   Bind width info for all frequencies.
C       DTH     R.A.   I   Directionsl increment.
C       TAILF   Real   I   Tail factor.
C       XFR     Real   I   Frequency increment factor.
C       SP1D    R.A.   O   1-D spectrum.
C       HS      Real   O   Wave height              -999.99 if undef.
C       TP      Real   O   Peak wave period         -999.99 if undef.
C       DM      Real   O   Mean wave direction      -999.99 if undef.
C     ----------------------------------------------------------------
C
C  4. Subroutines used :
C
C       None.
C
C  5. Called by :
C
C       Any.
C
C 10. Source code :
C
C/ ------------------------------------------------------------------- /
C/ Parameter list
C/
      INTEGER         NFR, NTH
      REAL            SPEC(NFR,NTH), MASK(NFR,NTH), FREQ(NFR), DIR(NTH),
     &                DFR(NFR), DTH, TAILF, XFR, SP1D(NFR), HS, TP, DM
C/
C/ ------------------------------------------------------------------- /
C/ Local parameters
C/
      INTEGER         IFR, ITH, IMAX, ILOW, IHGH
      REAL            COSMOM, SINMOM, TOTMOM, COS0, SIN0, PI, RADE, EMAX
      REAL            XL, XH, XL2, XH2, EL, EH, DENOM, FP
C/
C/ ------------------------------------------------------------------- /
*
      PI     = 4. * ATAN(1.)
      RADE   = 180./PI
*
      XL     = 1./XFR - 1.
      XH     =  XFR - 1.
      XL2    = XL**2
      XH2    = XH**2
*
      COSMOM = 0.
      SINMOM = 0.
      TOTMOM = 0.
*
      DO 110, IFR=1, NFR
*
        SP1D(IFR) = 0.
        COS0      = 0.
        SIN0      = 0.
*
        DO 100, ITH=1, NTH
          SP1D(IFR) = SP1D(IFR) + MASK(IFR,ITH)*SPEC(IFR,ITH)
          COS0      = COS0 + MASK(IFR,ITH)*SPEC(IFR,ITH) * COS(DIR(ITH))
          SIN0      = SIN0 + MASK(IFR,ITH)*SPEC(IFR,ITH) * SIN(DIR(ITH))
  100     CONTINUE
*
        SP1D(IFR) = SP1D(IFR) * DTH
        COSMOM    = COSMOM + COS0 * DTH * DFR(IFR)
        SINMOM    = SINMOM + SIN0 * DTH * DFR(IFR)
        TOTMOM    = TOTMOM + SP1D(IFR)*DFR(IFR)
*
  110   CONTINUE
*
      TOTMOM = TOTMOM + SP1D(NFR)*TAILF
      TOTMOM = MAX ( 0. , TOTMOM )
*
* 2.  Mean parameters ------------------------------------------------ *
* 2.a Set to undefined
*
      HS     =    0.00
      TP     = -999.99
      DM     = -999.99
*
      IF ( TOTMOM .GT. 0. ) THEN
*
* 2.b Wave height
*
          HS     = 4. * SQRT(TOTMOM)
*
* 2.c Mean direction
*
          DM     = RADE * ATAN2(SINMOM,COSMOM)
          IF ( DM .LT. 0. ) DM = DM + 360.
*
* 2.d Peak period
*
          EMAX   = 0.
*
          DO 200, IFR=1, NFR
            IF ( SP1D(IFR) .GT. EMAX ) THEN
                EMAX   = SP1D(IFR)
                IMAX   = IFR
              ENDIF
  200       CONTINUE
*
          ILOW   = MAX (  1 , IMAX-1 )
          IHGH   = MIN ( NFR , IMAX+1 )
          EL     = SP1D(ILOW) - SP1D(IMAX)
          EH     = SP1D(IHGH) - SP1D(IMAX)
          DENOM  = XL*EH - XH*EL
          FP     = FREQ(IMAX) * ( 1. + 0.5 * ( XL2*EH - XH2*EL )
     &                 / SIGN ( MAX(ABS(DENOM),1.E-15) , DENOM ) )
*
          TP     = 1. / FP
*
        ENDIF
*
      RETURN
C/
C/ End of MPARS ------------------------------------------------------ /
C/
      END
C/ ------------------------------------------------------------------- /
      SUBROUTINE FNDPRT ( NFR, NTH, IFRC, ITHC, SPEC, W1, W2 )
C/
C/                  +-----------------------------------+
C/                  | WAVEWATCH III           NOAA/NCEP |
C/                  |           H. L. Tolman            |
C/                  |                        FORTRAN 77 |
C/                  | Last update :         09-Sep-1998 |
C/                  +-----------------------------------+
C/
C  1. Purpose :
C
C     Find partition starting at given peak and given mask.
C
C  2. Method :
C
C  3. Parameters :
C
C     Parameter list
C     ----------------------------------------------------------------
C       NFR     Int.   I   Number of frequencies.
C       NTH     Int.   I   Number of directions.
C       IFRC    Int.   I   Peak discrete frequency.
C       ITHC    Int.   I   Peak discrete direction.
C       SPEC    R.A.   I   Spectrum.
C       W1      R.A.  I/O  Map of bins used so far.
C       W2      R.A.   O   Map of bins used now.
C     ----------------------------------------------------------------
C
C  4. Subroutines used :
C
C       None.
C
C  5. Called by :
C
C       Any.
C
C 10. Source code :
C
C/ ------------------------------------------------------------------- /
C/ Parameter list
C/
      INTEGER         NFR, NTH, IFRC, ITHC
      REAL            SPEC(NFR,NTH), W1(NFR,NTH), W2(NFR,NTH)
C/
C/ ------------------------------------------------------------------- /
C/ Local parameters
C/
      INTEGER         IFR, ITH, IFRL, ITHL
      LOGICAL         CHANGE, ADD
C/
C/ ------------------------------------------------------------------- /
*
* 1.  Set up the W2 map ---------------------------------------------- *
*
      DO 110, IFR=1, NFR
        DO 100, ITH=1, NTH
          W2(IFR,ITH) = 0.
  100     CONTINUE
  110   CONTINUE
*
      IFRL   = MAX ( 1 , IFRC-1 )
      IFRH   = MIN ( NFR , IFRC+1 )
      ITHL   = 1 + MOD(NTH+ITHC-2,NTH)
      ITHH   = 1 + MOD(ITHC,NTH)
*
      DO 130, ITH=ITHC-1, ITHC+1
        ITHL = 1 + MOD(NTH+ITH-1,NTH)
        DO 120, IFR=IFRC-1, IFRC+1
          IFRL = MAX(1,MIN(NFR,IFR))
          IF ( W1(IFRL,ITHL) .LE. 0.5 ) W2(IFRL,ITHL) = 0.5
  120     CONTINUE
  130   CONTINUE
*
      IF ( W1(IFRC,ITHC) .LT. 0.25 ) W2(IFRC,ITHC) = 1.0
*
* 2.  Itterate search ------------------------------------------------ *
*
      NITT   = 0
*
* 2.a Branch point
*
  200 CONTINUE
      NITT   = NITT + 1
      CHANGE = .FALSE.
*
* 2.b Determine central points
*
      DO 240, IFR=1, NFR
        DO 230, ITH=1, NTH
*
          IF ( W2(IFR,ITH).EQ.0.5 .AND. W1(IFR,ITH).LT.0.5 ) THEN
              ADD    = .TRUE.
              DO 220, ITHR=ITH-1, ITH+1
                ITHL = 1 + MOD(NTH+ITHR-1,NTH)
                DO 210, IFRL=MAX(1,IFR-1), MIN(NFR,IFR+1)
                  IF ( W2 (IFRL,ITHL).EQ.0. .AND. 
     &                SPEC(IFRL,ITHL).GT.SPEC(IFR,ITH) ) ADD = .FALSE.
  210             CONTINUE
  220           CONTINUE
              IF ( ADD ) W2(IFR,ITH) = 1.
              CHANGE = CHANGE .OR. ADD
            ENDIF
*
  230     CONTINUE
  240   CONTINUE
*
* 2.c Determine central points
*
      DO 280, IFR=1, NFR
        DO 270, ITH=1, NTH
*
          IF ( W2(IFR,ITH).EQ.0. ) THEN
              ADD    = .FALSE.
              DO 260, ITHR=ITH-1, ITH+1
                ITHL = 1 + MOD(NTH+ITHR-1,NTH)
                DO 250, IFRL=MAX(1,IFR-1), MIN(NFR,IFR+1)
                  IF ( W2 (IFRL,ITHL).EQ.1. ) ADD = .TRUE.
  250             CONTINUE
  260           CONTINUE
              IF ( ADD ) W2(IFR,ITH) = 0.5
              CHANGE = CHANGE .OR. ADD
            ENDIF
*
  270     CONTINUE
  280   CONTINUE
*
* 2.d Branch back ?
*
      IF ( CHANGE .AND. NITT.LT.25 ) GOTO 200
*
* 3   Update the overall map ----------------------------------------- *
*
      DO 310, IFR=1, NFR
        DO 300, ITH=1, NTH
          W1(IFR,ITH) = W1(IFR,ITH) + W2(IFR,ITH)
  300     CONTINUE
  310   CONTINUE
*
      RETURN
C/
C/ End of FNDPRT ----------------------------------------------------- /
C/
      END
C/ ------------------------------------------------------------------- /
      SUBROUTINE WAVNU2 (W,H,K,CG,EPS,NMAX,ICON)
C/
C/                  +-----------------------------------+
C/                  | WAVEWATCH III           NOAA/NCEP |
C/                  |           H. L. Tolman            |
C/                  |                        FORTRAN 77 |
C/                  | Last update :         17-Jul-1990 |
C/                  +-----------------------------------+
C/
C  1. Purpose :
C
C     Calculation of wavenumber K from a given angular
C     frequency W and waterdepth H.
C
C  2. Method :
C
C     Used equation :
C                        2
C                       W  = G*K*TANH(K*H)
C
C     Because of the nature of the equation, K is calculated
C     with an itterative procedure.
C
C  3. Parameters :
C
C     Parameter list
C     ----------------------------------------------------------------
C       W       Real   I   Angular frequncy
C       H       Real   I   Waterdepth
C       K       Real   O   Wavenumber ( same sign as W )
C       CG      Real   O   Group velocity (same sign as W)
C       EPS     Real   I   Wanted max. difference between K and Kold
C       NMAX    Int.   I   Max number of repetitions in calculation
C       ICON    Int.   O   Contol counter ( See error messages )
C     ----------------------------------------------------------------
C
C  9. Switches :
C
C     C/S  Enable subroutine tracing.
C
C 10. Source code :
C/
C/ ------------------------------------------------------------------- /
C/ Parameter list
C/
      INTEGER         ICON, NMAX
      REAL            EPS, CG, K, H, W
C/
C/ ------------------------------------------------------------------- /
C/ Local parameters
C/
      INTEGER         I
C/S      INTEGER         IENT
      REAL            G, F, W0, FD, DIF, RDIF, KOLD
C/
C/ ------------------------------------------------------------------- /
C/
      DATA G / 9.81 /
*
*     Initialisations :
*
      CG   = 0
      KOLD = 0
      ICON = 0
      W0   = ABS(W)
*
*     1st approach :
*
      IF (W0.LT.SQRT(G/H)) THEN
          K = W0/SQRT(G*H)
        ELSE
          K = W0*W0/G
        END IF
*
*     Refinement :
*
      DO 7, I=1, NMAX
        DIF = ABS(K-KOLD)
      IF (K.NE.0) THEN
          RDIF = DIF/K
        ELSE
          RDIF = 0
        END IF
      IF (DIF .LT. EPS .AND. RDIF .LT. EPS) THEN
          ICON = 1
          GOTO 8
        ELSE
          KOLD = K
          F    = G*KOLD*TANH(KOLD*H)-W0**2
          IF (KOLD*H.GT.25) THEN
              FD = G*TANH(KOLD*H)
            ELSE
              FD = G*TANH(KOLD*H) + G*KOLD*H/((COSH(KOLD*H))**2)
            END IF
          K    = KOLD - F/FD
        END IF
7       CONTINUE
      DIF   = ABS(K-KOLD)
      RDIF  = DIF/K
      IF (DIF .LT. EPS .AND. RDIF .LT. EPS) ICON = 1
8     CONTINUE
      IF (2*K*H.GT.25) THEN
          CG = W0/K * 0.5
        ELSE
          CG = W0/K * 0.5*(1+(2*K*H/SINH(2*K*H)))
        END IF
      IF (W.LT.0.0) THEN
          K  = (-1)*K
          CG = CG*(-1)
        END IF
*
      RETURN
C/
C/ End of WAVNU2 ----------------------------------------------------- /
C/
      END

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
!     this module contains necessary variables for remapping between
!     two grids.  also routines for resizing and initializing these
!     variables.
!
!-----------------------------------------------------------------------
!
!     CVS:$Id: remap_vars.f,v 1.5 2000/04/19 21:56:26 pwjones Exp $
!
!     Copyright (c) 1997, 1998 the Regents of the University of 
!       California.
!
!     This software and ancillary information (herein called software) 
!     called SCRIP is made available under the terms described here.  
!     The software has been approved for release with associated 
!     LA-CC Number 98-45.
!
!     Unless otherwise indicated, this software has been authored
!     by an employee or employees of the University of California,
!     operator of the Los Alamos National Laboratory under Contract
!     No. W-7405-ENG-36 with the U.S. Department of Energy.  The U.S.
!     Government has rights to use, reproduce, and distribute this
!     software.  The public may copy and use this software without
!     charge, provided that this Notice and any statement of authorship
!     are reproduced on all copies.  Neither the Government nor the
!     University makes any warranty, express or implied, or assumes
!     any liability or responsibility for the use of this software.
!
!     If software is modified to produce derivative works, such modified
!     software should be clearly marked, so as not to confuse it with 
!     the version available from Los Alamos National Laboratory.
!
!     This code has been modified from the version available from 
!     Los Alamos National Laboratory, for the purpose of running it
!     within WW3.
!
!***********************************************************************

      module scrip_remap_vars

      use SCRIP_KindsMod ! defines common data types
      use SCRIP_constants
      use scrip_grids

      implicit none

!-----------------------------------------------------------------------
!
!     module variables
!
!-----------------------------------------------------------------------

      integer (SCRIP_i4), parameter ::
     &      norm_opt_none    = 1
     &,     norm_opt_dstarea = 2
     &,     norm_opt_frcarea = 3

      integer (SCRIP_i4), parameter ::
     &      map_type_conserv  = 1
     &,     map_type_bilinear = 2
     &,     map_type_bicubic  = 3
     &,     map_type_distwgt  = 4
     &,     map_type_particle = 5

      integer (SCRIP_i4), save :: 
     &      max_links_map1  ! current size of link arrays
     &,     num_links_map1  ! actual number of links for remapping
     &,     max_links_map2  ! current size of link arrays
     &,     num_links_map2  ! actual number of links for remapping
     &,     num_maps        ! num of remappings for this grid pair
     &,     num_wts         ! num of weights used in remapping
     &,     map_type        ! identifier for remapping method
     &,     norm_opt        ! option for normalization (conserv only)
     &,     resize_increment ! default amount to increase array size

      integer (SCRIP_i4), dimension(:), allocatable, save ::
     &      grid1_add_map1, ! grid1 address for each link in mapping 1
     &      grid2_add_map1, ! grid2 address for each link in mapping 1
     &      grid1_add_map2, ! grid1 address for each link in mapping 2
     &      grid2_add_map2  ! grid2 address for each link in mapping 2

      real (SCRIP_r8), dimension(:,:), allocatable, save ::
     &      wts_map1, ! map weights for each link (num_wts,max_links)
     &      wts_map2  ! map weights for each link (num_wts,max_links)

      real (kind = SCRIP_r8) :: frac_lowest,frac_highest
      real (kind = SCRIP_r8) :: wt_lowest,wt_highest

!***********************************************************************

      contains

!***********************************************************************

      subroutine init_remap_vars

!-----------------------------------------------------------------------
!
!     this routine initializes some variables and provides an initial
!     allocation of arrays (fairly large so frequent resizing 
!     unnecessary).
!
!-----------------------------------------------------------------------

!-----------------------------------------------------------------------
!
!     determine the number of weights
!
!-----------------------------------------------------------------------

      select case (map_type)
      case(map_type_conserv)
        num_wts = 3
      case(map_type_bilinear)
        num_wts = 1
      case(map_type_bicubic)
        num_wts = 4
      case(map_type_distwgt)
        num_wts = 1
      case(map_type_particle)
        num_wts = 1
      end select

!-----------------------------------------------------------------------
!
!     initialize num_links and set max_links to four times the largest 
!     of the destination grid sizes initially (can be changed later).
!     set a default resize increment to increase the size of link
!     arrays if the number of links exceeds the initial size
!   
!-----------------------------------------------------------------------

      num_links_map1 = 0
      max_links_map1 = 4*grid2_size
      if (num_maps > 1) then
        num_links_map2 = 0
        max_links_map1 = max(4*grid1_size,4*grid2_size)
        max_links_map2 = max_links_map1
      endif

      resize_increment = 0.1*max(grid1_size,grid2_size)

!-----------------------------------------------------------------------
!
!     allocate address and weight arrays for mapping 1
!   
!-----------------------------------------------------------------------

      allocate (grid1_add_map1(max_links_map1),
     &          grid2_add_map1(max_links_map1),
     &          wts_map1(num_wts, max_links_map1))

!-----------------------------------------------------------------------
!
!     allocate address and weight arrays for mapping 2 if necessary 
!   
!-----------------------------------------------------------------------

      if (num_maps > 1) then
        allocate (grid1_add_map2(max_links_map2),
     &            grid2_add_map2(max_links_map2),
     &            wts_map2(num_wts, max_links_map2))
      endif

!-----------------------------------------------------------------------

      end subroutine init_remap_vars

!***********************************************************************

      subroutine resize_remap_vars(nmap, increment)

!-----------------------------------------------------------------------
!
!     this routine resizes remapping arrays by increasing(decreasing)
!     the max_links by increment
!
!-----------------------------------------------------------------------

!-----------------------------------------------------------------------
!
!     input variables
!
!-----------------------------------------------------------------------

      integer (SCRIP_i4), intent(in) ::
     &     nmap,      ! identifies which mapping array to resize
     &     increment  ! the number of links to add(subtract) to arrays

!-----------------------------------------------------------------------
!
!     local variables
!
!-----------------------------------------------------------------------

      integer (SCRIP_i4) ::
     &   ierr,     ! error flag
     &   mxlinks   ! size of link arrays

      integer (SCRIP_i4), dimension(:), allocatable ::
     &   add1_tmp, ! temp array for resizing address arrays
     &   add2_tmp  ! temp array for resizing address arrays

      real (SCRIP_r8), dimension(:,:), allocatable ::
     &   wts_tmp   ! temp array for resizing weight arrays

!-----------------------------------------------------------------------
!
!     resize map 1 arrays if required.
!
!-----------------------------------------------------------------------

      select case (nmap)
      case(1)

        !***
        !*** allocate temporaries to hold original values
        !***

        mxlinks = size(grid1_add_map1)
        allocate (add1_tmp(mxlinks), add2_tmp(mxlinks), 
     &            wts_tmp(num_wts,mxlinks))

        add1_tmp = grid1_add_map1
        add2_tmp = grid2_add_map1
        wts_tmp  = wts_map1
        
        !***
        !*** deallocate originals and increment max_links then
        !*** reallocate arrays at new size
        !***

        deallocate (grid1_add_map1, grid2_add_map1, wts_map1)
        max_links_map1 = mxlinks + increment
        allocate (grid1_add_map1(max_links_map1),
     &            grid2_add_map1(max_links_map1),
     &            wts_map1(num_wts,max_links_map1))

        !***
        !*** restore original values from temp arrays and
        !*** deallocate temps
        !***

        mxlinks = min(mxlinks, max_links_map1)
        grid1_add_map1(1:mxlinks) = add1_tmp (1:mxlinks)
        grid2_add_map1(1:mxlinks) = add2_tmp (1:mxlinks)
        wts_map1    (:,1:mxlinks) = wts_tmp(:,1:mxlinks)
        deallocate(add1_tmp, add2_tmp, wts_tmp)

!-----------------------------------------------------------------------
!
!     resize map 2 arrays if required.
!
!-----------------------------------------------------------------------

      case(2)

        !***
        !*** allocate temporaries to hold original values
        !***

        mxlinks = size(grid1_add_map2)
        allocate (add1_tmp(mxlinks), add2_tmp(mxlinks), 
     &            wts_tmp(num_wts,mxlinks),stat=ierr)
        if (ierr .ne. 0) then
          print *,'error allocating temps in resize: ',ierr
          stop
        endif

        add1_tmp = grid1_add_map2
        add2_tmp = grid2_add_map2
        wts_tmp  = wts_map2
        
        !***
        !*** deallocate originals and increment max_links then
        !*** reallocate arrays at new size
        !***

        deallocate (grid1_add_map2, grid2_add_map2, wts_map2)
        max_links_map2 = mxlinks + increment
        allocate (grid1_add_map2(max_links_map2),
     &            grid2_add_map2(max_links_map2),
     &            wts_map2(num_wts,max_links_map2),stat=ierr)
        if (ierr .ne. 0) then
          print *,'error allocating new arrays in resize: ',ierr
          stop
        endif


        !***
        !*** restore original values from temp arrays and
        !*** deallocate temps
        !***

        mxlinks = min(mxlinks, max_links_map2)
        grid1_add_map2(1:mxlinks) = add1_tmp (1:mxlinks)
        grid2_add_map2(1:mxlinks) = add2_tmp (1:mxlinks)
        wts_map2    (:,1:mxlinks) = wts_tmp(:,1:mxlinks)
        deallocate(add1_tmp, add2_tmp, wts_tmp)

      end select

!-----------------------------------------------------------------------

      end subroutine resize_remap_vars

!***********************************************************************

      end module scrip_remap_vars

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||

 module SCRIP_ErrorMod

!BOP
! !MODULE: SCRIP_ErrorMod
! !DESCRIPTION:
! This module contains SCRIP error flags and facilities for logging and
! printing error messages. Note that error flags are local to a
! process and there is no synchronization of error flags across
! processes. As routines trap error flags, they may add a message
! to the error log to aid in tracking the call sequence.
!
! Users should not need to change any values in this module.
!
! All routines in SCRIP which encounter an error should return to
! the calling routine with the SCRIP\_Fail error code set and a message
! added to the error log using the SCRIP\_ErrorCheck or
! SCRIP\_ErrorSet function. Routines in SCRIP should also check
! error codes returned by called routines and add a message to the
! error log to help users track the calling sequence that generated
! the error. This process enables the error code to be propagated
! to the highest level or calling routine to enable a graceful
! exit. At that level, the SCRIP_ErrorPrint call can be used to
! print the entire error trace or error log.
!
! !REVISION HISTORY:
! SVN:$Id: SCRIP_ErrorMod.F90 14 2006-08-17 17:07:05Z $
!
! !USES:

   use SCRIP_KindsMod
   !use SCRIP_CommMod
   use SCRIP_IOUnitsMod

   implicit none
   private
   save

! !DEFINED PARAMETERS:

   integer (SCRIP_i4), parameter, public :: &
      SCRIP_Success = 0, & ! standard SCRIP error flags
      SCRIP_Fail = -1

! !PUBLIC MEMBER FUNCTIONS:

   public :: SCRIP_ErrorSet, &
             SCRIP_ErrorCheck, &
             SCRIP_ErrorPrint

!EOP
!BOC
!-----------------------------------------------------------------------
!
! module variables
!
!-----------------------------------------------------------------------

   integer (SCRIP_i4), parameter :: &
      SCRIP_errorLogDepth = 20 ! Max depth of call tree to properly
                               ! size the error log array

   integer (SCRIP_i4) :: &
      SCRIP_errorMsgCount = 0 ! tracks current number of log messages

   character (SCRIP_CharLength), dimension(SCRIP_ErrorLogDepth) :: &
      SCRIP_errorLog ! list of error messages to be output

!EOC
!***********************************************************************

 contains

!***********************************************************************
!BOP
! !IROUTINE: SCRIP_ErrorSet -- sets error code and logs error message
! !INTERFACE:

 subroutine SCRIP_ErrorSet(errorCode, rtnName, errorMsg)

! !DESCRIPTION:
! This routine sets an error code to SCRIP\_Fail and adds a message to
! the error log for later printing.
!
! !REVISION HISTORY:
! same as module

! !OUTPUT PARAMETERS:

   integer (SCRIP_i4), intent(out) :: &
      errorCode ! Error code to set to fail

! !INPUT PARAMETERS:

   character (*), intent(in) :: &
      rtnName, &! name of calling routine
      errorMsg ! message to add to error log for printing

!EOP
!BOC
!-----------------------------------------------------------------------
!
! Local variables
!
!-----------------------------------------------------------------------

   character(SCRIP_charLength) :: &
      logErrorMsg ! constructed error message with routine name

!-----------------------------------------------------------------------
!
! Set error code to fail
!
!-----------------------------------------------------------------------

   errorCode = SCRIP_Fail

!-----------------------------------------------------------------------
!
! Add error message to error log
!
!-----------------------------------------------------------------------

   SCRIP_errorMsgCount = SCRIP_errorMsgCount + 1

   if (SCRIP_errorMsgCount <= SCRIP_errorLogDepth) then
      write(logErrorMsg,'(a,a2,a)') rtnName,': ',errorMsg
      SCRIP_errorLog(SCRIP_errorMsgCount) = logErrorMsg
   endif

!-----------------------------------------------------------------------
!EOC

 end subroutine SCRIP_ErrorSet

!***********************************************************************
!BOP
! !IROUTINE: SCRIP_ErrorCheck -- checks error code and logs error message
! !INTERFACE:

 function SCRIP_ErrorCheck(errorCode, rtnName, errorMsg)

! !DESCRIPTION:
! This function checks an error code and adds a message to the error
! log for later printing. It is a more compact form of the ErrorSet
! routine that is especially useful for checking an error code after
! returning from a routine or function. If the errorCode is the
! failure code SCRIP\_Fail, it returns a logical true value so that
! it can be used in a typical call like:
! \begin{verbatim}
! if (SCRIP_ErrorCheck(errorCode, rtnName, errorMsg)) return
! \end{verbatim}
!
! !REVISION HISTORY:
! same as module

! !OUTPUT PARAMETERS:

   logical (SCRIP_logical) :: &
      SCRIP_ErrorCheck

! !INPUT PARAMETERS:

   integer (SCRIP_i4), intent(in) :: &
      errorCode ! Error code to check

   character (*), intent(in) :: &
      rtnName, &! name of calling routine
      errorMsg ! message to add to error log for printing

!EOP
!BOC
!-----------------------------------------------------------------------
!
! local variables
!
!-----------------------------------------------------------------------

   character (SCRIP_charLength) :: &
      logErrorMsg ! constructed error message with routine name

!-----------------------------------------------------------------------
!
! If the error code is success, set the return value to false.
!
!-----------------------------------------------------------------------

   if (errorCode == SCRIP_Success) then
      SCRIP_ErrorCheck = .false.

!-----------------------------------------------------------------------
!
! If the error code is a fail, set the return value to true and
! add the error message to the log.
!
!-----------------------------------------------------------------------

   else
      SCRIP_ErrorCheck = .true.

      SCRIP_errorMsgCount = SCRIP_errorMsgCount + 1

      if (SCRIP_errorMsgCount <= SCRIP_errorLogDepth) then
         write(logErrorMsg,'(a,a2,a)') rtnName,': ',errorMsg
         SCRIP_errorLog(SCRIP_errorMsgCount) = logErrorMsg
      endif
   endif

!-----------------------------------------------------------------------
!EOC

 end function SCRIP_ErrorCheck

!***********************************************************************
!BOP
! !IROUTINE: SCRIP_ErrorPrint -- prints the error log
! !INTERFACE:

 subroutine SCRIP_ErrorPrint(printTask)

! !DESCRIPTION:
! This routine prints all messages in the error log. If a printTask
! is specified, only the message log on that task will be printed.
!
! !REVISION HISTORY:
! same as module

! !INPUT PARAMETERS:

!   integer (SCRIP_i4), intent(in) :: &
!      errorCode ! input error code to check success/fail

   !*** currently this has no meaning, but will be used in parallel
   !*** SCRIP version
   integer (SCRIP_i4), intent(in), optional :: &
      printTask ! Task from which to print error log

!EOP
!BOC
!-----------------------------------------------------------------------
!
! local variables
!
!-----------------------------------------------------------------------

   integer (SCRIP_i4) :: n

!-----------------------------------------------------------------------
!
! Print all error messages to stdout
!
!-----------------------------------------------------------------------

   if (present(printTask)) then

      !*** parallel SCRIP not yet supported
      !if (SCRIP_myTask == printTask) then

         write(SCRIP_stdout,SCRIP_blankFormat)
         write(SCRIP_stdout,SCRIP_delimFormat)
         write(SCRIP_stdout,SCRIP_blankFormat)

         if (SCRIP_errorMsgCount == 0) then ! no errors

            write(SCRIP_stdout,'(a34)') &
                                'Successful completion of SCRIP model'

         else

            write(SCRIP_stdout,'(a14)') 'SCRIP Exiting...'

            do n=1,min(SCRIP_errorMsgCount,SCRIP_errorLogDepth)
               write(SCRIP_stderr,'(a)') trim(SCRIP_errorLog(n))
               if (SCRIP_stdout /= SCRIP_stderr) then
                  write(SCRIP_stdout,'(a)') trim(SCRIP_errorLog(n))
               endif
            end do

            if (SCRIP_errorMsgCount > SCRIP_errorLogDepth) then
               write(SCRIP_stderr,'(a23)') 'Too many error messages'
               if (SCRIP_stdout /= SCRIP_stderr) then
                  write(SCRIP_stdout,'(a23)') 'Too many error messages'
               endif
            endif

         endif

         write(SCRIP_stdout,SCRIP_blankFormat)
         write(SCRIP_stdout,SCRIP_delimFormat)
         write(SCRIP_stdout,SCRIP_blankFormat)

      !endif

   else

      write(SCRIP_stdout,SCRIP_blankFormat)
      write(SCRIP_stdout,SCRIP_delimFormat)
      write(SCRIP_stdout,SCRIP_blankFormat)

      if (SCRIP_errorMsgCount == 0) then ! no errors

         write(SCRIP_stdout,'(a34)') 'Successful completion of SCRIP'

      else

         write(SCRIP_stdout,'(a14)') 'SCRIP Exiting...'

         do n=1,min(SCRIP_errorMsgCount,SCRIP_errorLogDepth)
            write(SCRIP_stderr,'(a)') trim(SCRIP_errorLog(n))
            if (SCRIP_stdout /= SCRIP_stderr) then
               write(SCRIP_stdout,'(a)') trim(SCRIP_errorLog(n))
            endif
         end do

         if (SCRIP_errorMsgCount > SCRIP_errorLogDepth) then
            write(SCRIP_stderr,'(a23)') 'Too many error messages'
            if (SCRIP_stdout /= SCRIP_stderr) then
               write(SCRIP_stdout,'(a23)') 'Too many error messages'
            endif
         endif

      endif

      write(SCRIP_stdout,SCRIP_blankFormat)
      write(SCRIP_stdout,SCRIP_delimFormat)
      write(SCRIP_stdout,SCRIP_blankFormat)

   endif

!-----------------------------------------------------------------------
!EOC

 end subroutine SCRIP_ErrorPrint

!***********************************************************************

 end module SCRIP_ErrorMod

!|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||

      PROGRAM W3ADC
C/
C/                  +-----------------------------------+
C/                  |           H. L. Tolman            |
C/                  |                        FORTRAN 77 |
C/                  | Last update :         05-Jan-2001 |
C/                  +-----------------------------------+
C/
C/    Version to preprocess FORTRAN 90 free format code.
C/
C  1. Purpose :
C
C     Pre-processing of FORTRAN files by switching on and of of
C     selected lines and by including COMMON's.
C
C                                  - Based on ADCOM by N. Booij,
C                                    Delft University of Technology.
C                                  - Refinement of WWADC
C                                  - FORTRAN 90 compatible
C
C  2. Method :
C
C     From standard input the following data are read:
C       - Test indicator and compress indicator     ( 1 line  ).
C       - File name of the input and output code    ( 1 line  ).
C       - Switches to be turned on                  ( 1 line  ).
C       - Include string and file name              ( n lines ).
C
C     where :
C
C       test indicator : 0 : no test output
C                       >0 : (more) test output
C       compress ind.  : 0 : no file compression
C                        1 : Remove comments except for empty switches.
C                        2 : Remove all comment.
C
C     Output is read using free format, so quotes are needed around
C     strings. Echo and test output is send to the standard output
C     device. Switches can be up to NLSWTC characters long, and are
C     separated by spaces.
C
C  3. Parameters :
C
C     Data in PARAMETER statements :
C     ----------------------------------------------------------------
C       MMLOUT  Int.  Line length of output.
C       MMSWTC  Int.  Maximum number of switches.
C       MMFILE  Int.  Maximum number of include files.
C       MMLINE  Int.  Maximum length of include files.
C     ----------------------------------------------------------------
C
C     Internal data :
C     ----------------------------------------------------------------
C       ITEST   Int.  Test indicator (see section 2).
C       ICOMP   Int.  Compression indicator (see section 2).
C       NSWTCH  Int.  Number of switches (total).
C       NLSWTC  Int.  Maximum length of switches.
C       NFILES  Int.  Number of include files.
C       NLINES  I.A.  Length of include files.
C       IDLEN   I.A.  Length of ID string for include file.
C       MMLNGT  Int.  Maximum length of include files.
C     ----------------------------------------------------------------
C
C  4. Subroutines used :
C
C     None.
C
C  5. Called by :
C
C     None (stand alone program).
C
C  6. Error messages :
C
C     - Checks on array sizes.
C     - Open errors on files.
C
C  7. Remarks :
C
C     - Switches are case-sensitive
C     - Switch in code has to be followed by space.
C     - Switches can be used in include files, since include files are
C       are pre-processed before the actual file is processed. Includes
C       in include files, however, are not accepted.
C     - By dealing with swtiches before looking for include files,
C       the inclusion of files can be governed by switches.
C     - Variable record lengths used by looking for last non-blank.
C     - ID string for inclusion of file can be anything, and may
C       include blanks.
C
C  8. Structure :
C
C     =====================================================
C      Initializations
C      Read from standard input and proparations
C      ----------------------------------------------------
C        ITEST and ICOMP
C        Read names of input and output files and open
C        Read and process switches.
C        Process include files
C          ------------------------------------------------
C          Get and store ID string
C          Preprocess include file
C            ----------------------------------------------
C            Process switches
C            Check for keeping of line (compress)
C            Determine line lengths
C     =====================================================
C      Actual processing
C      For every line do
C      ----------------------------------------------------
C        Process switches
C        Check for include files
C        If no include
C        --------------------------------------------------
C          Check for keeping of line (compress)
C          Determine actual line length
C          Write line
C     =====================================================
C
C  9. Source code :
C
* ----------------------------------------------------------------------
*
      PARAMETER ( MMLOUT = 132 )
      PARAMETER ( MMFILE =  30 )
      PARAMETER ( MMSWTC =  52 )
      PARAMETER ( MMLINE = 200 )
*
      INTEGER       NSWTCH, IDLEN(MMFILE), NLINES(MMFILE), LL,
     &              LENGTH(MMFILE,MMLINE), NINCF(MMFILE), LS(MMSWTC)
      LOGICAL       FLOLD, FLKEEP, FLINCL, FLSWTC, LSTEXC, NOWEXC,
     &              QUOTES
*
      CHARACTER*20  TEST0, TSTSTR
      CHARACTER*120 FNAMEI, FNAMEO, FNAMER
      CHARACTER*72  INSTR
      CHARACTER*143 NEWLNE, OLDLNE
      CHARACTER*200 SWTCHS
      CHARACTER*33  NOLINE
      CHARACTER     SWITCH*8, SW0*8
      DIMENSION     SWITCH(MMSWTC), TSTSTR(MMFILE), INSTR(MMFILE,MMLINE)
*
* initialisations
*
      NOLINE        = '.  .  .  .  .  .  .  .  .  .  .  '
*
* set test parameters --------------------------------------------------
*
      NLSWTC = LEN(SWITCH(1))
*
      READ (*,*) ITEST, ICOMP
      ITEST  = MAX ( ITEST , 0 )
      ICOMP  = MIN ( MAX(ICOMP,0) , 2 )
      WRITE (*,900) ITEST, ICOMP
*
* Read file names ------------------------------------------------------
*
      READ (*,*) FNAMEI, FNAMEO
      NDSIN  = 10
      NDSOUT = 11
      WRITE (*,910) FNAMEI, FNAMEO
*
      OPEN (NDSIN ,FILE=FNAMEI,ERR=801,STATUS='OLD')
      OPEN (NDSOUT,FILE=FNAMEO,ERR=802)
*
* Read switches --------------------------------------------------------
*
      READ (*,*) SWTCHS
      NSWTCH = 0
      FLOLD  = .FALSE.
*
      DO 100, I=1, 200
        IF (SWTCHS(I:I).NE.' ') THEN
            IF ( FLOLD ) THEN
                  J = J + 1
                  IF (J.GT.NLSWTC) THEN
                      WRITE (*,*) '*** ERROR: SWITCH TOO LONG'
                      STOP
                    ENDIF
                  SW0(J:J) = SWTCHS(I:I)
                ELSE
                  IF (NSWTCH+1.GT.MMSWTC) THEN
                      WRITE (*,*) '*** ERROR: TOO MANY SWITCHES'
                      STOP
                    ENDIF
                  NSWTCH   = NSWTCH + 1
                  J        = 1
                  SW0(1:1) = SWTCHS(I:I)
                  FLOLD    = .TRUE.
                ENDIF
          ELSE
            IF ( FLOLD ) THEN
                SWITCH(NSWTCH) = SW0(1:J)
                LS    (NSWTCH) = J
              ENDIF
            FLOLD  = .FALSE.
          ENDIF
  100   CONTINUE
*
      IF ( FLOLD ) THEN
          SWITCH(NSWTCH) = SW0(1:J)
          LS    (NSWTCH) = J
        ENDIF
*
      WRITE (*,920) NSWTCH
      IF (ITEST.EQ.0) THEN
          WRITE (*,921) (SWITCH(I),I=1,NSWTCH)
        ELSE
          DO 90, J=1, NSWTCH
            SW0    = SWITCH(J)
            WRITE (*,922) J, SW0(1:LS(J))
   90       CONTINUE
        ENDIF
*
* get include files ----------------------------------------------------
*
      NDSINC = 50
      NFILES = 0
      WRITE (*,930)
  110 CONTINUE
      READ (*,*,END=200,ERR=200) TEST0, FNAMER
      NFILES = NFILES + 1
      NINCF(NFILES) = 0
      IF (NFILES.GT.MMFILE) THEN
          WRITE (*,*) '*** ERROR: TOO MANY INCLUDE FILES'
          STOP
        ENDIF
      IF (ITEST.GE.3) WRITE (*,9930) TEST0, FNAMER
*
* store ID string and determine its length - - - - - - - - - - - - - - -
*
      TSTSTR(NFILES) = TEST0
      DO 120 J=LEN(TEST0),1,-1
        IDLEN(NFILES) = J
        IF (TEST0(J:J).NE.' ') GOTO 121
  120   CONTINUE
  121 CONTINUE
      IF (ITEST.GE.2) WRITE (*,9931) IDLEN(NFILES)
*
* (pre-) process include file  - - - - - - - - - - - - - - - - - - - - -
*
      ILINE1 = 0
      ILINE2 = 0
      NDSINC = NDSINC+1
      OPEN (NDSINC,FILE=FNAMER,ERR=803,STATUS='OLD')
      LSTEXC = .FALSE.
  130 CONTINUE
      READ (NDSINC,'(A)',END=190,ERR=190) NEWLNE
      ILINE1 = ILINE1 + 1
*
* switches
*
      FLKEEP = .TRUE.
      FLSWTC = .FALSE.
*
      IF ( NEWLNE(1:2).EQ.'!/' ) THEN
          FLKEEP = .FALSE.
          IF ( NEWLNE(3:3) .EQ. ' ' ) THEN
              FLSWTC = .TRUE.
              GOTO 141
            ENDIF
          DO 140, I=1, NSWTCH
            SW0    = SWITCH(I)
            J      = LS(I)
            IF ( NEWLNE( 3 :2+J) .EQ. SW0(1:J) ) THEN
                IF (  NEWLNE(3+J:3+J) .EQ. ' ' ) THEN
                    NEWLNE(1:MMLOUT) = NEWLNE(3+J:MMLOUT+3+J-1)
                    FLSWTC = .TRUE.
                    GOTO 141
                  ENDIF
                IF (  NEWLNE(3+J:3+J) .EQ. '/' ) THEN
                    NEWLNE(1:MMLOUT) = NEWLNE(4+J:MMLOUT+4+J-1)
                    FLSWTC = .TRUE.
                    GOTO 141
                  ENDIF
              ENDIF
  140       CONTINUE
  141     CONTINUE
        ENDIF
*
* keep line ...
*
      FLKEEP = FLKEEP .OR. FLSWTC
*
      IF (ICOMP.GE.1) FLKEEP = FLSWTC .OR. .NOT. (NEWLNE(1:1).EQ.'!')
      IF (ICOMP.GT.1) FLKEEP = FLKEEP .AND. (NEWLNE(1:2).NE.'!/')
*
      IF ( FLKEEP ) THEN
          DO 150 J=MMLOUT,1,-1
            LL     = J
            IF (NEWLNE(J:J).NE.' ') GOTO 151
 150        CONTINUE
 151      CONTINUE
*
          IF ( ICOMP.NE.0 .AND. .NOT.FLSWTC ) THEN
              QUOTES = .FALSE.
              DO 155 J=1,LL
                IF (.NOT.QUOTES .AND. NEWLNE(J-1:J-1).EQ.'!') GOTO 156
                IF (NEWLNE(J-1:J-1).EQ.'''') QUOTES = .NOT. QUOTES
 155            CONTINUE
 156          CONTINUE
              LL     = MIN ( J , LL )
            ENDIF
*
        ENDIF
*
      NOWEXC = NEWLNE(1:1).EQ.'!' .AND. LL.EQ.1
      FLKEEP = FLKEEP .AND. .NOT. (LSTEXC.AND.NOWEXC)
*
      IF (FLKEEP) THEN
          LSTEXC = NOWEXC
          ILINE2 = ILINE2 + 1
          IF (ILINE2.GT.MMLINE) THEN
              WRITE (*,*) '*** ERROR: TOO MANY INCLUDE LINES'
              STOP
            ENDIF
          INSTR(NFILES,ILINE2) = NEWLNE(1:MMLOUT)
*
* line length
*
          LENGTH(NFILES,ILINE2) = LL
        ENDIF
*
* next line
*
      GOTO 130
  190 CONTINUE
      NLINES(NFILES) = ILINE2
      WRITE (*,931) TEST0, FNAMER, ILINE1, ILINE2
*
      IF (ITEST.GE.2) THEN
          WRITE (*,9932) FNAMER
          DO 191, I=1,NLINES(NFILES)
            IF (ITEST.GE.3) THEN
                WRITE (*,9933) INSTR(NFILES,I)(1:LENGTH(NFILES,I)),
     &            ('.',J=LENGTH(NFILES,I)+1,72), '|'
              ELSE
                WRITE (*,9933) INSTR(NFILES,I)(1:72), '|'
              ENDIF
  191       CONTINUE
          WRITE (*,9934)
        ENDIF
*
* next include file
*
      GOTO 110
  200 CONTINUE
      IF (ITEST.GE.2) THEN
          WRITE (*,9999)
          STOP
        ENDIF
*
* Preprocessing finished, start processing file ------------------------
*
      NINP   = 0
      NOUT   = 0
      NINCL  = 0
      LSTEXC = .FALSE.
      IF (ITEST.GE.1) WRITE (*,9940)
  300 CONTINUE
      READ (NDSIN ,'(A)',END=400,ERR=400) NEWLNE
      NINP   = NINP + 1
*
      OLDLNE = NEWLNE
*
* switches
*
      FLKEEP = .TRUE.
      FLSWTC = .FALSE.
*
      IF ( NEWLNE(1:2).EQ.'!/' ) THEN
          FLKEEP = .FALSE.
          IF ( NEWLNE(3:3) .EQ. ' ' ) THEN
              FLSWTC = .TRUE.
              GOTO 311
            ENDIF
          DO 310, I=1, NSWTCH
            SW0    = SWITCH(I)
            J      = LS(I)
            IF ( NEWLNE( 3 :2+J) .EQ. SW0(1:J) ) THEN
                IF (  NEWLNE(3+J:3+J) .EQ. ' ' ) THEN
                    NEWLNE(1:MMLOUT) = NEWLNE(3+J:MMLOUT+3+J-1)
                    FLSWTC = .TRUE.
                    GOTO 311
                  ENDIF
                IF (  NEWLNE(3+J:3+J) .EQ. '/' ) THEN
                    NEWLNE(1:MMLOUT) = NEWLNE(4+J:MMLOUT+4+J-1)
                    FLSWTC = .TRUE.
                    GOTO 311
                  ENDIF
              ENDIF
  310       CONTINUE
  311     CONTINUE
        ENDIF
*
* include ???
*
      FLINCL = .FALSE.
      DO 330, J=1, NFILES
        IF (NEWLNE(1:IDLEN(J)).EQ.TSTSTR(J)(1:IDLEN(J))) THEN
            IF (ITEST.GE.1) THEN
                WRITE (*,9941) OLDLNE, NOLINE
                NOLINE(1 :32) = NOLINE( 2:33)
                NOLINE(33:33) = NOLINE( 3: 3)
              ENDIF
            DO 320, I=1,NLINES(J)
              WRITE (NDSOUT,'(A)') INSTR(J,I)(1:LENGTH(J,I))
  320         CONTINUE
            IF (ITEST.GE.1) THEN
                DO 321, I=1,NLINES(J)
                  WRITE (*,9941) NOLINE, INSTR(J,I)
                  NOLINE(1 :32) = NOLINE( 2:33)
                  NOLINE(33:33) = NOLINE( 3: 3)
  321             CONTINUE
              ENDIF
            FLINCL = .TRUE.
            NINCL  = NINCL + 1
            NINCF(J) = NINCF(J) + 1
            NOUT   = NOUT + NLINES(J)
            GOTO 331
          ENDIF
  330   CONTINUE
  331 CONTINUE
*
* keep line ...
*
      IF (.NOT.FLINCL) THEN
          FLKEEP = FLKEEP .OR. FLSWTC
*
          IF (ICOMP.GE.1) FLKEEP = FLSWTC .OR. .NOT.(NEWLNE(1:1).EQ.'!')
          IF (ICOMP.GT.1) FLKEEP = FLKEEP .AND. (NEWLNE(1:2).NE.'!/')
*
          IF ( FLKEEP ) THEN
              DO 350 J=MMLOUT,1,-1
                LL     = J
                IF (NEWLNE(J:J).NE.' ') GOTO 351
 350            CONTINUE
 351          CONTINUE
*
              IF ( ICOMP.NE.0 .AND. .NOT.FLSWTC ) THEN
                  QUOTES = .FALSE.
                  DO 355 J=1,LL
                    IF (.NOT.QUOTES .AND. NEWLNE(J-1:J-1).EQ.'!')
     &                    GOTO 356
                    IF (NEWLNE(J-1:J-1).EQ.'''') QUOTES = .NOT. QUOTES
 355                CONTINUE
 356              CONTINUE
                  LL     = MIN ( J , LL )
                ENDIF
*
            ENDIF
*
          NOWEXC = NEWLNE(1:1).EQ.'!' .AND. LL.EQ.1
          FLKEEP = FLKEEP .AND. .NOT. (LSTEXC.AND.NOWEXC)
*
          IF (FLKEEP) THEN
              LSTEXC = NOWEXC
*
* write line
*
              WRITE (NDSOUT,'(A)') NEWLNE(1:LL)
              NOUT   = NOUT + 1
              IF (ITEST.GE.1) WRITE (*,9941) OLDLNE, NEWLNE
*
            ELSE IF (ITEST.GE.1) THEN
              WRITE (*,9941) OLDLNE, NOLINE
              NOLINE(1 :32) = NOLINE( 2:33)
              NOLINE(33:33) = NOLINE( 3: 3)
            ENDIF
        ENDIF
*
* next line
*
      GOTO 300
  400 CONTINUE
*
* End of processing ----------------------------------------------------
*
      IF (ITEST.GE.1) WRITE (*,9942)
      WRITE (*,950) NINP, NOUT, NINCL
      IF (NINCL.NE.0) THEN
          WRITE (*,951)
          DO 410, J=1, NFILES
            IF (NINCF(J).NE.0) WRITE (*,952) NINCF(J), TSTSTR(J)
  410       CONTINUE
        ENDIF
*
      STOP ' '
*
* Error escape locations
*
  801 CONTINUE
      WRITE (*,*) '*** ERROR: OPENING INPUT FILE'
      STOP
*
  802 CONTINUE
      WRITE (*,*) '*** ERROR: OPENING OUTPUT FILE'
      STOP
*
  803 CONTINUE
      WRITE (*,*) '*** ERROR: OPENING INCLUDE FILE ', FNAMER
      STOP
*
* Formats
*
  900 FORMAT (/'  W3ADC, WAVEWATCH FORTRAN PREPROCESSING : '/
     &         ' =========================================='//
     &         '     ITEST =',I4/
     &         '     ICOMP =',I4)
  910 FORMAT ( '     INPUT FILE  : ',A/
     &         '     OUTPUT FILE : ',A)
  920 FORMAT ( '     NUMBER OF SWITCHES:',I4,'   SWITCHES :')
  921 FORMAT ( '        ',8(A,1X))
  922 FORMAT ( '     ',I4,'  >',A,'<')
  930 FORMAT (/'     INCLUDE FILES :'//
     &         '     ID_STRING             FILENAME    ',
     &         '                                 LINES '/
     &         '     ----------------------------------',
     &         '---------------------------------------')
  931 FORMAT ( '     ',A20,2X,A40,2X,2I4)
  950 FORMAT (/'     FINAL STATISTICS  : '/
     &         '        INPUT LINES    :',I6/
     &         '        OUTPUT LINES   :',I6/
     &         '        FILES INCLUDED :',I6,'  TOTAL')
  951 FORMAT ( '                         ------------------------',
     &                                      '--------------------')
  952 FORMAT ( '                        ',I6,2X,A)
*
 9930 FORMAT ( ' TEST W3ADC/3 : ',A,2X,A)
 9931 FORMAT ( ' TEST W3ADC/3 : ',I10)
 9932 FORMAT ( ' TEST W3ADC/2 : INCULDE FILE ',A/
     &         '   +------------------------------------',
     &         '------------------------------------+')
 9933 FORMAT ( '   |',73A)
 9934 FORMAT ( '   +------------------------------------',
     &         '------------------------------------+'/)
 9940 FORMAT (/' TEST W3ADC/1 '/
     &         '                 INPUT                  ',
     &         '                OUTPUT'/
     &         '   +---------------------------------+  ',
     &         '  +---------------------------------+')
 9941 FORMAT ( '   |',A33,'|    |',A33,'|')
 9942 FORMAT ( '   +---------------------------------+  ',
     &         '  +---------------------------------+')
 9999 FORMAT ( ' TEST W3ADC/2 : PROGRAM ENDED DUE TO VALUE OF ITEST'/)
*
* End of W3ADC  --------------------------------------------------------
*
      END

!------------------------------------------------------------------------------
module m_constants
!------------------------------------------------------------------------------
!
! physical constants
!
real grav    ! gravitational acceleration
real sqrtg   ! square root of grav
real gsq     ! square of grav
real nu      ! kinematic viscosity of water
!
real d_water ! density of water
real d_air   ! density of air
!
! mathematical constants
!
real pi     ! circular constant, 3.1415...
real pi2    ! 2*pi
real pih    ! pi/2
real dera   ! conversion from degrees to radians
real rade   ! conversion from radians to degrees
real expmin ! min argument for exp. function to avoid underflow
real expmax ! max argument for exp. function to avoid overflow
real sqrt2  ! square root of 2 ~ 1.41
!
contains
!
!------------------------------------------------------------------------------
subroutine init_constants
!------------------------------------------------------------------------------
!
pi   = 4.*atan(1.)
pi2  = 2.*pi
pih  = 0.5*pi
dera = pi/180.
rade = 180./pi
!
expmin = -20.
expmax =  20.
!
!  physical constants
!
grav    = 9.81
sqrtg   = sqrt(grav)
gsq     = grav*grav
nu      = 1.e-6
d_air   = 1.2
d_water = 1027
!
end subroutine
!
end module

!-----------------------------------------------------------------------------!
module m_fileio
!-----------------------------------------------------------------------------!
!
!   +-------+    ALKYON Hydraulic Consultancy & Research
!   |       |    Gerbrant van Vledder
!   |   +---+
!   |   | +---+  Last update: 8 Feb. 2003
!   +---+ |   |
!         +---+
!
! Module for storing file i/o related variables
!
! The values for the parameter i_log, i_prt and iw_tst must be set
! in one of the routines of the host program or in subroutine sys_init
!
! Version 1.1   29 May  2000   Initial version
!         1.2   21 Sep. 2001   Form=binary added (B)
!         1.3    5 Oct. 2001   Form=direct access, unformatted, fixed record (R)
!         1.4   24 Aug. 2002   Bug fixed and restructure of test output
!         1.5    8 Feb. 2003   Error check included when incorrect path (Z_FILEIO)
!
!-----------------------------------------------------------------------------!
! The following two parameters must be set by the user
! They define the overall test level and the output channel
!
integer,parameter :: i_print=0  ! (0/1/2)  Test output printing off/on
!                               ! Output channel defined by i_out
!
integer,parameter :: i_out=6    ! Output channel to screen
!                               ! ==1 screen output for Unix/Linux systems
!                               ! ==6 screen output for Windows
!------------------------------------------------------------------------------
!
! Standard switches to activate Logging, Test and Print ouput
!
integer i_log        ! (0/1)      Logging off/on
integer i_prt        ! (0/1)      Printing off/on
integer i_tst        ! (0,1,2...) Test level off/on
!
!
! Standard unit numbers of input & output files
!
integer lu_err  ! standard error file
integer lu_inp  ! standard input file
integer lu_log  ! standard logging
integer lu_prt  ! standard print output
integer lu_tst  ! standard test output
!
contains
!-----------------------------------------------------------------------------!
subroutine z_fileio(filename,qual,iufind,iunit,iostat)                        !
!-----------------------------------------------------------------------------!
!
!   +-------+    ALKYON Hydraulic Consultancy & Research
!   |       |    Gerbrant van Vledder
!   |   +---+
!   |   | +---+
!   +---+ |   |
!         +---+
!
implicit none
!
!  0. Update history
!
!     24/07/1999  First version
!     28/09/1999  Module name changed from FILEOPEN -> Z_FILEIO
!     27/10/1999  Option to delete an existing file added
!     18/11/1999  Argument IUNIT used to control use of Z_FLUNIT
!     22/11/1999  Parameter iunit not changed unless by z_flunit
!     28/12/1999  Interface with Z_FLUNIT updated and
!                 input parameter iufind added
!     14/04/2000  Module m_fileio included in this routine
!     25/05/2000  Module m_fileio excluded, if an already opened file is
!                 found, the corresponding unit number is assigned to output
!     21/09/2001  Form=binary added, extension to Fortran 95 standard
!      5/10/2001  Form=fixed Record length, as specified in input argument
!     17/06/2002  Initialisation of IUNIT=-1 included
!     24/08/2002  Bug fixed when routine called with IUFIND=0
!     08/02/2003  Bug fixed when file could not be created due to invalid path 
!
!  1. Purpose
!
!     Open file with name FILENAME and determine unit number IUNIT
!     With file type determined in QUAL
!
!     Depending on the value of IUFIND a search is performed for a
!     free unit number
!
!  2. Method
!
!     If file exists then
!       if QUAL = 'D'
!         delete file
!       Else
!         inquire if file opened
!         If opened
!           determine unit number
!         Else
!           If iunit >= 10 Find free unit number
!           Open file with unit number and file qualifier
!         End if
!       End if
!     Else
!       If QUAL='SNU'
!         If iunit >= 10 find free unit number
!         Open new file with unit number and qualifier
!       Else
!         Iunit = -1   File does not exist
!       End if
!     End if
!
!
!  3. Parameter list
!
!Type       I/O           Name           Description
!----------------------------------------------------
character(len=*), intent(in)  :: filename  ! File name
character(len=2), intent(in)  :: qual      ! File qualifyer
integer,   intent(in)         :: iufind    ! Indicator for search of unit number
integer,   intent(inout)      :: iunit     ! Unit number
integer,   intent(out)        :: iostat    ! Error indicator
!
!  4. Subroutines used
!
!     Z_FLUNIT
!
!  5. Error messages
!
!     IUNIT > 0    File exists, is (already) connected to unit number IUNIT, or is
!                  created and connected to unit number
!     IUNIT == 0   File has been deleted or does not exist
!           < 0    An error occurred, no file or unit number found
!
!     IOSTAT =  0   No errors detected
!              -1   Incorrect file qualifier
!              -2   Unit number does not exist
!              -3   Attempt to open non-existing file with status=OLD
!              -4   Attempt to open existing file with wrong FORMATTING
!              -5   Incorrect value for IUFIND: not in range [0,1]
!              -6   File could not be created due to,e.g. incorrect path
!
!  6. Remarks
!
!     1) Use of file qualifier:
!
!        1st char: O(ld),R(eplace),S(cratch),
!                  U(nknown),(D)elete
!        2nd char: F(ormatted),U(nformatted),B(inary)
!
!     2) Use of IUFIND
!
!        if IUFIND==0, No search is performed for a free unit number
!                 ==1, A search is performed in routine Z_FLUNIT
!
!     3) This routine is based on routine FOR from
!        SWAN version 40.00 of Delft University of Technology
!
!------------------------------------------------------------------------------
! Local variables
!
character(len=7)  :: cstat  ! string with status of file I/O
character(len=11) :: cform  ! string with format of file I/O
integer junit               ! temporary unit number
logical lexist              ! indicator if a file exists
logical lopen               ! indicator if a file is opened
integer iuerr               ! error indicator from Z_FLUNIT
!-------------------------------------------------------------------------------------
! initialisations
!-------------------------------------------------------------------------------------
iostat = 0
if(iufind==1) iunit  = -1
!
!
!  Check value of IUFIND
!
if(iufind/=0 .and. iufind/=1) then
  if(i_print >0) write(i_out,*) 'Z_FILEIO: Incorrect value for IUFIND:',iufind
  iostat = -5
  goto 9999
end if
!
!
!  check input argument QUAL
!
if(i_print>=1) write(i_out,*) 'Z_FILEIO/A:',trim(filename),' ',qual,iunit,iostat
!
if (index('ORSUD',qual(1:1)) ==0 .or. index('FUB',qual(2:2)) ==0) then
  if(i_print > 0) write(i_out,*) 'Incorrect file qualifier'
  iostat = -1
else
  if(qual(1:1) == 'O') cstat = 'old'
  if(qual(1:1) == 'R') cstat = 'replace'
  if(qual(1:1) == 'S') cstat = 'scratch'
  if(qual(1:1) == 'U') cstat = 'unknown'
  if(qual(1:1) == 'D') cstat = 'delete'
!
  if(qual(2:2) == 'F') cform = 'formatted'
  if(qual(2:2) == 'U') cform = 'unformatted'
  if(qual(2:2) == 'B') cform = 'binary'          ! extension to FORTRAN 95 standard
  if(qual(2:2) == 'R') cform = 'unformatted'
!
!  Check if file exists
!
  inquire(file=filename,exist=lexist)
  if(i_print >=2) write(i_out,*) 'Z_FILEIO  file exists?:',trim(filename),':',lexist
!
!  delete file if it exists and qual == 'D'
!
  if(lexist .and. qual(1:1)=='D') then
    inquire(file=filename,opened=lopen)
    if(lopen) then
      inquire(file=filename,number=junit)
    else
      if(iufind == 1) call z_flunit(iunit,iuerr)
      junit = iunit
      if(junit > 0) then
        open(file=filename,unit=junit,form=cform,iostat=iostat)
        if(iostat/=0) then
          iostat = -4
          goto 9999
        end if
      end if
    end if
    close(junit,status=cstat)
    goto 9999
  end if
!
!  if the file exists, check if it is opened
!
  if(lexist) then
    if(i_print >=2) write(i_out,*) 'Z_FILEIO: File exists:',trim(filename)
    inquire(file=filename,opened=lopen)
    if(lopen) then
      if(i_print >=2) write(i_out,*) 'Z_FILEIO: File is opened:',trim(filename)
!
!  determine unit number to which this file is connected
!  and assign it to the output number
!
      inquire(file=filename,number=junit)
      if(i_print >=2) write(i_out,*) 'Z_FILEIO: File is connected to unit:', junit
      iunit = junit
    else
!
!  if the file exists and not connected to a unit number, search a free unit number
!
      if(i_print >=2) write(i_out,*) 'Z_FILEIO: File is not connected to a unit number'
      if(iufind==0) then
        if(i_print >=2) write(i_out,*) 'Z_FILEIO: Assign user defined unit number:',iunit
      elseif(iufind==1) then
        call z_flunit(iunit,iuerr)
        if(i_print >=2) write(i_out,*) 'Z_FILEIO: New unit number IUNIT:',iunit
      end if
      junit = iunit
!
      if(junit > 0) then
        open(file=filename,unit=junit,form=cform,status=cstat)
      else
        iostat = -2
      end if
   end if
!
!  the file does not exist, so open it and find a free unit number
!
  else
!
    if(i_print>=2) then
       write(i_out,*) 'Z_FILEIO: File does not exist !'
       write(i_out,*) 'Z_FILEIO: Qual:',qual(1:1)
    end if
!
    if(index('SRU',qual(1:1)) > 0) then
      if(iufind==1) then
        call z_flunit(iunit,iuerr)
        if(i_print >=1) write(i_out,*) 'Z_FILEIO: New unit number IUNIT:',iunit
      end if
      junit = iunit
!
!  open file to IUNIT, if possible
!
      if(junit > 0) then
        open(file=filename,unit=junit,form=cform,iostat=iuerr)
!
! check added 8/2/2003
!
        if(iuerr/=0) then
          iunit = -1
          iostat = -6
        end if
      else
        iostat = -2
      end if
!
!  file cannot be opened because it does not exist
!
    elseif('O'==qual(1:1)) then   ! File should exist
      if(i_print>=2) write(i_out,*) 'Z_FILEIO: File cannot be opened because it does not exist'
      iostat = -3
    end if
  end if
end if
!
9999 continue
!
if(i_print>=1) write(i_out,*) 'Z_FILEIO/Z:',trim(filename),' ',qual,iunit,iostat
!
return
end  subroutine
!
!-----------------------------------------------------------------------------!
subroutine z_fclose(iunit)                                                    !
!-----------------------------------------------------------------------------!
!
!   +-------+    ALKYON Hydraulic Consultancy & Research
!   |       |    Gerbrant van Vledder
!   |   +---+
!   |   | +---+
!   +---+ |   |
!         +---+
!
implicit none
!
!  0. Update history
!
!     0.01 24/08/2000  First version
!
!  1. Purpose
!
!     Close file with unit number IUNIT, and set IUNIT=-1
!
!  2. Method
!
!
!  3. Parameter list
!
!Type       I/O           Name           Description
!-----------------------------------------------------------------------------
integer, intent(inout)  :: iunit          ! Unit number
!-----------------------------------------------------------------------------
close(iunit)
iunit = -1
!
return
end subroutine
!
!-----------------------------------------------------------------------------!
subroutine z_flunit(iunit,ierr)                                               !
!-----------------------------------------------------------------------------!
!
!   +-------+    ALKYON Hydraulic Consultancy & Research
!   |       |    Gerbrant van Vledder
!   |   +---+
!   |   | +---+
!   +---+ |   |
!         +---+
!
implicit none
!
!  0. Update history
!
!     Version   Date    Modification
!
!     0.01  24/07/1999  Initial version
!     0.02  01/10/1999  Extra check added to ensure maximum unit number
!     0.03  07/10/1999  Check of existence of uni number deleted,
!                       since this test produces different answer
!                       on Lahey compiler
!     0.04  25/11/1999  Intent added
!     0.05  24/12/1999  Module M_GENVAR added for information about range of unit numbers
!     0.06  27/12/1999  Module M_GENVAR replaced by M_FILEIO
!                       Check added for forbidden unit numbers
!     0.07  28/12/1999  Internal checks added and IERR added to parameter list
!     0.08  08/02/2000  User of lu_min & lu_max deleted
!     0.09  14/04/2000  Module m_fileio included in this routine
!
!  1. Purpose
!
!     Find a free unit number
!
!  2. Method
!
!     Starting at LU_MIN till LU_MAX are investigated until
!     a free (i.e. not connected to a file) is found.
!     Use is made of the standard fortran INQUIRE function.
!     The values of LU_MIN and LU_MAX should be specified
!     in an initialisation routine
!
!  3. Parameter list
!
!Type     I/O           Name         Description
!----------------------------------------------------------
integer, intent(out) :: iunit       ! resulting unit number
integer, intent(out) :: ierr        ! error level
!
!  4. Subroutines used
!
!     None
!
!  5. Error messages
!
!     ierr=0   No errors encountered
!          1   Invalud combination lu_low >= lu_high
!          2   Invalid value for lu_low
!          3   Invalid value for lu_high
!          4   No free unit number could be found
!
!  6. Remarks
!
!     If no free unit number if found in the range
!     lu_min - lu_high, then the function returns IUNIT = -1
!
!     The switch i_print can be used to generate test output
!
!----------------------------------------------------------------------------------
! local parameters
!
integer junit                       ! counter for unit numbers
logical lopen                       ! indicator if a unit number is connected to a file
logical lnot                        ! indicates if a forbidden unit number is checked
integer i_not                       ! counter to check forbidded unit numbers
!
!---------------------------------------------------------------------------------
!  range of unit numbers to search
!
integer, parameter :: lu_min=60     ! minimum unit number
integer, parameter :: lu_max=200    ! maximum unit number
!
! specification of forbidden unit numbers
!
integer, parameter :: lu_nr=3   ! number of forbidden unit numbers
integer lu_not(lu_nr)           ! list of forbidden unit numbers
!----------------------------------------------------------------------------------
lu_not(1) = 100
lu_not(2) = 101
lu_not(3) = 102
!-----------------------------------------------------------------------------------
!
ierr = 0
!
if(i_print >= 2) then
  write(i_out,*) 'Z_FLUNIT: forbidden     :',lu_not
  write(i_out,*) 'Z_FLUNIT: lu_min lu_max :',lu_min,lu_max
end if
!
!  check data specified in Module Z_FILEIO
!
if(lu_min >= lu_max) then
  ierr = 1
  write(i_out,*) 'Z_FLUNIT: Incorrect boundaries for LU_MIN & LU_MAX:',&
&            lu_min,lu_max
end if
!
junit = lu_min
!
iunit = -1
!
do while (iunit ==-1)
!
! Check if unit number is free, i.e. not in use by an opened file
!
   inquire(unit=junit,opened=lopen)
!
!  check if unit number is not a forbidden unit number
!
   lnot = .false.
   do i_not=1,lu_nr
     if(lu_not(i_not)==junit) then
       lnot = .true.
       if(i_print >= 1) write(i_out,*) 'Z_FLUNIT: a forbidden unit number was encountered:',junit
     end if
   end do
!
   if(lopen.or.lnot) then
      junit = junit + 1
   else
      iunit = junit
   end if
   if(junit > lu_max) exit
end do
!
if(iunit < 0) then
  write(i_out,*) 'ERROR in Z_FLUNIT: No free unit number could be found'
end if
!
return
end subroutine
!
end module

!|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||

 module SCRIP_KindsMod

!BOP
! !MODULE: SCRIP_KindsMod
!
! !DESCRIPTION:
! This module defines default numerical data types for all common data
! types like integer, character, logical, real4 and real8.
!
! !USERDOC:
! Users should not need to adjust anything in this module. If various
! character strings like long paths to files exceed the default
! character length, the default value may be increased.
!
! !REFDOC:
! This module is supplied to provide consistent data representation
! across machine architectures. It is meant to replace the old
! Fortran double precision and real *X declarations that were
! implementation-specific.
! Users should not need to adjust anything in this module. If various
! character strings like long paths to files exceed the default
! character length, the default value may be increased.
!
! !REVISION HISTORY:
! SVN:$Id: SCRIP_KindsMod.F90 82 2008-02-14 19:36:07Z pwjones $

! !USES:
! uses no other modules

   implicit none
   private
   save

! !DEFINED PARAMETERS:

   integer, parameter, public :: &
      SCRIP_CharLength = 100 ,&
      SCRIP_Logical = kind(.true.) ,&
      SCRIP_i4 = selected_int_kind(6) ,&
      SCRIP_i8 = selected_int_kind(13) ,&
      SCRIP_r4 = selected_real_kind(6) ,&
      SCRIP_r8 = selected_real_kind(13) ,&
      SCRIP_r16 = selected_real_kind(26)

!EOP
!BOC
!EOC
!***********************************************************************

 end module SCRIP_KindsMod

!|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||

!|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||

 module SCRIP_IOUnitsMod

!BOP
!
! !MODULE: SCRIP_IOUnitsMod
!
! !DESCRIPTION:
! This module contains an I/O unit manager for tracking, assigning
! and reserving I/O unit numbers.
!
! There are three reserved I/O units set as parameters in this
! module. The default units for standard input (stdin), standard
! output (stdout) and standard error (stderr). These are currently
! set as units 5,6,6, respectively as that is the most commonly
! used among vendors. However, the user may change these if those
! default units are conflicting with other models or if the
! vendor is using different values.
!
! The maximum number of I/O units per node is currently set by
! the parameter SCRIP\_IOMaxUnits.
!
! !REFDOC:
!
! !REVISION HISTORY:
! SVN:$Id: SCRIP_IOUnitsMod.F90 83 2008-02-22 17:26:54Z pwjones $

! !USES:

   use SCRIP_KindsMod

   implicit none
   private
   save

! !PUBLIC MEMBER FUNCTIONS:

   public :: SCRIP_IOUnitsGet, &
             SCRIP_IOUnitsRelease, &
             SCRIP_IOUnitsReserve, &
             SCRIP_IOUnitsRedirect, &
             SCRIP_IOUnitsFlush

! !PUBLIC DATA MEMBERS:

   integer (SCRIP_i4), parameter, public :: &
      SCRIP_stdin = 5, &! reserved unit for standard input
      SCRIP_stdout = 6, &! reserved unit for standard output
      SCRIP_stderr = 6 ! reserved unit for standard error

   ! common formats for writing to stdout, stderr

   character (9), parameter, public :: &
      SCRIP_delimFormat = "(72('-'))"

   character (5), parameter, public :: &
      SCRIP_blankFormat = "(' ')"

!EOP
!BOC
!-----------------------------------------------------------------------
!
! private io unit manager variables
!
!-----------------------------------------------------------------------

   integer (SCRIP_i4), parameter :: &
      SCRIP_IOUnitsMinUnits = 11, & ! do not use unit numbers below this
      SCRIP_IOUnitsMaxUnits = 99 ! maximum number of open units

   logical (SCRIP_Logical) :: &
      SCRIP_IOUnitsInitialized = .false.

   logical (SCRIP_Logical), dimension(SCRIP_IOUnitsMaxUnits) :: &
      SCRIP_IOUnitsInUse ! flag=.true. if unit currently open

!EOC
!***********************************************************************

contains

!***********************************************************************
!BOP
! !IROUTINE: SCRIP_IOUnitsGet
! !INTERFACE:

 subroutine SCRIP_IOUnitsGet(iunit)

! !DESCRIPTION:
! This routine returns the next available i/o unit and marks it as
! in use to prevent any later use.
! Note that {\em all} processors must call this routine even if only
! the master task is doing the i/o. This is necessary insure that
! the units remain synchronized for other parallel I/O functions.
!
! !REVISION HISTORY:
! same as module

! !OUTPUT PARAMETERS:

   integer (SCRIP_i4), intent(out) :: &
      iunit ! next free i/o unit

!EOP
!BOC
!-----------------------------------------------------------------------
!
! local variables
!
!-----------------------------------------------------------------------

   integer (SCRIP_i4) :: n ! dummy loop index

   logical (SCRIP_Logical) :: alreadyInUse

!-----------------------------------------------------------------------
!
! check to see if units initialized and initialize if necessary
!
!-----------------------------------------------------------------------

   if (.not. SCRIP_IOUnitsInitialized) then
      SCRIP_IOUnitsInUse = .false.
      SCRIP_IOUnitsInUse(SCRIP_stdin) = .true.
      SCRIP_IOUnitsInUse(SCRIP_stdout) = .true.
      SCRIP_IOUnitsInUse(SCRIP_stderr) = .true.

      SCRIP_IOUnitsInitialized = .true.
   endif

!-----------------------------------------------------------------------
!
! find next free unit
!
!-----------------------------------------------------------------------

   srch_units: do n=SCRIP_IOUnitsMinUnits, SCRIP_IOUnitsMaxUnits
      if (.not. SCRIP_IOUnitsInUse(n)) then ! I found one, I found one

         !*** make sure not in use by library or calling routines
         INQUIRE (unit=n,OPENED=alreadyInUse)

         if (.not. alreadyInUse) then
            iunit = n ! return the free unit number
            SCRIP_IOUnitsInUse(iunit) = .true. ! mark iunit as being in use
            exit srch_units
         else
            !*** if inquire shows this unit in use, mark it as
            !*** in use to prevent further queries
            SCRIP_IOUnitsInUse(n) = .true.
         endif
      endif
   end do srch_units

   if (iunit > SCRIP_IOUnitsMaxUnits) &
      stop 'SCRIP_IOUnitsGet: No free units'

!-----------------------------------------------------------------------
!EOC

 end subroutine SCRIP_IOUnitsGet

!***********************************************************************
!BOP
! !IROUTINE: SCRIP_IOUnitsRelease
! !INTERFACE:

 subroutine SCRIP_IOUnitsRelease(iunit)

! !DESCRIPTION:
! This routine releases an i/o unit (marks it as available).
! Note that {\em all} processors must call this routine even if only
! the master task is doing the i/o. This is necessary insure that
! the units remain synchronized for other parallel I/O functions.
!
! !REVISION HISTORY:
! same as module

! !INPUT PARAMETER:

   integer (SCRIP_i4), intent(in) :: &
      iunit ! i/o unit to be released

!EOP
!BOC
!-----------------------------------------------------------------------
!
! check for proper unit number
!
!-----------------------------------------------------------------------

   if (iunit < 1 .or. iunit > SCRIP_IOUnitsMaxUnits) then
      stop 'SCRIP_IOUnitsRelease: bad unit'
   endif

!-----------------------------------------------------------------------
!
! mark the unit as not in use
!
!-----------------------------------------------------------------------

   SCRIP_IOUnitsInUse(iunit) = .false. ! that was easy...

!-----------------------------------------------------------------------
!EOC

 end subroutine SCRIP_IOUnitsRelease

!***********************************************************************
!BOP
! !IROUTINE: SCRIP_IOUnitsReserve
! !INTERFACE:

 subroutine SCRIP_IOUnitsReserve(iunit)

! !DESCRIPTION:
! This routine marks an IO unit as in use to reserve its use
! for purposes outside of SCRIP IO. This is necessary for
! cases where you might be importing code developed elsewhere
! that performs its own I/O and open/closes units.
! Note that {\em all} processors must call this routine even if only
! the master task is doing the i/o. This is necessary insure that
! the units remains synchronized for other parallel I/O functions.
!
! !REVISION HISTORY:
! same as module

! !INPUT PARAMETER:

   integer (SCRIP_i4), intent(in) :: &
      iunit ! i/o unit to be reserved

!EOP
!BOC
!-----------------------------------------------------------------------
!
! local variables
!
!-----------------------------------------------------------------------

   logical (SCRIP_Logical) :: alreadyInUse

!-----------------------------------------------------------------------
!
! check for proper unit number
!
!-----------------------------------------------------------------------

   if (iunit < SCRIP_IOUnitsMinUnits .or. &
       iunit > SCRIP_IOUnitsMaxUnits) then
      stop 'SCRIP_IOUnitsReserve: invalid unit'
   endif

!-----------------------------------------------------------------------
!
! check to see if SCRIP already using this unit
!
!-----------------------------------------------------------------------

   if (SCRIP_IOUnitsInUse(iunit)) then
      stop 'SCRIP_IOUnitsReserve: unit already in use by SCRIP'
   endif

!-----------------------------------------------------------------------
!
! check to see if others already using this unit
!
!-----------------------------------------------------------------------

   INQUIRE (unit=iunit, OPENED=alreadyInUse)
   if (alreadyInUse) then
      stop 'SCRIP_IOUnitsReserve: unit already in use by others'
   endif

!-----------------------------------------------------------------------
!
! mark the unit as in use
!
!-----------------------------------------------------------------------

   SCRIP_IOUnitsInUse(iunit) = .true.

!-----------------------------------------------------------------------
!EOC

 end subroutine SCRIP_IOUnitsReserve

!***********************************************************************
!BOP
! !IROUTINE: SCRIP_IOUnitsRedirect
! !INTERFACE:

 subroutine SCRIP_IOUnitsRedirect(iunit, filename)

! !DESCRIPTION:
! This routine enables a user to redirect stdin, stdout, stderr to
! a file instead of to the terminal. It is only permitted for these
! special units. The SCRIP IO file operators should be used for
! normal I/O.
! Note that {\em all} processors must call this routine even if only
! the master task is doing the i/o. This is necessary insure that
! the units remains synchronized for other parallel I/O functions.
!
! !REVISION HISTORY:
! same as module

! !INPUT PARAMETER:

   integer (SCRIP_i4), intent(in) :: &
      iunit ! i/o unit to be redirected to file

   character (*), intent(in) :: &
      filename ! filename, including path, to which
                               ! i/o should be directed

!EOP
!BOC
!-----------------------------------------------------------------------
!
! check for proper unit number and open file
!
!-----------------------------------------------------------------------

   if (iunit == SCRIP_stdin) then ! open input file for stdin
      open(unit=iunit, file=filename, status='old', form='formatted')

   else if (iunit == SCRIP_stdout) then ! open output file for stdout
      open(unit=iunit, file=filename, status='unknown', form='formatted')

   else if (iunit == SCRIP_stderr .and. SCRIP_stderr /= SCRIP_stdout) then
      ! open output file for stderr
      open(unit=iunit, file=filename, status='unknown', form='formatted')

   else
      stop 'SCRIP_IOUnitsRedirect: invalid unit'

   endif

!-----------------------------------------------------------------------
!EOC

 end subroutine SCRIP_IOUnitsRedirect

!***********************************************************************
!BOP
! !IROUTINE: SCRIP_IOUnitsFlush
! !INTERFACE:

 subroutine SCRIP_IOUnitsFlush(iunit)

! !DESCRIPTION:
! This routine enables a user to flush the output from an IO unit
! (typically stdout) to force output when the system is buffering
! such output. Because this system function is system dependent,
! we only support this wrapper and users are welcome to insert the
! code relevant to their local machine.
!
! !REVISION HISTORY:
! same as module

! !INPUT PARAMETER:

   integer (SCRIP_i4), intent(in) :: &
      iunit ! i/o unit to be flushed

!EOP
!BOC
!-----------------------------------------------------------------------
!
! insert your system code here
!
!-----------------------------------------------------------------------

!-----------------------------------------------------------------------
!EOC

 end subroutine SCRIP_IOUnitsFlush

!***********************************************************************

 end module SCRIP_IOUnitsMod

!|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
!     This routine reads remapping information from files written
!     by remap_setup.  If remapping in both directions are required,
!     two input files must be specified.
!
!-----------------------------------------------------------------------
!
!     CVS:$Id: remap_read.f,v 1.6 2000/04/19 21:56:26 pwjones Exp $
!
!     Copyright (c) 1997, 1998 the Regents of the University of 
!       California.
!
!     This software and ancillary information (herein called software) 
!     called SCRIP is made available under the terms described here.  
!     The software has been approved for release with associated 
!     LA-CC Number 98-45.
!
!     Unless otherwise indicated, this software has been authored
!     by an employee or employees of the University of California,
!     operator of the Los Alamos National Laboratory under Contract
!     No. W-7405-ENG-36 with the U.S. Department of Energy.  The U.S.
!     Government has rights to use, reproduce, and distribute this
!     software.  The public may copy and use this software without
!     charge, provided that this Notice and any statement of authorship
!     are reproduced on all copies.  Neither the Government nor the
!     University makes any warranty, express or implied, or assumes
!     any liability or responsibility for the use of this software.
!
!     If software is modified to produce derivative works, such modified
!     software should be clearly marked, so as not to confuse it with 
!     the version available from Los Alamos National Laboratory.
!
!     This code has been modified from the version available from 
!     Los Alamos National Laboratory, for the purpose of running it
!     within WW3.
!
!***********************************************************************

      module scrip_remap_read 

!-----------------------------------------------------------------------
!
!     contains routines for reading a remap file
!
!-----------------------------------------------------------------------

      use SCRIP_KindsMod   ! defines common data types
      use SCRIP_ErrorMod   ! SCRIP error handler
      use SCRIP_NetcdfMod  ! netCDF error handler
      use netcdf           ! netCDF library

      use SCRIP_constants  ! defines common scalar constants
      use scrip_grids      ! module containing grid information
      use scrip_remap_vars ! module containing remap information

      implicit none

!-----------------------------------------------------------------------
!
!     module variables
!
!-----------------------------------------------------------------------


      character(SCRIP_charLength), private :: 
     &   map_method       ! character string for map_type
     &,  normalize_opt    ! character string for normalization option
     &,  convention       ! character string for output convention

!-----------------------------------------------------------------------
!
!     various netCDF ids for files variables
!
!-----------------------------------------------------------------------

      integer (SCRIP_i4), private ::
     &   ncstat                ! error flag for netCDF calls
     &,  nc_file_id            ! id for netCDF file
     &,  nc_srcgrdsize_id      ! id for source grid size
     &,  nc_dstgrdsize_id      ! id for destination grid size
     &,  nc_srcgrdcorn_id      ! id for number of source grid corners
     &,  nc_dstgrdcorn_id      ! id for number of dest grid corners
     &,  nc_srcgrdrank_id      ! id for source grid rank
     &,  nc_dstgrdrank_id      ! id for dest grid rank
     &,  nc_numlinks_id        ! id for number of links in mapping
     &,  nc_numwgts_id         ! id for number of weights for mapping
     &,  nc_srcgrddims_id      ! id for source grid dimensions
     &,  nc_dstgrddims_id      ! id for dest grid dimensions,
     &,  nc_srcgrdcntrlat_id   ! id for source grid center latitude
     &,  nc_dstgrdcntrlat_id   ! id for dest grid center latitude
     &,  nc_srcgrdcntrlon_id   ! id for source grid center longitude
     &,  nc_dstgrdcntrlon_id   ! id for dest grid center longitude
     &,  nc_srcgrdimask_id     ! id for source grid mask
     &,  nc_dstgrdimask_id     ! id for dest grid mask
     &,  nc_srcgrdcrnrlat_id   ! id for latitude of source grid corners
     &,  nc_srcgrdcrnrlon_id   ! id for longitude of source grid corners
     &,  nc_dstgrdcrnrlat_id   ! id for latitude of dest grid corners
     &,  nc_dstgrdcrnrlon_id   ! id for longitude of dest grid corners
     &,  nc_srcgrdarea_id      ! id for area of source grid cells
     &,  nc_dstgrdarea_id      ! id for area of dest grid cells
     &,  nc_srcgrdfrac_id      ! id for area fraction on source grid
     &,  nc_dstgrdfrac_id      ! id for area fraction on dest grid
     &,  nc_srcgrdadd_id       ! id for map source address
     &,  nc_dstgrdadd_id       ! id for map dest address
     &,  nc_rmpmatrix_id       ! id for remapping matrix

!***********************************************************************

      contains

!***********************************************************************

      subroutine read_remap_ww3(map_name, interp_file, errorCode)

!-----------------------------------------------------------------------
!
!     this driver routine reads some global attributes and then
!     calls a specific read routine based on file conventions
!
!-----------------------------------------------------------------------

!-----------------------------------------------------------------------
!
!     input variables
!
!-----------------------------------------------------------------------

      character(SCRIP_CharLength), intent(in) ::
     &            interp_file  ! filename for remap data

!-----------------------------------------------------------------------
!
!     output variables
!
!-----------------------------------------------------------------------

      character(SCRIP_CharLength), intent(out) ::
     &            map_name     ! name for mapping

!-----------------------------------------------------------------------
!
!     local variables
!
!-----------------------------------------------------------------------

      integer (SCRIP_i4) ::  
     &  errorCode            ! error code for SCRIP routine

      character (14), parameter :: 
     &  rtnName = 'read_remap_ww3'

!-----------------------------------------------------------------------
!
!     open file and read some global information
!
!-----------------------------------------------------------------------

      ncstat = nf90_open(interp_file, NF90_NOCLOBBER, nc_file_id)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName, 'error
     &   opening interpolation file')) return

      !***
      !*** map name
      !***
      map_name = ' '
      ncstat = nf90_get_att(nc_file_id, NF90_GLOBAL, 'title',
     &                         map_name)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName, 'error
     &   reading map name')) return


      !***
      !*** normalization option
      !***
      normalize_opt = ' '
      ncstat = nf90_get_att(nc_file_id, NF90_GLOBAL, 'normalization',
     &                         normalize_opt)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName, 'error
     &   reading interpolation option')) return

      select case(normalize_opt)
      case ('none')
        norm_opt = norm_opt_none
      case ('fracarea')
        norm_opt = norm_opt_frcarea
      case ('destarea')
        norm_opt = norm_opt_dstarea
      case default
        print *,'normalize_opt = ',normalize_opt
        stop 'Invalid normalization option'
      end select

      !***
      !*** map method
      !***
      map_method = ' '
      ncstat = nf90_get_att (nc_file_id, NF90_GLOBAL, 'map_method',
     &                          map_method)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName, 'error
     &   reading map method')) return

      select case(map_method)
      case('Conservative remapping')
        map_type = map_type_conserv
      case('Bilinear remapping')
        map_type = map_type_bilinear
      case('Distance weighted avg of nearest neighbors')
        map_type = map_type_distwgt
      case('Bicubic remapping')
        map_type = map_type_bicubic
      case default
        print *,'map_type = ',map_method
        stop 'Invalid Map Type'
      end select

      !***
      !*** file convention
      !***
      convention = ' '
      ncstat = nf90_get_att (nc_file_id, NF90_GLOBAL, 'conventions',
     &                          convention)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName, 'error
     &   reading file convention')) return

!-----------------------------------------------------------------------
!
!     call appropriate read routine based on output convention
!
!-----------------------------------------------------------------------

      select case(convention)
      case ('SCRIP')
        call read_remap_scrip_ww3
      case ('NCAR-CSM')
        print *,'convention = NCAR-CSM not supported for WW3'
        stop 'unsupported file convention'
!       call read_remap_csm
      case default
        print *,'convention = ',convention
        stop 'unknown output file convention'
      end select

!-----------------------------------------------------------------------

      end subroutine read_remap_ww3

!***********************************************************************

      subroutine read_remap_scrip_ww3

!-----------------------------------------------------------------------
!
!     the routine reads a netCDF file to extract remapping info
!     in SCRIP format
!
!     Only read variables needed by WW3
!
!-----------------------------------------------------------------------
!-----------------------------------------------------------------------
!
!     local variables
!
!-----------------------------------------------------------------------

      character (SCRIP_charLength) ::
     &  grid1_name           ! grid name for source grid
     &, grid2_name           ! grid name for dest   grid

      integer (SCRIP_i4) ::  
     &  n                    ! dummy index
     &, errorCode            ! error code for SCRIP routine

      integer (SCRIP_i4), dimension(:), allocatable ::
     &  grid1_mask_int,      ! integer masks to determine
     &  grid2_mask_int       ! cells that participate in map

      character (20), parameter :: 
     &  rtnName = 'read_remap_scrip_ww3'

!-----------------------------------------------------------------------
!
!     read some additional global attributes
!
!-----------------------------------------------------------------------

      !***
      !*** source and destination grid names
      !***

      grid1_name = ' '
      grid2_name = ' '
      errorCode = SCRIP_Success
      ncstat = nf90_get_att (nc_file_id, NF90_GLOBAL, 'source_grid',
     &                          grid1_name)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName, 'error 
     &   reading source grid name')) return

      ncstat = nf90_get_att (nc_file_id, NF90_GLOBAL, 'dest_grid',
     &                          grid2_name)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName, 'error
     &   reading destination grid name')) return

! Let's not include routine write statements w/out check on improc, l_master, etc.
!     print *,' '
!     print *,'Remapping between:',trim(grid1_name)
!     print *,'and ',trim(grid2_name)
!     print *,' '

!-----------------------------------------------------------------------
!
!     read dimension information
!
!-----------------------------------------------------------------------

      ncstat = nf90_inq_dimid(nc_file_id, 'dst_grid_size', 
     &                      nc_dstgrdsize_id)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName, 'error
     &   reading destination grid id')) return
!     ncstat = nf90_inq_dimlen(nc_file_id, nc_dstgrdsize_id, grid2_size)
      ncstat = nf90_inquire_dimension(nc_file_id, nc_dstgrdsize_id, 
     &                                len = grid2_size)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName, 'error
     &   reading destination grid size')) return

      ncstat = nf90_inq_dimid(nc_file_id, 'num_links', 
     &                      nc_numlinks_id)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName, 'error
     &   reading number of links id')) return
!     ncstat = nf90_inq_dimlen(nc_file_id, nc_numlinks_id, 
!    &                       num_links_map1)
      ncstat = nf90_inquire_dimension(nc_file_id, nc_numlinks_id, 
     &                                len = num_links_map1)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName, 'error
     &   reading number of links')) return
      max_links_map1 = num_links_map1

      ncstat = nf90_inq_dimid(nc_file_id, 'num_wgts', 
     &                      nc_numwgts_id)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName, 'error
     &   reading number of weights id')) return
!     ncstat = nf90_inq_dimlen(nc_file_id, nc_numwgts_id, num_wts)
      ncstat = nf90_inquire_dimension(nc_file_id, nc_numwgts_id, 
     &                                len = num_wts)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName, 'error
     &   reading number of weights')) return

!-----------------------------------------------------------------------
!
!     allocate arrays
!
!-----------------------------------------------------------------------

! grid2_frac is allocated in grid_init
      if(allocated(grid2_frac))deallocate(grid2_frac)
      allocate( grid2_frac      (grid2_size) )

! grid1_add_map1, grid2_add_map1, wts_map1 are allocated in init_remap_vars
      if(allocated(grid1_add_map1))deallocate(grid1_add_map1)
      if(allocated(grid2_add_map1))deallocate(grid2_add_map1)
      if(allocated(wts_map1))deallocate(wts_map1)
      allocate( grid1_add_map1(num_links_map1),
     &          grid2_add_map1(num_links_map1),
     &          wts_map1(num_wts,num_links_map1) )

!-----------------------------------------------------------------------
!
!     get variable ids
!
!-----------------------------------------------------------------------

      ncstat = nf90_inq_varid(nc_file_id, 'dst_grid_frac', 
     &                                   nc_dstgrdfrac_id)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName, 'error
     &   reading destination grid fraction id')) return

      ncstat = nf90_inq_varid(nc_file_id, 'src_address', 
     &                                   nc_srcgrdadd_id)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName, 'error
     &   reading source grid address id')) return

      ncstat = nf90_inq_varid(nc_file_id, 'dst_address', 
     &                                   nc_dstgrdadd_id)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName, 'error
     &   reading destination grid address id')) return

      ncstat = nf90_inq_varid(nc_file_id, 'remap_matrix', 
     &                                   nc_rmpmatrix_id)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName, 'error
     &   reading remap matrix id')) return

!-----------------------------------------------------------------------
!
!     read all variables
!
!-----------------------------------------------------------------------

      ncstat = nf90_get_var(nc_file_id, nc_dstgrdfrac_id, 
     &                                       grid2_frac)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName, 'error
     &   reading destination grid fraction')) return

      ncstat = nf90_get_var(nc_file_id, nc_srcgrdadd_id, 
     &                        grid1_add_map1)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName, 'error
     &   reading source grid address')) return

      ncstat = nf90_get_var(nc_file_id, nc_dstgrdadd_id, 
     &                        grid2_add_map1)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName, 'error
     &   reading destination grid address')) return

      ncstat = nf90_get_var(nc_file_id, nc_rmpmatrix_id, 
     &                                       wts_map1)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName, 'error
     &   reading remap weights')) return


      ncstat = nf90_close(nc_file_id)
      if (SCRIP_NetcdfErrorCheck(ncstat, errorCode, rtnName, 'error
     &   closing netCDF file')) return

!-----------------------------------------------------------------------

      end subroutine read_remap_scrip_ww3

!***********************************************************************

      end module scrip_remap_read

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!*********************************************************************
MODULE RKPARAM          !parameters for Runge Kutta solver
   REAL,DIMENSION(3) :: yscal
   REAL h1,hmin,eps
   REAL co,freq,dl
   INTEGER,PARAMETER :: ndim=3
END MODULE RKPARAM
!*********************************************************************
MODULE BATHYGRID          !bottom topography grid
   REAL    rlonmax,rlonmin,rlatmin,rlatmax,rot
   INTEGER                          nx,ny,ip,jp
   REAL                             sx,sy,deltaz
   REAL(kind=4), TARGET ,DIMENSION(:,:),ALLOCATABLE :: grid, U, V
   REAL(kind=4), TARGET ,DIMENSION(1,6)             :: gride,Ue, Ve
   REAL(kind=4), TARGET ,DIMENSION(1,12)            :: gridd,Ud,Vd
END MODULE BATHYGRID
!*********************************************************************
MODULE Raytraj         !bottom topography grid
   real xch(1500),ych(1500),ach(1500)
   INTEGER nchunk
   REAL timestep,depthmin,depthmax
END MODULE Raytraj
!*********************************************************************
MODULE Constants
   REAL,    PARAMETER :: pi = 3.14159265,tpi=6.2831853,d2r=.01745329
   REAL,    PARAMETER :: max15bit=32768.,max8bit=256.,max7bit=128.
   REAL,    PARAMETER :: max14bit=16384.
   INTEGER, PARAMETER :: i15bit=32768,i8bit=256,i7bit=128,i14bit=16384
   REAL,    PARAMETER :: g =  9.81          !gravity       : SI  (m/s^2)
   REAL,    PARAMETER :: rhow =  1026.      !water density : SI  (kg/m^3)
   REAL,    PARAMETER :: kappa = 0.4        !Von Karman's constant
   REAL,    PARAMETER :: nu  = 3.E-6        !Salt water kinematic viscosity
   REAL, DIMENSION(:),ALLOCATABLE  ::invxtanhx
   REAL, DIMENSION(:,:),ALLOCATABLE  ::invxtanhxc
   INTEGER ntanh,ncur
END MODULE Constants

!**********************************************************************
SUBROUTINE tfact(depth,f,fact,fact2)
!... calculates the transformation factor (dk/dko)*(cgo/cg)
!... to avoid floating point exception in sinh, max value of sig=75
!... first get wave no. and group velocity at transformation site
   IMPLICIT NONE
   REAL,                INTENT(in)     ::depth,f
   REAL,                INTENT(out)    ::fact,fact2
   REAL d,dk,c,cg,dk0,c0,cg0
   
   CALL disp(depth,f,dk,c,cg)
   d=800.
   CALL disp(d,f,dk0,c0,cg0)
   fact=(dk/dk0)*(cg0/cg)
   fact2=(dk/cg)
   RETURN
END


!*********************************************************************
SUBROUTINE ref(xs,ys,as,iflag)
!*********************************************************************
! This routine integrates the ray equations (using the Cash-Karp Runge-Kutta
! driver RKdriver, from the initial position (xs,ys) until it crosses into a
! different zone. The subroutine returns the position and direction of the
! ray at the zone boundary.
!
! If the Fsource flag is equal to 1 then the routine also computes linear interpolation
! coefficents from the grid points. These coefficients are weighted by the propagation time.
! In order to do that the routine keeps track of the current timestep,
! direction bin and triangle. If any of these change then a new set of
! interpolation coefficients is generated. If not, the coefficients are updated
! and are given more weight. This is checked at every mini-timestep (h1) of the
! RKdriver.
!
! When the zone boundary is reached, coefficents are genrated in order 
! to be able to interpolate energy density from the neighboring grid 
! points at the end of the ray.  
!*********************************************************************
   USE BATHYGRID
   USE Constants
   USE Raytraj
   USE RKPARAM
   IMPLICIT NONE
      
   REAL,INTENT(inout)         :: xs,ys,as !start position (grid units) and angle (rad)
   INTEGER,INTENT(out)     :: iflag    !IFlag=0 hit land or cross-shelf boundary, 

   REAL x1,x2,tchunk,dt1
   REAL yrad(3)            ! current x,y, and angle
   INTEGER kchunk,nstep

      !WRITE(6,*) 'xs ....',xs,ys,as,iflag
      yrad(1)=xs
      yrad(2)=ys
      yrad(3)=as
   
      tchunk=0.
      IFlag=2
      nchunk=0
   
! Starts first chunk
            nchunk=nchunk+1
            xch(nchunk)=yrad(1)*sx/1000.
            ych(nchunk)=yrad(2)*sy/1000.
            ach(nchunk)=yrad(3)*180/pi

      CALL RKdriver(yrad) !take a step
      dt1=h1/(60.)                 !time = time step * (C / Cg)
      tchunk=dt1
      kchunk=1
      
      DO nstep=1,100000
         CALL RKdriver(yrad) !take a step
         tchunk=tchunk+dt1
         !WRITE(6,*) 'STEP:',nstep,yrad(1),yrad(2),yrad(3) 
         
         IF (tchunk.GT.timestep) THEN     !timestep change
            nchunk=nchunk+1
            xch(nchunk)=yrad(1)*sx/1000.
            ych(nchunk)=yrad(2)*sy/1000.
            ach(nchunk)=yrad(3)*180/pi
            tchunk=tchunk-timestep
         ENDIF

         IF (yrad(1).lt.10.or.yrad(1).gt.nx-10) IFlag=0
         IF (yrad(2).lt.10.or.yrad(2).gt.ny-10) IFlag=0
         IF (dl.gt.depthmax) IFlag=1
         IF (dl.lt.depthmin) IFlag=0
         IF (iflag.eq.0.or.iflag.eq.1) THEN
         !   WRITE(6,*) 'FLAGG:',dl,depthmin,nchunk*timestep+tchunk
            nchunk=nchunk+1
            xch(nchunk)=yrad(1)*sx/1000.
            ych(nchunk)=yrad(2)*sy/1000.
            ach(nchunk)=yrad(3)*180/pi
            RETURN
         ENDIF
      ENDDO    !end of do loop on nstep
      print *,' error - too many steps '
      !stop   
      RETURN
      end


!**********************************************************************
SUBROUTINE RKdriver(ystart)
!     Integrates the 3 starting variables from 0 to h1
!     with accuracy eps.  h1 is a guess of the step size, hmin is the
!     min step size (0 is ok) ystart is overwritten with the desired
!     answer
!     yscal is a vector containing the typical scales of each variable
!     these scales define the admissible errors: eps*yscal(i)
!**********************************************************************
!  The Cash-Karp Runge Kutta solver is adapted to this specific problem
!  by Fabrice Ardhuin, june 1999, from Numerical Recipes, 2nd ed.
!**********************************************************************
   USE RKPARAM
   USE Constants
   IMPLICIT NONE
   REAL,DIMENSION(ndim),INTENT(inout) ::ystart
   INTEGER,PARAMETER ::maxstp=1000
   REAL,DIMENSION(ndim) :: y,dydt
   REAL x,h,hdid,hnext
   INTEGER nstp   
   
   x=0.
   h=h1
   y(:)=ystart(:)
   DO nstp=1,maxstp
      !WRITE(6,*) 'RK driver',nstp,y(1),y(2),y(3),h
      CALL derivs(y,dydt)
      IF(x+h.gt.h1) h=h1-x       !limits step if it goes over the remaining
                                 !time h1-x
      CALL rkqs(y,dydt,h,hdid,hnext)
      x=x+hdid
      IF(x.ge.h1) THEN
         ystart(:)=y(:)
         !WRITE(6,*) 'RKdriver',x,hdid,h1,nstp,dl
         !WRITE(6,*) 'ycurr',ystart
         RETURN
      ENDIF
      h=hnext
   ENDDO
   WRITE(6,*) 'Step size too smal in RK driver',nstp,x,h1,hdid
   STOP
   RETURN
END

!**********************************************************************
SUBROUTINE derivs(y,dydt)
!     c=phase speed and dydt are the derivatives of the n vectors
!     with respect to time.
!**********************************************************************
   USE RKPARAM
   USE BATHYGRID
   IMPLICIT NONE
   REAL,DIMENSION(ndim),INTENT(in) ::y
   REAL,DIMENSION(ndim),INTENT(out)::dydt

   REAL xg,yg,cg,depth,dcdx,dcdy,ca,sa,Umean,Vmean, gUx, gUy, gVx, gVy  
   
   xg=y(1)
   yg=y(2)
   CALL speed(xg,yg,y(3),cg,depth,dcdx,dcdy,Umean,Vmean, gUx, gUy, gVx, gVy)
   !WRITE(6,*) 'SPEED:',xg,yg,cg,depth,dcdx,dcdy,Umean,Vmean, gUx, gUy, gVx, gVy
   ca=cos(y(3))
   sa=sin(y(3))
   dydt(1)=(cg*ca+Umean)/sx        ! x and y are the coordinates in grid units
   dydt(2)=(cg*sa+Vmean)/sy        
   !dydt(3)=cg*(sa*dcdx/sx-ca*dcdy/sy)+sa**2*gVx+sa*ca*(gUx-gVy)-ca**2*gUy
   dydt(3)=(sa*(cg*dcdx+sa*gVx+ca*gUx)/sx-ca*(cg*dcdy+ca*gUy+sa*gVy)/sy)
   RETURN
END

!**********************************************************************
SUBROUTINE rkqs(y,dydt,htry,hdid,hnext)
!   Fifth order R-K step with monitoring of local error.  Input
!   is the n-vector of the input variable y and its derivatives
!   dydt at the starting value of x. htry is the stepsize to be
!   attempted, eps is the required accuracy and yscal is a
!   vector against which error is scaled.  On output, y and x
!   are replaced by their new values,hid is the accomplished
!   stepsize and hnext is the estimate of the next stepsize.
!**********************************************************************
   USE RKPARAM
   IMPLICIT NONE
   REAL,DIMENSION(ndim),INTENT(inout) ::y,dydt
   REAL,                INTENT(in)    ::htry
   REAL,                INTENT(out)   ::hdid,hnext
   
   REAL,PARAMETER :: pgrow=-.2
   REAL,PARAMETER :: pshrink=-.25
   REAL,PARAMETER :: safety=.9
   REAL,PARAMETER :: errcon=1.89e-4          !errcon=(5/safety)**(1/pgrow)
   REAL,DIMENSION(3):: yerr,ytemp
   REAL h,htemp,errmax
   INTEGER i,kount
   kount=0
      
   h=htry
   DO
      kount=kount+1
      CALL rkck(y,dydt,h,ytemp,yerr)
         errmax=0.
         DO i=1,ndim
            errmax=MAX(errmax,abs(yerr(i)/yscal(i)))
         ENDDO
         errmax=errmax/eps
      !WRITE(6,*) 'RKQS',errmax,kount,h
      IF(errmax.GT.1) THEN
         htemp=safety*h*(errmax**pshrink)
         h=MAX(htemp,0.1*h)                  !h should always be positive !!
                                             !I got rid of the test on xnew=x
      ELSE
         IF(errmax.gt.errcon) THEN
            hnext=safety*h*(errmax**pgrow)
         ELSE
            hnext=5.0*h
         ENDIF
         hdid=h
         y(:)=ytemp(:)
         RETURN
      ENDIF
   ENDDO
   !WRITE(6,*) 'Step size too smal in rkqs'
   RETURN
END

!**********************************************************************
SUBROUTINE rkck(y,dydt,h,yout,yerr)
!   For ndim variables y and their derivs dydt known at y, use
!   to advance solution over an interval h and return the
!   incremented variables as yout ( which may be the same as y)
!   the SUBROUTINE derivs(y,dydt) returns dydt at y
   USE RKPARAM
   IMPLICIT NONE
   REAL,DIMENSION(ndim),INTENT(in)     ::y,dydt
   REAL,                INTENT(in)     ::h
   REAL,DIMENSION(ndim),INTENT(out)    ::yout,yerr
   
   REAL,DIMENSION(ndim) ::    ak2,ak3,ak4,ak5,ak6,ytemp
   REAL,PARAMETER       ::    A2=.2,A3=.3,A4=.6,A5=1.,A6=.875
   REAL,PARAMETER       ::    B21=.2,B31=.075,B32=9./40.
   REAL,PARAMETER       ::    B41=.3,B42=-.9,B43=1.2
   REAL,PARAMETER       ::    B51=-11./54.,B52=2.5,B53=-70/27.,B54=35./27.
   REAL,PARAMETER       ::    B61=1631./55296.,B62=175./512.,B63=575./13824.
   REAL,PARAMETER       ::    B64=44275./110592.,B65=253./4096.
   REAL,PARAMETER       ::    C1=37./378.,C3=250./621.,C4=125./594.,C6=512./1771.
   REAL,PARAMETER       ::    DC1=C1-2825./27648.,DC3=C3-18575./48384.
   REAL,PARAMETER       ::    DC4=C4-13525/55296.,DC5=-277/14336,DC6=C6-.25
   
   ytemp(:)=y(:)+B21*h*dydt(:)
   CALL derivs(ytemp,ak2)
   ytemp(:)=y(:)+h*(B31*dydt(:)+B32*ak2(:))
   CALL derivs(ytemp,ak3)
   ytemp(:)=y(:)+h*(B41*dydt(:)+B42*ak2(:)+B43*ak3(:))
   CALL derivs(ytemp,ak4)
   ytemp(:)=y(:)+h*(B51*dydt(:)+B52*ak2(:)+B53*ak3(:)+B54*ak4(:))
   CALL derivs(ytemp,ak5)
   ytemp(:)=y(:)+h*(B61*dydt(:)+B62*ak2(:)+B63*ak3(:)+B64*ak4(:)+B65*ak5(:))
   CALL derivs(ytemp,ak6)
   yout(:)=y(:)+h*(C1*dydt(:)+C3*ak3(:)+C4*ak4(:)+C6*ak6(:))
   yerr(:)=h*(DC1*dydt(:)+DC3*ak3(:)+DC4*ak4(:)+DC6*ak6(:))
   RETURN
END

!**********************************************************************
SUBROUTINE speed(xg,yg,dir,cg,depth,dcdx,dcdy,Umean,Vmean, gUx, gUy, gVx, gVy)
!**********************************************************************
!     Wave speed gradients, from Dobson (1967), for not-too-shallow water
!     Code by William C. O'Reilly (1990-1998)
!     Modified by Fabrice Ardhuin (1999) to accomodate any depth.
!     Modified .................. 11/8/2000 with a Newton-Rapson method for
!                                 the inversion of the dispersion relation
!**********************************************************************
!     uses biquadric interpolation (bilinear would not be smooth)
!... calculates the depth, wave phase speed and gradients
!  Positions of the grid points (+) used in the computations
!  The current point xg,yg (*) is located in the [1,2,3,4] rectangle
!                  + 8   + 7
!
!            + 9   + 4   + 3   + 6
!                    *
!            + 10  + 1   + 2   + 5
!
!                  + 11  + 12
!**********************************************************************
   USE BATHYGRID
   USE Constants
   USE RKparam
   IMPLICIT NONE
   REAL,                INTENT(in)     ::xg,yg,dir
   REAL,                INTENT(out)    ::cg,depth,dcdx,dcdy,Umean,Vmean, gUx, gUy, gVx, gVy
   REAL(KIND=4), POINTER :: grid0(:,:) 
   REAL(KIND=4), POINTER,DIMENSION(:,:)             :: einter
   REAL (KIND=4), POINTER,DIMENSION(:,:)            :: dinter
   REAL,DIMENSION(12,6),SAVE :: sxy=reshape((/ 0.30861241,0.23684207,0.21770331, &
      0.23684207,-0.08492823,-0.05143541,-0.05143541,-0.08492823,0.00598086, &
      0.13038277,0.13038277,0.00598086, &
      0.05322964,0.19677030,0.14413872,0.10586122,0.09031100,-0.06758374, &
      -0.03349283,0.03349282,-0.18241626,-0.34031099,-0.12440190,0.12440190, &
      0.05322964,0.10586122,0.14413872,0.19677030,0.03349282,-0.03349283, &
      -0.06758374,0.09031099,0.12440190,-0.12440191,-0.34031099,-0.18241625, &
      -0.125,-0.125,-0.125,-0.125,0.125,0.125, &
      0.,0.,0.125,0.125,-0.,-0., &
      0.05263157,-0.05263157,0.05263158,-0.05263157,-0.15789473,0.15789474, &
      0.15789474,-0.15789473,-0.15789473,0.15789473,0.15789473,-0.15789473, &
      -0.125,-0.125,-0.125,-0.125,0.,0., &
      0.125,0.125,-0.,-0.,0.125,0.125 /),(/12,6/))
      
      
   INTEGER i,j,ifield
   REAL X,Y,sigma,dy,k,c,mean,gx, gy, sigma2, Up
   REAL xm,ym,xp,yp,sig,aka,yhat,t,a,dddx,dddy,dcdd
   
   xm=MAX(2.,MIN(xg,FLOAT(nx)-2.))
   ym=MAX(2.,MIN(yg,FLOAT(ny)-2.))
   i=INT(xm)
   j=INT(ym)
   xp=mod(xm,1.0)
   yp=mod(ym,1.0)

   IF (ip.ne.i.OR.jp.NE.j) THEN
      ip=i
      jp=j
      DO ifield=1,3
      IF (ifield.EQ.1) THEN 
         GRID0=> GRID
         einter=> gride
         dinter=> gridd
      ENDIF
      IF (ifield.EQ.2) THEN 
          GRID0=> U
         einter=> Ue
         dinter=> Ud
      ENDIF
      IF (ifield.EQ.3) THEN 
          GRID0=> V
         einter=> Ve
         dinter=> Vd
      ENDIF
      dinter(1,11)=grid0(i,j-1)
      dinter(1,12)=grid0(i+1,j-1)
      dinter(1,10)=grid0(i-1,j)
      dinter(1,1 )=grid0(i,j)
      dinter(1,2)=grid0(i+1,j)
      dinter(1,5)=grid0(i+2,j)
      dinter(1,9)=grid0(i-1,j+1)
      dinter(1,4)=grid0(i,j+1)
      dinter(1,3)=grid0(i+1,j+1)
      dinter(1,6)=grid0(i+2,j+1)
      dinter(1,8)=grid0(i,j+2)
      dinter(1,7)=grid0(i+1,j+2)
      einter=MATMUL(dinter,sxy)
      ENDDO
   ENDIF
      DO ifield=1,3
      IF (ifield.EQ.1) THEN 
         GRID0=> GRID
         einter=> gride
         dinter=> gridd
      ENDIF
      IF (ifield.EQ.2) THEN  
          GRID0=> U
         einter=> Ue
         dinter=> Ud
      ENDIF
      IF (ifield.EQ.3) THEN
          GRID0=> V
         einter=> Ve
         dinter=> Vd
      ENDIF

      mean=einter(1,1)+(einter(1,2)+einter(1,4)*xp+einter(1,5)*yp)*xp &
         +(einter(1,3)+einter(1,6)*yp)*yp
!... gradients of bottom depths
      gx=einter(1,4)*2.*xp+einter(1,5)*yp+einter(1,2)
      gy=einter(1,6)*2.*yp+einter(1,5)*xp+einter(1,3)

      IF (ifield.EQ.1) THEN 
         depth=mean
         dddx=gx
         dddy=gy
      ENDIF
      IF (ifield.EQ.2) THEN 
         Umean=mean
         gUx=gx
         gUy=gy
!IF (abs(U(i,j)) > 0.1) WRITE(6,*) 'TEST 2:',ifield,Umean,gx,gy,'#',U(i,j),grid0(i,j),Ud
   ENDIF
   IF (ifield.EQ.3) THEN 
      Vmean=mean
      gVx=gx
      gVy=gy
!WRITE(6,*) 'TEST 3:',ifield,Vmean,U(i,j),grid0(i,j)
   ENDIF
   END DO
   
!... adjust water level here
   depth=depth+deltaz

   IF(depth.lt.0.3) depth=0.3
   dl=depth
!... calculate phase speed gradient with depth 
!... (accurate in Shallow Water where Dobson was not)
   Up=(cos(dir)*Umean+sin(dir)*Vmean)
   CALL DISPcur(depth,freq,Up,k,c,cg)
   sigma=c*k
   sigma2=freq*tpi
   Y=(sigma**2*DEPTH)/G
   X=k*DEPTH
   !   WRITE(6,*) 'SIGMA:',sigma,Up,Umean,Vmean,sigma2
      c=sigma/k
      cg=g*((y/x)+x*(1-(y/x)**2))/(2.*sigma)  
                           !dk=aka/depth
                           !cg=tpi*freq/dk
                           !rc=c/co
	! old formula: Dobson
        ! dcdd=sig*(1.-rc*rc)/(c*rc+sig*depth*(1-rc*rc))
      ! the following formula is exaclty equivalent to Dobson in deep water
      ! but it is accurate in shallow water
      dcdd=(1-y/(y+x**2-y**2))/depth  !=(dc/dh)/c 
      dcdx=dcdd*dddx
      dcdy=dcdd*dddy
      !WRITE(6,*) 'SPEED',X,Y,I1,xinvxtanh(I1+1),k,c
      !WRITE(6,*) 'SPEED',xg,yg,cg,depth,dcdx,dcdy
      RETURN
      END

!*********************************************************************
	SUBROUTINE DISP(depth,freq,k,c,cg)
!*********************************************************************
   USE Constants
   IMPLICIT NONE
   REAL,                INTENT(in)     ::depth,freq  !depth (m) and frequency (Hz)
   REAL,                INTENT(out)    ::k,c,cg      !wave number (m-1),phase speed (m/s)
   REAL dep,sigma,X,Y,dy
   INTEGER I
   
   dep=depth
   IF (depth.LT.1) dep=1.
   sigma=freq*tpi
	Y=(sigma**2*DEP)/G
   IF (Y.GE.14.5) THEN 
      X=Y 
   ELSE
      I=INT(Y*REAL(ntanh)/15.)
   	dy=mod(Y*REAL(ntanh)/15.,1.0)
      X=invxtanhx(I)*(1-dy)+invxtanhx(I+1)*dy
   ENDIF
   k=X/DEP
   c=sigma/k
   cg=g*((y/x)+x*(1-(y/x)**2))/(2.*sigma)
   
   RETURN
	END

!*********************************************************************
	SUBROUTINE DISPcur(depth,freq,Up,k,c,cg)
!*********************************************************************
   USE Constants
   IMPLICIT NONE
   REAL,                INTENT(in)     ::depth,freq, Up  !depth (m) and frequency (Hz), and current in wave direction
   REAL,                INTENT(out)    ::k,c,cg          !wave number (m-1),phase speed (m/s)
   REAL dep,omega,sigma,X,Y,dy,DC,Ur
   INTEGER I,I2
   
   dep=depth
   IF (depth.LT.1) dep=1.
   omega=freq*tpi
   Y=(omega**2*DEP)/G
   Ur=Up/sqrt(g*dep)
   IF (Y.GE.14.5) THEN 
      IF (Up.GT.0.1) THEN 
         k=((2*omega*Up+g)-sqrt(g**2+4*omega*Up*g))/(2*Up**2)
      ELSE
         k=omega**2/g
      ENDIF
   ELSE
      I=INT(Y*REAL(ntanh)/15.)
!      Y=15.*REAL(J)/ntanh
!      Up=20.*(-100+REAL(J2))/ncur
      I2=INT(Ur*REAL(ncur)/2.+100)
      dy=mod(Y*REAL(ntanh)/15.,1.0)
      dC=mod(Ur*REAL(ncur)/2.+100,1.0)
      X=(invxtanhxc(I,I2)*(1-dy)+invxtanhxc(I+1,I2)*dy)*(1-dC) &
       +(invxtanhxc(I,I2+1)*(1-dy)+invxtanhxc(I+1,I2+1)*dy)*(dC)
      k=X/DEP
   ENDIF
   sigma=sqrt(g*k*tanh(k*dep))
   c=sigma/k
   cg=g*((y/x)+x*(1-(y/x)**2))/(2.*sigma)
   !WRITE(6,*) 'TEST1:',I,I2,Y,Up,(omega-k*Up)**2*DEP/g,(sigma)**2*DEP/g,k*dep*tanh(k*dep)
   
   RETURN
	END


!*********************************************************************
	SUBROUTINE TABULATE
!*********************************************************************
   USE Constants
   USE RKPARAM
   IMPLICIT NONE

   REAL X,Y,H,F,FD
   INTEGER I,J
   ntanh=2000
   ALLOCATE(invxtanhx(0:ntanh))
   DO J=0,ntanh
      Y=15.*REAL(J)/ntanh
      X=Y
   	F=1.
      DO 10 I=1,100
	   	H=TANH(X)
		   F=Y-X*H
         IF (ABS(F) .LT. 1.E-6) GO TO 20
	   	FD=-H-X/COSH(X)**2
   		X=X-F/FD
10	   CONTINUE
   	PRINT *,' SUBROUTINE DISP DOES NOT CONVERGE !!! '
20	   invxtanhx(J)=X
      ENDDO
      RETURN
	   END

!*********************************************************************
	SUBROUTINE TABULATECUR
!*********************************************************************
   USE Constants
   USE RKPARAM
   IMPLICIT NONE

   REAL X,Y,H,F,FD, Up
   INTEGER I,J,J2
   ntanh=2000
   ncur=200
   ALLOCATE(invxtanhxc(0:ntanh,0:ncur))
   DO J=0,ntanh
   DO J2=0,ncur
      Y=15.*REAL(J)/ntanh
      Up=2.*(-100+REAL(J2))/ncur
      X=Y
      F=1.
      DO 10 I=1,100
         H=TANH(X)
         F=Y-X*H+X**2*Up**2-2*X*sqrt(Y)*Up
         IF (ABS(F) .LT. 1.E-6) GO TO 20
	   	FD=-H-X/COSH(X)**2+2*X*Up**2-2*sqrt(Y)*Up
   		X=X-F/FD
10	   CONTINUE
!   	PRINT *,' SUBROUTINE DISP DOES NOT CONVERGE !!! ',Y,Up
20	   invxtanhxc(J,J2)=X
      !IF (J.EQ.214.AND.J2.EQ.120) WRITE(6,*) 'TEST:',Y,invxtanhxc(J,J2),Up,F,(Y-X*Up/g),X*H
      !IF (J.EQ.215.AND.J2.EQ.120) WRITE(6,*) 'TEST:',Y,invxtanhxc(J,J2),Up,F,(Y-X*Up/g),X*H
      ENDDO
      ENDDO
      RETURN
    END

!**********************************************************************
!**********************************************************************
!**********************************************************************
!**********************************************************************
PROGRAM rayplot  ! Forward ray-tracing version
   USE BATHYGRID
   USE Constants
   USE Raytraj
   USE RKPARAM
   IMPLICIT NONE
      
   REAL distance,theta0,xs,ys,sig,dw,dk,c,cg,dto,h_len2,delx,dely
   REAL h_len,dxy,dcdx,dcdy,a_step,ang,angs, depth, Up,wn
   INTEGER I,J,nrays,Iray,k,ircode,Iray1
   CHARACTER(len=160):: fblog,fbathy

   CALL Tabulate
depth=10.
freq=0.1
Up=2

   CALL DISP(depth,freq,wn,c,cg)
!WRITE(6,*) 'disp test:',wn,C,g*wn*tanh(wn*depth),(tpi*freq)**2
   CALL TABULATECUR
   CALL DISPcur(depth,freq,Up,wn,c,cg)
!WRITE(6,*) 'UPP:',wn,C,g*wn*tanh(wn*depth),(tpi*freq-wn*Up)**2
!   STOP
      
      OPEN(3,file='Ray3a.inpray',status='old')
      READ(3,'(a)') fblog
      READ(3,'(a)') fbathy
      READ(3,*) nrays
      READ(3,*) freq,distance,theta0,timestep,depthmax,depthmin
      READ(3,*) deltaz
      !READ(3,*) xs,ys

      h_len=100
      
      eps=0.0001    ! error tolerance in ray integration

!-------------------------------------------------------------------
!                 Get bathymetry grid data
!-------------------------------------------------------------------
      open(2,file=fblog)
      read(2,*) rlonmax,rlonmin,rlatmin,rlatmax
      read(2,*) rot
      read(2,*) sx,sy
      read(2,*) nx,ny 
      close(2)
      yscal(1)=REAL(nx)
      yscal(2)=REAL(ny)
      yscal(3)=1.

!                 Get the grid itself
   ALLOCATE(grid(nx,ny),U(nx,ny),V(nx,ny))
      open(2,file=fbathy,form='unformatted',access='direct',recl=4*ny)
      DO i=1,nx !beware 1 should be replaced by 4 on HP terminals
         read(2,rec=i) (grid(i,j),j=1,ny)
      ENDDO
      CLOSE(2)
      DO j=1,ny !beware 1 should be replaced by 4 on HP terminals
         !DO i=1,nx
           read(3,*) U(1:NX,j)
         IF (J.EQ.133) WRITE(6,*) 'J:',j,U(1:20,j)
   !ENDDO
      ENDDO
      DO j=1,ny !beware 1 should be replaced by 4 on HP terminals
         read(3,*) (V(i,j),i=1,nx)
      ENDDO
      CLOSE(3)

      WRITE(6,*) 'CURRENT:',MAXVAL(U),MINVAL(U),MAXVAL(V),MINVAL(V)

      sig=2.*pi*freq

      dw=800.
      call disp(dw,freq,dk,c,cg)    !calculate deep water phase speed
      dto=timestep*60.
      h_len2=cg*dto*0.1 !lengthen the steps for long output timestep
      IF (h_len2 > h_len) h_len=h_len2
      
      co=c
      hmin=0.
      !IF (h_len.GT.(sx+sy)*0.25) h_len=(sx+sy)*0.25
      h1=h_len/co                !calculate initial ray time steps, h1
                                          ! (major factor in computation time)
      
      OPEN(995,file='rays.asc',status='unknown')
      WRITE(6,*) 'Ray direction:',theta0
      ang=MOD(theta0,180.) !+180
      if (ang.GT.90) ang=ang-180.
      if (ang.LT.-90) ang=ang+180.
      WRITE(6,*) 'changed to:',ang,MOD(theta0,180.)
      xs=21
      ys=21
      Iray1=0
      angs=ang*d2r                  !transforms to radians
      delx=distance*1000./sx/sin(angs)
      dely=distance*1000./sy/cos(angs)
      WRITE(6,*) 'DELX,DELY:',distance,delx,dely,xs,ys,ang
      IF ((delx.GT.0).AND.(dely.GT.0)) THEN 
         xs=21
         ys=ny-20
      ENDIF 
      DO IRAY=1,nrays
         !WRITE(6,*) 'ray before:',IRAY,Iray1,xs,ys,ang
         CALL ref(xs,ys,angs,ircode)
         !WRITE(6,*) 'ray after :',IRAY,Iray1,xs,ys,ang,ircode
         write(995,*) nchunk,ircode
         write(995,*) (xch(k),k=1,nchunk),  &
        (ych(k),k=1,nchunk),(ach(k),k=1,nchunk)

         IF (delx.LT.0) THEN 
            IF (ABS(cos(angs)).GT.1E-5.AND.ys.LT.(ny-20)) THEN 
               ys=ys+dely
            ELSE
               ys=ny-20
            ENDIF
            IF (ys.GT.(ny-20)) THEN 
               xs=xs+ABS((ys-ny+20)*sy/sx/tan(angs))
               ys=ny-20
               Iray1=Iray
            ENDIF
            IF (ys.EQ.ny-20.AND.(Iray.NE.Iray1)) THEN 
               xs=xs-delx
            ENDIF
         ELSE
            IF (dely.GT.0) THEN 
               IF (ABS(cos(angs)).GT.1E-5.AND.ys.GT.21) THEN 
                  ys=ys-dely
               ELSE
                  ys=21
               ENDIF
               IF (ys.LT.(21)) THEN 
                  xs=xs+ABS((21-ys)*tan(angs)*sy/sx)
                  ys=21
                  Iray1=Iray
               ENDIF
            ELSE
               IF (ABS(cos(angs)).GT.1E-5.AND.ys.LT.(ny-20)) THEN 
                  ys=ys-dely
               ELSE
                  ys=ny-20
               ENDIF
            
            IF (ys.LT.(21)) THEN 
               xs=xs+ABS((ys-(ny-20))*tan(angs)*sy/sx)
               ys=ny-20
               Iray1=Iray
            ENDIF
            ENDIF

           IF (ys.EQ.21.AND.(Iray.NE.Iray1)) THEN 
               xs=xs+delx
            ENDIF
         ENDIF
      ENDDO
      CLOSE(995)
      END

      PROGRAM W3PRNT
C/
C/                  +-----------------------------------+
C/                  |           H. L. Tolman            |
C/                  |                        FORTRAN 77 |
C/                  | Last update :         08-Jul-1993 |
C/                  +-----------------------------------+
C/
C  1. Purpose :
C
C     Printing source codes and COMMON's including page numbers and
C     headers.
C
C  2. Method :
C
C     File name read from standard input.
C     Output send to w3prnt.out.
C
C  3. Parameters :
C
C     Data in PARAMETER statements :
C     ----------------------------------------------------------------
C       MMLINE  Int.  Maximum length of file.
C       NLPAGE  Int.  Length of page in terms of lines.
C       NOPAGE  Int.  Number of lines printed on page.
C       NUMB    Log.  Flag for line numbering.
C       INVERT  Log.  Flag for inverting print order of pages.
C     ----------------------------------------------------------------
C
C  4. Subroutines used :
C
C     None.
C
C  5. Called by :
C
C     None (stand alone program).
C
C  6. Error messages :
C
C     - File existence.
C     - File size.
C
C  7. Remarks :
C
C     - Only first 74 characters printed.
C     - If line is longer, last charected beomes break-off mark >.
C
C  8. Structure :
C
C     =====================================================
C       Prepagations
C       Get file name from standard input.
C       Open input file.
C       Read entire file.
C       Get number of pages.
C       Open output file.
C       Process pages.
C       ------------------------------------------------
C       ------------------------------------------------
C     =====================================================
C
C  9. Source code :
C
* ----------------------------------------------------------------------
*
      INTEGER     MMLINE, NLPAGE, NOPAGE
      LOGICAL     NUMB, INVERT
*
      PARAMETER ( MMLINE = 5000 )
      PARAMETER ( NLPAGE =   60 )
      PARAMETER ( NOPAGE =   55 )
*
      PARAMETER ( NUMB   = .TRUE. )
      PARAMETER ( INVERT = .FALSE. )
*
      INTEGER     NADD_1, NADD_2, N_HEAD, IERR, I, NL, NPAGE,
     &            IP, IP1, IPN, IPS, IL, IL1, ILN, ICHAR
      CHARACTER   FILE*80, LINE*80, NOLINE*80, HEADER*80,
     &            FNAME*40, NULLST*1, PP*4
      DIMENSION   FILE(MMLINE)
*
* initialisations ------------------------------------------------------
*
      NOLINE(01:40) = '                                        '
      NOLINE(41:80) = '                                        '
      NULLST = ' '
      NADD_1 = ( NLPAGE - NOPAGE -1 ) / 2
      NADD_2 = NLPAGE - NOPAGE - 1 - NADD_1
*
* get file name --------------------------------------------------------
*
      READ (*,'(A)',ERR=800,IOSTAT=IERR) FNAME
      N_HEAD = LEN(FNAME)
      DO 100, I=N_HEAD, 1, -1
        IF ( FNAME(I:I) .NE. ' ' ) THEN
            N_HEAD = I
            GOTO 101
          ENDIF
  100   CONTINUE
  101 CONTINUE
      HEADER = NOLINE
      HEADER(71-N_HEAD:70) = FNAME(1:N_HEAD)
      HEADER(73:76) = 'page'
*
* Open input file ------------------------------------------------------
*
      OPEN (10,FILE=FNAME,STATUS='OLD',ERR=801,IOSTAT=IERR)
      REWIND (10)
*
* Read input file ------------------------------------------------------
*
      NL     = 0
  200 CONTINUE
      READ (10,'(A)',END=201,ERR=802,IOSTAT=IERR) LINE
      NL     = NL + 1
      IF ( NL .GT. MMLINE ) THEN
          WRITE (*,*) '*** ERROR  : TOO MANY LINES'
          STOP ' '
        ENDIF
      FILE(NL) = LINE
      GOTO 200
*
  201 CONTINUE
*
* Numer of pages ----------------------------------------------------------------------
*
      NPAGE  = 1 + (NL-1)/NOPAGE
      IF ( INVERT ) THEN
          IP1    = NPAGE
          IPN    =   1
          IPS    =  -1
        ELSE
          IP1    =   1
          IPN    = NPAGE
          IPS    =   1
        ENDIF
*
* Open output file -----------------------------------------------------
*
      OPEN (11,FILE='w3prnt.out',ERR=803,IOSTAT=IERR)
*
* Loop over pages ------------------------------------------------------
*
      DO 400, IP=IP1, IPN, IPS
*
        WRITE (PP,'(I4)') IP
        HEADER(77:80) = PP
        ILN    = IP * NOPAGE
        IL1    = ILN + 1 - NOPAGE
*
        WRITE (11,'(A)') HEADER
        DO 300, IL=1, NADD_1
          WRITE (11,'(A)')  NULLST
  300     CONTINUE
*
        DO 350, IL=IL1, ILN
          IF ( IL .LE. NL ) THEN
              LINE   = FILE(IL)
              DO 310, I=80, 1, -1
                IF ( LINE(I:I) .NE. ' ' ) THEN
                    ICHAR  = I
                    GOTO 311
                  ENDIF
  310           CONTINUE
  311         CONTINUE
              IF ( ICHAR .GT. 74 ) THEN
                  LINE(74:74) = '>'
                  ICHAR  = 74
                ENDIF
              IF ( NUMB ) THEN
                  WRITE (11,'(1X,I4,1X,A)')  IL, LINE(1:ICHAR)
                ELSE
                  WRITE (11,'(6X,A)') LINE(1:ICHAR)
                ENDIF
            ELSE
              WRITE (11,'(A)')  NULLST
            ENDIF
  350     CONTINUE
*
        IF ( IP .NE. IPN ) THEN
            DO 360, IL=1, NADD_2
              WRITE (11,'(A)')  NULLST
  360         CONTINUE
          ENDIF
*
  400   CONTINUE
*
* End of processing ----------------------------------------------------
*
      STOP
*
* Error escape locations
*
  800 CONTINUE
      WRITE (*,*) '*** ERROR  : READING FILE NAME'
      WRITE (*,*) '    IOSTAT : ', IERR
      STOP
*
  801 CONTINUE
      WRITE (*,*) '*** ERROR  : OPENING INPUT FILE'
      WRITE (*,*) '    IOSTAT : ', IERR
      STOP
*
  802 CONTINUE
      WRITE (*,*) '*** ERROR  : READING FROM OUTPUT FILE'
      WRITE (*,*) '    IOSTAT : ', IERR
      STOP
*
  803 CONTINUE
      WRITE (*,*) '*** ERROR  : OPENING INPUT FILE'
      WRITE (*,*) '    IOSTAT : ', IERR
      STOP
*
* Formats
*
*
* End of W3PRNT --------------------------------------------------------
*
      END

module serv_xnl4v5
contains
SUBROUTINE y_gauleg(x1,x2,x,w,n)
!-------------------------------------------------------------------
INTEGER, intent(in) ::  n    ! Number of intervals
real, intent(in)    ::  x1   ! lower limit of integration interval
real, intent(in)    ::  x2   ! upper limit of integration interval
real, intent(out)   ::  x(n) ! Positions for function evaluations
real, intent(out)   ::  w(n) ! Weights
!
!-----------------------------------------------------------------------
DOUBLE PRECISION EPS
PARAMETER (EPS=3.d-14)
INTEGER i,j,m
DOUBLE PRECISION p1,p2,p3,pp,xl,xm,z,z1
!-----------------------------------------------------------------------
      m=(n+1)/2
      xm=0.5d0*(x2+x1)
      xl=0.5d0*(x2-x1)
      do 12 i=1,m
        z=cos(3.141592654d0*(i-.25d0)/(n+.5d0))
1       continue
          p1=1.d0
          p2=0.d0
          do 11 j=1,n
            p3=p2
            p2=p1
            p1=((2.d0*j-1.d0)*z*p2-(j-1.d0)*p3)/j
11        continue
          pp=n*(z*p1-p2)/(z*z-1.d0)
          z1=z

          z=z1-p1/pp
        if(abs(z-z1).gt.EPS)goto 1
        x(i)=xm-xl*z
        x(n+1-i)=xm+xl*z
        w(i)=2.d0*xl/((1.d0-z*z)*pp*pp)
        w(n+1-i)=w(i)
12    continue
!
return
END subroutine

!-----------------------------------------------------------------------------!
subroutine z_cmpcg(sigma,depth,grav,cg)
!-----------------------------------------------------------------------------!
!
!   +-------+    ALKYON Hydraulic Consultancy & Research
!   |       |    Gerbrant van Vledder
!   |   +---+
!   |   | +---+
!   +---+ |   |
!         +---+
!
implicit none
!
!  0. Update history
!
!     12/01/2001  Initial version
!     11/04/2001  Check included for the cases tat sigma < 0 or depth <0
!                 Result is cg = -10
!
!  1. Purpose:
!
!     Compute group velocity for a given radian frequency and depth
!
!  2. Method
!
!     Linear wave theory
!
!  3. Parameter list:
!
!Type   I/O           Name    Description
!------------------------------------------------------------------------------
real, intent(in)  :: sigma  !  radian frequency (rad)
real, intent(in)  :: depth  !  water depth (m)
real, intent(in)  :: grav   !  gravitational acceleration (m/s^2)
real, intent(out) :: cg     !  group velocity (m/s)
!
real k                      !  wave number
!/A
!!real z_wnumb                !  compute wave number
!/Z
!-----------------------------------------------------------------------------
k = z_wnumb(sigma,depth,grav)
!
if(depth <= 0. .or. sigma <= 0.) then
  cg = -10.
else
  if(depth*k > 30.) then
    cg = grav/(2.*sigma)
  else
    cg = sigma/k*(0.5+depth*k/sinh(2.*depth*k))
  end if
end if
!
return
end subroutine
!
!-----------------------------------------------------------------------------!
subroutine z_intp1(x1,y1,x2,y2,n1,n2,ierr)                                    !
!-----------------------------------------------------------------------------!
!
!   +-------+    ALKYON Hydraulic Consultancy & Research
!   |       |    Gerbrant van Vledder
!   |   +---+
!   |   | +---+
!   +---+ |   |
!         +---+
!
implicit none
!
!  0. Update history
!
!     30/03/1999 Initical version
!      9/04/1999 Check included for monotonicity of x-data
!     11/10/1999 Error messages added and updated
!     18/01/2001 Check include if n1==1
!     24/01/2001 Check for equality of y2 data loosened if n2==1
!     13/09/2001 Documentation updated
!
!  1. Purpose
!
!     Interpolate function values
!
!  2. Method
!
!     Linear interpolation

!     If a requested point falls outside the input domain, then
!     the nearest point is used (viz. begin or end point of x1/y1 array
!
!     If the input array has only one point. A constant value is assumed
!
!  3. Parameter list
!
!     Name    I/O  Type  Description
!
integer, intent(in) ::  n1   !   number of data points in x1-y1 arrays
integer, intent(in) ::  n2   !   number of data points in x2-y2 arrays
real, intent(in) ::  x1(n1)  !   x-values of input data
real, intent(in) ::  y1(n1)  !   y-values of input data
real, intent(in) ::  x2(n2)  !   x-values of output data
real, intent(out) :: y2(n2)  !   y-values of output data
integer, intent(out) :: ierr !   Error indicator
!
!  4. Subroutines used
!
!  5. Error messages
!
!     ierr = 0    No errors detected
!          = 1    x1-data not monotonic increasing
!          = 10   x2-data not monotonic increasing
!          = 11   x1- and x2 data not monotonic increasing
!          = 2    x1-data not monotonic decreasing
!          = 20   x1-data not monotonic decreasing
!          = 22   x1- and x2 data not monotonic decreasing
!
!          = 2    No variation in x1-data
!          = 3    No variation in x2-data is allowed if n2=1
!
!  6. Remarks
!
!     It is assumed that the x1- and x2-data are either
!     monotonic increasing or decreasing
!
!     If a requested x2-value falls outside the range of x1-values
!     it is assumed that the corresponding y2-value is equal to
!     the nearest boundary value of the y1-values
!
!     Example: x1 = [0 1 2 3]
!              y1 = [1 2 1 0]
!
!              x2 = -1,  y2 = 1
!              x2 =  5,  y2 = 0
!
!------------------------------------------------------------------------------
integer i1,i2        ! counters
!
real ds            ! step size
real fac           ! factor in linear interpolation
real s1,s2         ! search values
real xmin1,xmax1   ! minimum and maximum of x1-data
real xmin2,xmax2   ! minimum and maximum of x2-data
!
real, parameter :: eps=1.e-20
!------------------------------------------------------------------------------
!   initialisation
!
ierr = 0
!
!  check number of points of input array
!
if(n1==1) then
  y2 = y1(1)
  goto 9999
end if
!
!  check minimum and maximum data values
!
xmin1 = minval(x1)
xmax1 = maxval(x1)
xmin2 = minval(x2)
xmax2 = maxval(x2)
!
if (abs(xmin1-xmax1) < eps .or. abs(x1(1)-x1(n1)) < eps) then
  ierr = 2
  goto 9999
end if
!
if ((abs(xmin2-xmax2) < eps .or. abs(x2(1)-x2(n2)) < eps) .and. n2 > 1) then
  ierr = 3
  goto 9999
end if
!
! check input data for monotonicity
!
if(x1(1) < x1(n1)) then             ! data increasing
  do i1=1,n1-1
    if(x1(i1) > x1(i1+1)) then
      ierr=1
      write(*,*) 'z_intp1: i1 x1(i1) x1(i1+1):',i1,x1(i1),x1(i1+1)
      goto 9999
    end if
  end do
!
  do i2=1,n2-1
    if(x2(i2) > x2(i2+1)) then
      ierr=ierr+10
      write(*,*) 'z_intp1: i2 x2(i2) x2(i2+1):',i2,x2(i2),x2(i2+1)
      goto 9999
    end if
  end do
!
else                                 ! data decreasing
  do i1=1,n1-1
    if(x1(i1) < x1(i1+1)) then
      ierr=2
      write(*,*) 'z_intp1: i1 x1(i1) x1(i1+1):',i1,x1(i1),x1(i1+1)
      goto 9999
    end if
  end do
!
  do i2=1,n2-1
    if(x2(i2) < x2(i2+1)) then
      ierr=ierr + 20
      write(*,*) 'z_intp1: i2 x2(i2) x2(i2+1):',i2,x2(i2),x2(i2+1)
      goto 9999
    end if
  end do
end if
!
!------------------------------------------------------------------------------
! initialize
!------------------------------------------------------------------------------
if(ierr==0) then
  i1 = 1
  s1 = x1(i1)
!
  do i2 = 1,n2
    s2 = x2(i2)
    do while (s1 <= s2 .and. i1 < n1)
      i1 = i1 + 1
      s1 = x1(i1)
    end do
!
!  special point
!  choose lowest s1-value if x2(:) < x1(1)
!
    if(i1 ==1) then
      y2(i2) = y1(i1)
    else
      ds = s2 - x1(i1-1)
      fac = ds/(x1(i1)-x1(i1-1))
      y2(i2) = y1(i1-1) + fac*(y1(i1)-y1(i1-1))
    end if
!
! special case at end: choose s2(n2) > s1(n1), choose last value of y1(1)
!
    if(i2==n2 .and. s2>s1) y2(n2) = y1(n1)
  end do
end if
!
9999 continue
!
return
end subroutine
!
!-----------------------------------------------------------------------------!
subroutine z_polyarea(xpol,ypol,npol,area)
!-----------------------------------------------------------------------------!
!
!   +-------+    ALKYON Hydraulic Consultancy & Research
!   |       |    P.O. Box 248
!   |   +---+    8300 AE Emmeloord
!   |   | +---+  Tel: +31 527 620909
!   +---+ |   |  Fax: +31 527 610020
!         +---+  http://www.alkyon.nl
!
!         Gerbrant van Vledder
!
!  0. Update history
!
!     0.01  12/06/2003  Initial version
!
!  1. Purpose
!
!     Computes area of a closed polygon
!
!  2. Method
!
!     The area of the polygon
!
!  3. Parameter list
!
!     Name    I/O  Type  Description
!
integer, intent(in)  ::  npol       ! Number of points of polygon
real, intent(in)     ::  xpol(npol) ! x-coodinates of polygon
real, intent(in)     ::  ypol(npol) ! y-coordinates of polygon
real, intent(out)    ::  area       ! area of polygon
!
!  4. Subroutines used
!
!  5. Error messages
!
!  6. Remarks
!
integer ipol,ipol1         ! counters
real xmin,xmax,ymin,ymax   ! minima and maxima of polygon
real xmean,ymean           ! mean values
real xa,ya,xb,yb           ! temporary variables
real sumx,sumy             ! sums
real darea                 ! piece of area
!-------------------------------------------------------------------------------
if(npol<=1) then
  crf  = 0.
  xz   = 0.
  yz   = 0.
  area = 0.
  return
end if
!
! compute minimum and maximum coordinates
!
xmin = minval(xpol)
xmax = maxval(xpol)
ymin = minval(ypol)
ymax = maxval(ypol)
!
!  compute mean of range of x- and y-coordinates
!
xmean = 0.5*(xmin + xmax)
ymean = 0.5*(ymin + ymax)
!
! compute area and center of gravity
! do loop over all line pieces of polygon
!
area = 0.
sumx = 0.
sumy = 0.
!
do ipol=1,npol
  ipol1 = ipol + 1
  if(ipol==npol) ipol1 = 1
  xa = xpol(ipol)
  ya = ypol(ipol)
  xb = xpol(ipol1)
  yb = ypol(ipol1)
!
  darea = 0.5*((xa-xmean)*(yb-ymean) - (xb-xmean)*(ya-ymean))
  area  = area + darea
  sumx  = sumx + darea*(xa+xb+xmean)/3.
  sumy  = sumy + darea*(ya+yb+ymean)/3.
end do
!
return
end subroutine
!
!-----------------------------------------------------------------------------!
subroutine z_steps(x,dx,nx)
!-----------------------------------------------------------------------------!
!
!
!   +-------+    ALKYON Hydraulic Consultancy & Research
!   |       |    Gerbrant van Vledder
!   |   +---+
!   |   | +---+  Creation date:  September 28, 1998
!   +---+ |   |  Last Update:    march 19, 2003
!         +---+
!
!  0. Update history
!
!     19/03/2003   Input argument defined using intent option
!                  check included nx > 0
!
!  1. Purpose
!
!     Compute bandwidth of spectral discretization
!
implicit none
!
integer, intent(in) :: nx     ! Number of elements in array
real, intent(in)    :: x(nx)  ! Input data array with elements
real, intent(out)   :: dx(nx) ! Output array with step sizes
!
integer ix                    ! counter
!------------------------------------------------------------------------------
if (nx<1) then
  return
!
elseif (nx==1) then
  dx = 0
else
  do ix=2,nx-1
    dx(ix) = 0.5 * (x(ix+1) - x(ix-1))
  end do
!
  if (nx >= 4) then
    dx(1)  = dx(2)*dx(2)/dx(3)
    dx(nx) = dx(nx-1)*dx(nx-1)/dx(nx-2)
  else
    dx(1)  = dx(2)
    dx(nx) = dx(nx-1)
  end if
end if
!
return
end subroutine
!-----------------------------------------------------------------------------!
real function z_root2(func,x1,x2,xacc,iprint,ierr)
!-----------------------------------------------------------------------------!
!
!   +-------+    ALKYON Hydraulic Consultancy & Research
!   |       |
!   |   +---+
!   |   | +---+
!   +---+ |   |
!         +---+
!
!  0. Update history
!
!     Version Date       Modification
!
!     0.01    29/11/1999 Initial version
!     0.02    07/11/1999 Test added to check boundaries, and reverse if necessary
!                        Bug fixed in assigning answer
!     0.03    02/09/2002 Maximum number of iterations set to 20, instead of 10
!
!  1. Purpose
!
!     Find zero crossing point of function FUNC between the
!     initial values on either side of zero crossing
!
!  2. Method
!
!     Ridders method of root finding
!
!     adapted from routine zridddr
!     Numerical Recipes
!     The art if scientific computing, second edition, 1992
!     W.H. Press, S.A. Teukolsky, W.T. Vetterling and B.P. Flannery
!
!  3. Parameter list
!
!     Name    I/O  Type  Description
!
!     func     i    r    real function
!     x1       i    r    initial x-value on left/right side of zero-crossing
!     x2       i    r    initial x-value on right/left side of zero-crossing
!     xacc     i    r    accuracy, used as |x1(i)-x2(i)|< xacc
!     iprint   i    i    Output channel and test level
!     ierr     o    i    Error indicator
!
!  4. Subroutines used
!
!     Func      user supplied real function
!
!  5. Error messages
!
!     ierr = 0   No errors occured during iteration process
!            1   Iteration halted in dead end, this combination may NEVER occur
!            2   Maximum number of iterations exceeded
!            3   Solution jumped outside interval
!
!  6. Remarks
!
!     It is assumed that the x1- and x2-coordinate lie
!     on different sides of the actual zero crossing
!
!     The input parameter IPRINT is used to generate test output.
!     If IPRINT==0, no test output is created
!              > 0, test output is directed to the file connected to unit LUPRINT=IPRINT
!                   if no file is connected to this unit, no output is written
!
!
implicit none
!
real func                         ! external function
real, intent (in) :: x1           ! x-value at one side of interval
real, intent (in) :: x2           ! x-value at other side of interval
real, intent (in) :: xacc         ! requested accuracy
integer, intent (in) :: iprint    ! number of output channel, only used when
integer, intent (out) :: ierr     ! error indicator
!
real unused                       ! default value
real zriddr                       ! intermediate function value
real xx1,xx2,xx                   ! local boundaries during iteration
integer maxit                     ! maximum number of iteration
integer luprint                   ! unit of test output
logical lopen                     ! check if a file is opened

parameter (maxit = 20)
external func
!
integer iter      ! counter for number of iterations
real fh           ! function value FUNC(xh)
real fl           ! function value FUNC(xl)
real fm           ! function value FUNC(xm)
real fnew         ! function value FUNC(xnew)
real s            ! temp. function value, used for inverse quadratic interpolation
real xh           ! upper (high) boundary of interval
real xl           ! lower boundary of interval
real xm           ! middle point of interval
real xnew         ! new estimate according to Ridders method
!
ierr   = 0        ! set error level
unused =-1.11e30  ! set start value
!
xx1 = x1          ! copy boundaries of interval to local variables
xx2 = x2
!
luprint = iprint
!
if(luprint > 0) then
  inquire(unit=luprint,opened=lopen)
  if(.not.lopen) then
    luprint = 0
    write(*,'(a,i4)') 'Z_ROOT2: invalid unit number:',iprint
  end if
end if
!
! check boundaries on requirement x2 > x1
!
if(xx1 > xx2) then
  xx  = xx1
  xx1 = xx2
  xx2 = xx
end if
!
fl = func(xx1)
fh = func(xx2)
!
!if(luprint > 0) write(luprint,'(a,4e13.5)') &
!&  'Z_ROOT2: xx1 xx2 fl fh:',xx1,xx2,fl,fh
!
if((fl > 0. .and. fh < 0.) .or. (fl < 0. .and. fh > 0.))then
   xl = xx1
   xh = xx2
   zriddr = unused
!
   do iter=1,maxit
      xm = 0.5*(xl+xh)
      fm = func(xm)
      s = sqrt(fm**2-fl*fh)
      if(s == 0.) goto 9000
      xnew = xm+(xm-xl)*(sign(1.,fl-fh)*fm/s)
!
!      if(luprint>0) write(luprint,'(a,4e13.5)') &
!&       'Z_ROOT2: xm,fm,s,xnew:',xm,fm,s,xnew
!
      if (abs(xnew-zriddr) <= xacc) then
!        if(luprint>0) write(luprint,'(a)') 'Z_ROOT2: xnew=zriddr'
        goto 9000
      end if
!
      zriddr = xnew
      fnew = func(zriddr)
      if (fnew == 0.) goto 9000
!
      if(sign(fm,fnew) /= fm) then
         xl = xm
         fl = fm
         xh = zriddr
         fh = fnew
      elseif(sign(fl,fnew) /= fl) then
         xh = zriddr
         fh = fnew
      elseif(sign(fh,fnew) /= fh) then
         xl = zriddr
         fl = fnew
      else
         ierr = 1
         goto 9000
      endif
!
      if(abs(xh-xl) <= xacc) goto 9000
!
      if(luprint > 0) write(luprint,'(a,i4,5e14.6)') &
&     'Z_ROOT2: iter,x1,x2,|x1-x2|,xacc,z:', iter,xl,xh,abs(xl-xh),xacc,fnew
!
   end do
   ierr = 2
   if(luprint > 0) write(luprint,'(a)') 'Z_ROOT2: -> ierr=2'
   goto 9000
else if (fl == 0.) then
  zriddr = xx1
else if (fh == 0.) then
  zriddr = xx2
else
  ierr = 3
  goto 9999
! 'root must be bracketed in zriddr'
endif
!
9000 continue
!
z_root2 = zriddr
!
if(luprint > 0) write(luprint,'(a,2i3,5e13.5)') &
&     'Z_ROOT2: ierr,iter,xl,xh,acc,x0,z0:', ierr,iter,xl,xh,xacc,z_root2,func(z_root2)
!
9999 continue
!
return
end function
!
!-----------------------------------------------------------------------------!
subroutine z_upper(str)
!-----------------------------------------------------------------------------!
!
!   +-------+    ALKYON Hydraulic Consultancy & Research
!   |       |    Gerbrant van Vledder
!   |   +---+
!   |   | +---+  Creation date:  July 3,1998
!   +---+ |   |  Last Update:
!         +---+
!
!  0. Update history
!
!  1. Purpose
!
!     Transform all lower capitals to UPPER CAPITALS in string STR
!
!  2. Method
!
!  3. Parameter list
!
!     Name    I/O  Type  Description
!
implicit none
character(len=*), intent(inout) :: str  ! Character string to be converted
!
!  4. Subroutines used
!
!  5. Error messages
!
!  6. Remarks
!
integer nlen
integer i,ial,iau,izl
!
nlen = len(str)
!
ial = ichar('a')
iau = ichar('A')
izl = ichar('z')
!
do i=1,nlen
  if(ichar(str(i:i)) >= ial.and. ichar(str(i:i)) <= izl) then
    str(i:i) = char(ichar(str(i:i))-ial+iau)
  end if
end do
!
return
end subroutine
!
!-----------------------------------------------------------------------------!
real function z_wnumb(w,d,grav)
!-----------------------------------------------------------------------------!
!
!   +-------+    ALKYON Hydraulic Consultancy & Research
!   |       |    Gerbrant van Vledder
!   |   +---+
!   |   | +---+
!   +---+ |   |
!         +---+
!
implicit none
!
!  0. Update history
!
!     01/04/1999  Initial version
!     12/01/2001  grav added as input parameter
!     11/04/2001  Check included for the case w < 0 or d < 0
!
!  1. Purpose:
!
!     Compute wave number k for a given radian frequency and water depth
!
!  2. Method
!
!     finite depth linear dispersion relation, using a Pade approximation
!
!  3. Parameter list:
!
!Type   I/O           Name     Description
!------------------------------------------------------------------------------
real, intent(in)  ::  w      ! radian frequency (rad)
real, intent(in)  ::  d      ! water depth (m)
real, intent(in)  ::  grav   ! graviational acceleration (m/s^2)
!
!  4. Subroutines used
!
!  5. Error messages
!
!  6. Remarks
!
!     The Pade approximation has been described in Hunt, 198.
!
!
real x,xx,y,omega
!
if(d<=0 .or. w<= 0.) then
  z_wnumb = -10.
else
  omega   = w**2/grav
  y       = omega*d
  xx      = y*(y+1./(1.+y*(0.66667+y*(0.35550+y*(0.16084+y*(0.06320+y* &
&           (0.02174+y*(0.00654+y*(0.00171+y*(0.00039+y*0.00011))))))))))
  x       = sqrt(xx)
  z_wnumb = x/d
end if
!
return
end function
end module

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
!     This module reads in and initializes two grids for remapping.
!     NOTE: grid1 must be the master grid -- the grid that determines
!           which cells participate (e.g. land mask) and the fractional
!           area of grid2 cells that participate in the remapping.
!
!-----------------------------------------------------------------------
!
!     CVS:$Id: grids.f,v 1.6 2001/08/21 21:06:41 pwjones Exp $
!
!     Copyright (c) 1997, 1998 the Regents of the University of 
!       California.
!
!     This software and ancillary information (herein called software) 
!     called SCRIP is made available under the terms described here.  
!     The software has been approved for release with associated 
!     LA-CC Number 98-45.
!
!     Unless otherwise indicated, this software has been authored
!     by an employee or employees of the University of California,
!     operator of the Los Alamos National Laboratory under Contract
!     No. W-7405-ENG-36 with the U.S. Department of Energy.  The U.S.
!     Government has rights to use, reproduce, and distribute this
!     software.  The public may copy and use this software without
!     charge, provided that this Notice and any statement of authorship
!     are reproduced on all copies.  Neither the Government nor the
!     University makes any warranty, express or implied, or assumes
!     any liability or responsibility for the use of this software.
!
!     If software is modified to produce derivative works, such modified
!     software should be clearly marked, so as not to confuse it with 
!     the version available from Los Alamos National Laboratory.
!
!     this grids.f has been modified from the version available from 
!     Los Alamos National Laboratory.
!     modifications are marked with "NRL"
!     list of modifications:
!     - netcdf operations for reading from netcdf file removed
!           (major change)
!     - print statements added
!     - allocations removed (moved to scrip_wrapper subroutine)
!     - imask removed (this was an intermediate step from ncdf to 
!           the logicals grid1_mask grid2_mask; creation of these 
!           logicals is now handled by scrip_wrapper)
!
!***********************************************************************

      module scrip_grids

!-----------------------------------------------------------------------

      use SCRIP_KindsMod    ! defines data types
      use SCRIP_ErrorMod    ! error tracking
      use SCRIP_IOUnitsMod  ! manages I/O units
      use SCRIP_constants    ! common constants
!      use SCRIP_NetcdfMod   ! netCDF stuff
!      use netcdf            ! netCDF library module

      implicit none

!-----------------------------------------------------------------------
!
!     variables that describe each grid
!
!-----------------------------------------------------------------------

      integer (SCRIP_i4), save ::
     &             grid1_size, grid2_size, ! total points on each grid
     &             grid1_rank, grid2_rank, ! rank of each grid
     &             grid1_corners, grid2_corners ! number of corners
                                                ! for each grid cell

      integer (SCRIP_i4), dimension(:), allocatable, save ::
     &             grid1_dims, grid2_dims  ! size of each grid dimension

      character(SCRIP_charLength), save :: 
     &             grid1_name, grid2_name  ! name for each grid

      character (SCRIP_charLength), save :: 
     &             grid1_units, ! units for grid coords (degs/radians)
     &             grid2_units  ! units for grid coords

      real (SCRIP_r8), parameter ::
     &      deg2rad = pi/180.   ! conversion for deg to rads

!-----------------------------------------------------------------------
!
!     grid coordinates and masks
!
!-----------------------------------------------------------------------

      logical (SCRIP_logical), dimension(:), allocatable, target,save ::
     &             grid1_mask,        ! flag which cells participate
     &             grid2_mask,        ! flag which cells participate
     &     special_polar_cell1,       ! cell with only 1 corner at pole
     &     special_polar_cell2        !

      real (SCRIP_r8), dimension(:), allocatable, target, save ::
     &             grid1_center_lat,  ! lat/lon coordinates for
     &             grid1_center_lon,  ! each grid center in radians
     &             grid2_center_lat, 
     &             grid2_center_lon,
     &             grid1_area,        ! tot area of each grid1 cell
     &             grid2_area,        ! tot area of each grid2 cell
     &             grid1_area_in,     ! area of grid1 cell from file
     &             grid2_area_in,     ! area of grid2 cell from file
     &             grid1_frac,        ! fractional area of grid cells
     &             grid2_frac,        ! participating in remapping
     &             grid1_centroid_lat,! Centroid of grid1 cell
     &             grid1_centroid_lon,!
     &             grid2_centroid_lat,! Centroid of grid2 cell
     &             grid2_centroid_lon !


      real (SCRIP_r8), dimension(:,:), allocatable, target, save ::
     &             grid1_corner_lat,  ! lat/lon coordinates for
     &             grid1_corner_lon,  ! each grid corner in radians
     &             grid2_corner_lat, 
     &             grid2_corner_lon

      logical (SCRIP_logical), save ::
     &             luse_grid_centers ! use centers for bounding boxes
     &,            luse_grid1_area   ! use area from grid file
     &,            luse_grid2_area   ! use area from grid file

      real (SCRIP_r8), dimension(:,:), allocatable, target, save ::
     &             grid1_bound_box,  ! lat/lon bounding box for use
     &             grid2_bound_box   ! in restricting grid searches

      integer (SCRIP_i4), save ::    ! Cells overlapping the poles 
                                     ! (may be 0)
     &     grid1_npole_cell,        
     &     grid1_spole_cell,         
     &     grid2_npole_cell,
     &     grid2_spole_cell
      

!-----------------------------------------------------------------------
!
!     bins for restricting searches
!
!-----------------------------------------------------------------------

      character (SCRIP_charLength), save ::
     &        restrict_type  ! type of bins to use

      integer (SCRIP_i4), save ::
     &        num_srch_bins  ! num of bins for restricted srch

      integer (SCRIP_i4), dimension(:,:), allocatable, save ::
     &        bin_addr1, ! min,max adds for grid1 cells in this lat bin
     &        bin_addr2  ! min,max adds for grid2 cells in this lat bin

      real(SCRIP_r8), dimension(:,:), allocatable, save ::
     &        bin_lats   ! min,max latitude for each search bin
     &,       bin_lons   ! min,max longitude for each search bin

!-----------------------------------------------------------------------
!
!     Parameters for dealing with intersections in the polar region
!
!-----------------------------------------------------------------------

      real (SCRIP_r8), save :: 
     &     north_thresh,  ! threshold for coord transf.
     &     south_thresh   ! threshold for coord transf.


      !*** Number of subsegments used to represents edges near
      !*** the polar regions - choose an odd number to avoid obvious
      !*** degeneracies in intersection

      integer (SCRIP_i4), save ::
     &     npseg                    

!***********************************************************************

      contains

!***********************************************************************

      subroutine grid_init(errorCode,l_master,l_test)

!-----------------------------------------------------------------------
!
!     this routine reads grid info from grid files and makes any
!     necessary changes (e.g. for 0,2pi longitude range)
!
!-----------------------------------------------------------------------

!-----------------------------------------------------------------------
!
!     input variables
!
!-----------------------------------------------------------------------

      logical(SCRIP_Logical), intent(in) :: l_master  ! Am I the master
                                                  ! processor (do I/O)?
      logical(SCRIP_Logical), intent(in) :: l_test ! Whether to include
                                                   ! test output

!-----------------------------------------------------------------------
!
!     output variables
!
!-----------------------------------------------------------------------

      integer (SCRIP_i4), intent(out) ::
     &   errorCode                 ! returned error code

!-----------------------------------------------------------------------
!
!     local variables
!
!-----------------------------------------------------------------------

      integer (SCRIP_i4) :: 
     &  n,      ! loop counter
     &  nele,   ! element loop counter
     &  i,j,
     &  ip1,jp1,
     &  n_add, e_add, ne_add,
     &  nx, ny, ncorners_at_pole

      integer (SCRIP_i4) ::
     &     zero_crossing, pi_crossing,
     &     grid1_add, grid2_add,
     &     corner, next_corn
     
      real (SCRIP_r8) ::
     &     beglon, beglat, endlon, endlat

      logical (SCRIP_logical) ::
     &     found

!NRL      integer (SCRIP_i4), dimension(:), allocatable :: 
!NRL     &                            imask ! integer mask read from file

      real (SCRIP_r8) :: 
     &  dlat,dlon           ! lat/lon intervals for search bins

      real (SCRIP_r8), dimension(4) ::
     &  tmp_lats, tmp_lons  ! temps for computing bounding boxes

      character (9), parameter ::
     &   rtnName = 'grid_init'

      if(l_master.and.l_test)write(SCRIP_stdout,*)'subroutine grid_init'

!NRL #####################################################
!NRL .....Begin part of code formerly handled by netcdf read
!NRL #####################################################

!-----------------------------------------------------------------------
!
!     allocate grid coordinates/masks and read data
!
!-----------------------------------------------------------------------

      allocate( 
!NRL &          grid1_mask      (grid1_size),
!NRL &          grid2_mask      (grid2_size),
     &          special_polar_cell1(grid1_size),
     &          special_polar_cell2(grid2_size),
!NRL &          grid1_center_lat(grid1_size), 
!NRL &          grid1_center_lon(grid1_size),
!NRL &          grid2_center_lat(grid2_size), 
!NRL &          grid2_center_lon(grid2_size),
     &          grid1_area      (grid1_size),
     &          grid1_area_in   (grid1_size),
     &          grid2_area      (grid2_size),
     &          grid2_area_in   (grid2_size),
     &          grid1_frac      (grid1_size),
     &          grid2_frac      (grid2_size),
!NRL &          grid1_corner_lat(grid1_corners, grid1_size),
!NRL &          grid1_corner_lon(grid1_corners, grid1_size),
!NRL &          grid2_corner_lat(grid2_corners, grid2_size),
!NRL &          grid2_corner_lon(grid2_corners, grid2_size),
     &          grid1_bound_box (4            , grid1_size),
     &          grid2_bound_box (4            , grid2_size),
     &          grid1_centroid_lat(grid1_size),
     &          grid1_centroid_lon(grid1_size),
     &          grid2_centroid_lat(grid2_size),
     &          grid2_centroid_lon(grid2_size))

!NRL      allocate(imask(grid1_size))

      grid1_area = zero
      grid1_frac = zero
      grid1_centroid_lat = zero
      grid1_centroid_lon = zero

!-----------------------------------------------------------------------
!
!     initialize logical mask and convert lat/lon units if required
!
!-----------------------------------------------------------------------

!NRL      where (imask == 1)
!NRL        grid1_mask = .true.
!NRL      elsewhere
!NRL        grid1_mask = .false.
!NRL      endwhere
!NRL      deallocate(imask)

      select case (grid1_units(1:7))
      case ('degrees')

        grid1_center_lat = grid1_center_lat*deg2rad
        grid1_center_lon = grid1_center_lon*deg2rad

      case ('radians')

        !*** no conversion necessary

      case default

        print *,'unknown units supplied for grid1 center lat/lon: '
        print *,'proceeding assuming radians'

      end select

      select case (grid1_units(1:7))
      case ('degrees')

        grid1_corner_lat = grid1_corner_lat*deg2rad
        grid1_corner_lon = grid1_corner_lon*deg2rad

      case ('radians')

        !*** no conversion necessary

      case default

        print *,'unknown units supplied for grid1 corner lat/lon: '
        print *,'proceeding assuming radians'

      end select

!-----------------------------------------------------------------------
!
!     read data for grid 2
!
!-----------------------------------------------------------------------

!NRL      allocate(imask(grid2_size))

      grid2_area = zero
      grid2_frac = zero
      grid2_centroid_lat = zero
      grid2_centroid_lon = zero

!-----------------------------------------------------------------------
!
!     initialize logical mask and convert lat/lon units if required
!
!-----------------------------------------------------------------------

!NRL      where (imask == 1)
!NRL        grid2_mask = .true.
!NRL      elsewhere
!NRL        grid2_mask = .false.
!NRL      endwhere
!NRL      deallocate(imask)

      select case (grid2_units(1:7))
      case ('degrees')

        grid2_center_lat = grid2_center_lat*deg2rad
        grid2_center_lon = grid2_center_lon*deg2rad

      case ('radians')

        !*** no conversion necessary

      case default

        print *,'unknown units supplied for grid2 center lat/lon: '
        print *,'proceeding assuming radians'

      end select

      select case (grid2_units(1:7))
      case ('degrees')

        grid2_corner_lat = grid2_corner_lat*deg2rad
        grid2_corner_lon = grid2_corner_lon*deg2rad

      case ('radians')

        !*** no conversion necessary

      case default

        print *,'no units supplied for grid2 corner lat/lon: '
        print *,'proceeding assuming radians'

      end select

!NRL #####################################################
!NRL .....End part of code formerly handled by netcdf read
!NRL #####################################################


!-----------------------------------------------------------------------
!
!     convert longitudes to 0,2pi interval
!
!-----------------------------------------------------------------------

      where (grid1_center_lon .gt. pi2)  grid1_center_lon =
     &                                   grid1_center_lon - pi2
      where (grid1_center_lon .lt. zero) grid1_center_lon =
     &                                   grid1_center_lon + pi2
      where (grid2_center_lon .gt. pi2)  grid2_center_lon =
     &                                   grid2_center_lon - pi2
      where (grid2_center_lon .lt. zero) grid2_center_lon =
     &                                   grid2_center_lon + pi2
      where (grid1_corner_lon .gt. pi2)  grid1_corner_lon =
     &                                   grid1_corner_lon - pi2
      where (grid1_corner_lon .lt. zero) grid1_corner_lon =
     &                                   grid1_corner_lon + pi2
      where (grid2_corner_lon .gt. pi2)  grid2_corner_lon =
     &                                   grid2_corner_lon - pi2
      where (grid2_corner_lon .lt. zero) grid2_corner_lon =
     &                                   grid2_corner_lon + pi2

!-----------------------------------------------------------------------
!
!     make sure input latitude range is within the machine values
!     for +/- pi/2 
!
!-----------------------------------------------------------------------

      where (grid1_center_lat >  pih) grid1_center_lat =  pih
      where (grid1_corner_lat >  pih) grid1_corner_lat =  pih
      where (grid1_center_lat < -pih) grid1_center_lat = -pih
      where (grid1_corner_lat < -pih) grid1_corner_lat = -pih

      where (grid2_center_lat >  pih) grid2_center_lat =  pih
      where (grid2_corner_lat >  pih) grid2_corner_lat =  pih
      where (grid2_center_lat < -pih) grid2_center_lat = -pih
      where (grid2_corner_lat < -pih) grid2_corner_lat = -pih


!-----------------------------------------------------------------------
!
!     also, different grids consider the pole to be a slightly different
!     values (1.570796326789 vs 1.5707963267977). Find the closest
!     approach to the pole and if it is within a tolerance, move such
!     points that are practically at the pole to the pole to avoid
!     problems
!
!-----------------------------------------------------------------------
      
      where (abs(grid1_corner_lat-pih) < 1.e-03) grid1_corner_lat =  pih
      where (abs(grid1_corner_lat+pih) < 1.e-03) grid1_corner_lat = -pih
      where (abs(grid2_corner_lat-pih) < 1.e-03) grid2_corner_lat =  pih
      where (abs(grid2_corner_lat+pih) < 1.e-03) grid2_corner_lat = -pih


!-----------------------------------------------------------------------
!
!     compute bounding boxes for restricting future grid searches
!
!-----------------------------------------------------------------------

      if (.not. luse_grid_centers) then
        grid1_bound_box(1,:) = minval(grid1_corner_lat, DIM=1)
        grid1_bound_box(2,:) = maxval(grid1_corner_lat, DIM=1)
        grid1_bound_box(3,:) = minval(grid1_corner_lon, DIM=1)
        grid1_bound_box(4,:) = maxval(grid1_corner_lon, DIM=1)

        grid2_bound_box(1,:) = minval(grid2_corner_lat, DIM=1)
        grid2_bound_box(2,:) = maxval(grid2_corner_lat, DIM=1)
        grid2_bound_box(3,:) = minval(grid2_corner_lon, DIM=1)
        grid2_bound_box(4,:) = maxval(grid2_corner_lon, DIM=1)

      else

        nx = grid1_dims(1)
        ny = grid1_dims(2)

        do n=1,grid1_size

          !*** find N,S and NE points to this grid point

          j = (n - 1)/nx +1
          i = n - (j-1)*nx

          if (i < nx) then
            ip1 = i + 1
          else
            !*** assume cyclic
            ip1 = 1
            !*** but if it is not, correct
            e_add = (j - 1)*nx + ip1
            if (abs(grid1_center_lat(e_add) - 
     &              grid1_center_lat(n   )) > pih) then
              ip1 = i
            endif
          endif

          if (j < ny) then
            jp1 = j+1
          else
            !*** assume cyclic
            jp1 = 1
            !*** but if it is not, correct
            n_add = (jp1 - 1)*nx + i
            if (abs(grid1_center_lat(n_add) - 
     &              grid1_center_lat(n   )) > pih) then
              jp1 = j
            endif
          endif

          n_add = (jp1 - 1)*nx + i
          e_add = (j - 1)*nx + ip1
          ne_add = (jp1 - 1)*nx + ip1

          !*** find N,S and NE lat/lon coords and check bounding box

          tmp_lats(1) = grid1_center_lat(n)
          tmp_lats(2) = grid1_center_lat(e_add)
          tmp_lats(3) = grid1_center_lat(ne_add)
          tmp_lats(4) = grid1_center_lat(n_add)

          tmp_lons(1) = grid1_center_lon(n)
          tmp_lons(2) = grid1_center_lon(e_add)
          tmp_lons(3) = grid1_center_lon(ne_add)
          tmp_lons(4) = grid1_center_lon(n_add)

          grid1_bound_box(1,n) = minval(tmp_lats)
          grid1_bound_box(2,n) = maxval(tmp_lats)
          grid1_bound_box(3,n) = minval(tmp_lons)
          grid1_bound_box(4,n) = maxval(tmp_lons)
        end do

        nx = grid2_dims(1)
        ny = grid2_dims(2)

        do n=1,grid2_size

          !*** find N,S and NE points to this grid point

          j = (n - 1)/nx +1
          i = n - (j-1)*nx

          if (i < nx) then
            ip1 = i + 1
          else
            !*** assume cyclic
            ip1 = 1
            !*** but if it is not, correct
            e_add = (j - 1)*nx + ip1
            if (abs(grid2_center_lat(e_add) - 
     &              grid2_center_lat(n   )) > pih) then
              ip1 = i
            endif
          endif

          if (j < ny) then
            jp1 = j+1
          else
            !*** assume cyclic
            jp1 = 1
            !*** but if it is not, correct
            n_add = (jp1 - 1)*nx + i
            if (abs(grid2_center_lat(n_add) - 
     &              grid2_center_lat(n   )) > pih) then
              jp1 = j
            endif
          endif

          n_add = (jp1 - 1)*nx + i
          e_add = (j - 1)*nx + ip1
          ne_add = (jp1 - 1)*nx + ip1

          !*** find N,S and NE lat/lon coords and check bounding box

          tmp_lats(1) = grid2_center_lat(n)
          tmp_lats(2) = grid2_center_lat(e_add)
          tmp_lats(3) = grid2_center_lat(ne_add)
          tmp_lats(4) = grid2_center_lat(n_add)

          tmp_lons(1) = grid2_center_lon(n)
          tmp_lons(2) = grid2_center_lon(e_add)
          tmp_lons(3) = grid2_center_lon(ne_add)
          tmp_lons(4) = grid2_center_lon(n_add)

          grid2_bound_box(1,n) = minval(tmp_lats)
          grid2_bound_box(2,n) = maxval(tmp_lats)
          grid2_bound_box(3,n) = minval(tmp_lons)
          grid2_bound_box(4,n) = maxval(tmp_lons)
        end do

      endif

      where (abs(grid1_bound_box(4,:) - grid1_bound_box(3,:)) > pi)
        grid1_bound_box(3,:) = zero
        grid1_bound_box(4,:) = pi2
      end where

      where (abs(grid2_bound_box(4,:) - grid2_bound_box(3,:)) > pi)
        grid2_bound_box(3,:) = zero
        grid2_bound_box(4,:) = pi2
      end where

      where (grid1_center_lat > grid1_bound_box(2,:))
     &  grid1_bound_box(2,:) = pih

      where (grid1_center_lat < grid1_bound_box(1,:))
     &  grid1_bound_box(1,:) = -pih

      where (grid2_center_lat > grid2_bound_box(2,:))
     &  grid2_bound_box(2,:) = pih

      where (grid2_center_lat < grid2_bound_box(1,:))
     &  grid2_bound_box(1,:) = -pih


      !***
      !*** Check for cells that overlap poles and explicitly
      !*** store their addresses
      !***

      grid1_npole_cell = 0
      grid1_spole_cell = 0
         
      do grid1_add = 1, grid1_size

         found = .false.
         do corner = 1, grid1_corners
            endlat = grid1_corner_lat(corner,grid1_add)
            if (abs(abs(endlat)-pih) .lt. 1e-5) then
               found = .true.   ! cell has polar pnt; so pole is 
                                ! not in the interior of the cell
               exit
            endif
         enddo

         if (found) cycle


         beglon = grid1_corner_lon(1,grid1_add)
         zero_crossing = 0
         pi_crossing = 0

         do corner = 1, grid1_corners
            next_corn = mod(corner,grid1_corners) + 1
            endlon = grid1_corner_lon(next_corn,grid1_add)

            if (abs(beglon-endlon) .gt. pi) then
               zero_crossing = 1
            else
               if ((beglon .lt. pi .and. endlon .ge. pi) .or.
     &              (endlon .lt. pi .and. beglon .ge. pi)) then
                  pi_crossing = 1
               endif
            endif

            beglon = endlon
         enddo
         
         if (zero_crossing .eq. 1 .and. pi_crossing .eq. 1) then

            !***
            !*** We have a polar cell
            !***

            if (grid1_center_lat(grid1_add) .gt. 0) then
               grid1_npole_cell = grid1_add
            else if (grid1_center_lat(grid1_add) .lt. 0) then
               grid1_spole_cell = grid1_add
            endif

            if (grid1_npole_cell .ne. 0 .and.
     &           grid1_spole_cell .ne. 0) then
               exit
            endif

         endif

      enddo



      grid2_npole_cell = 0
      grid2_spole_cell = 0

      do grid2_add = 1, grid2_size

         found = .false.
         do corner = 1, grid2_corners
            endlat = grid2_corner_lat(corner,grid2_add)
            if (abs(abs(endlat)-pih) .lt. 1e-5) then
               found = .true.   ! cell has polar pnt; so pole is 
                                ! not in the interior of the cell
               exit
            endif
         enddo

         if (found) cycle

         beglon = grid2_corner_lon(1,grid2_add)
         zero_crossing = 0
         pi_crossing = 0

         do corner = 1, grid2_corners
            next_corn = mod(corner,grid2_corners) + 1
            endlon = grid2_corner_lon(next_corn,grid2_add)
            
            if (abs(beglon-endlon) > pi) then
               zero_crossing = 1
            else
               if ((beglon .lt. pi .and. endlon .ge. pi) .or.
     &              (endlon .lt. pi .and. beglon .ge. pi)) then
                  pi_crossing = 1
               endif
            endif

            beglon = endlon
         enddo
         
         if (zero_crossing .eq. 1 .and. pi_crossing .eq. 1) then

            !***
            !*** We have a polar cell
            !***

            if (grid2_center_lat(grid2_add) .gt. 0) then
               grid2_npole_cell = grid2_add
            else if (grid2_center_lat(grid2_add) .lt. 0) then
               grid2_spole_cell = grid2_add
            endif

            if (grid2_npole_cell .ne. 0 .and.
     &           grid2_spole_cell .ne. 0) then
               exit
            endif

         endif

      enddo


      special_polar_cell1 = .false.
      do grid1_add = 1, grid1_size

         ncorners_at_pole = 0
         do i = 1, grid1_corners
            beglat = grid1_corner_lat(i,grid1_add)
            if (abs(abs(beglat)-pih) .le. 1.e-5) 
     &           ncorners_at_pole = ncorners_at_pole + 1
         enddo

         if (ncorners_at_pole .eq. 1) 
     &        special_polar_cell1(grid1_add) = .true.
            
      enddo

      special_polar_cell2 = .false.
      do grid2_add = 1, grid2_size

         ncorners_at_pole = 0
         do i = 1, grid2_corners
            beglat = grid2_corner_lat(i,grid2_add)
            if (abs(abs(beglat)-pih) .le. 1.e-5) 
     &              ncorners_at_pole = ncorners_at_pole + 1
         enddo

         if (ncorners_at_pole .eq. 1) 
     &        special_polar_cell2(grid2_add) = .true.
            
      enddo

      if(l_master)print *, ' '
      if(l_master)print *, 'Grid 1 size', grid1_size
      if(l_master)print *, 'Grid 2 size', grid2_size


!     if(l_master)print *, 'grid1_npole_cell',grid1_npole_cell
      if (grid1_npole_cell .gt. 0) then
         do i = 1, grid1_corners
            print *, grid1_corner_lat(i,grid1_npole_cell),
     &           grid1_corner_lon(i,grid1_npole_cell)
         enddo
      endif
!     if(l_master)print *, 'grid1_spole_cell',grid1_spole_cell
      if (grid1_spole_cell .gt. 0) then
         do i = 1, grid1_corners
            print *, grid1_corner_lat(i,grid1_spole_cell), 
     &           grid1_corner_lon(i,grid1_spole_cell)
         enddo
      endif
!     if(l_master)print *, 'grid2_npole_cell',grid2_npole_cell
      if (grid2_npole_cell .gt. 0) then
         do i = 1, grid2_corners
            print *, grid2_corner_lat(i,grid2_npole_cell), 
     &           grid2_corner_lon(i,grid2_npole_cell)
         enddo
      endif
!     if(l_master)print *, 'grid2_spole_cell',grid2_spole_cell
      if (grid2_spole_cell .gt. 0) then
         do i = 1, grid2_corners
            print *, grid2_corner_lat(i,grid2_spole_cell), 
     &           grid2_corner_lon(i,grid2_spole_cell)
         enddo
      endif
      if(l_master)print *


!-----------------------------------------------------------------------
!
!     set up and assign address ranges to search bins in order to 
!     further restrict later searches
!
!-----------------------------------------------------------------------

      select case (restrict_type)

      case ('latitude')
        if(l_master.and.l_test)write(SCRIP_stdout,*)
     &        'Using latitude bins to restrict search.'

        allocate(bin_addr1(2,num_srch_bins))
        allocate(bin_addr2(2,num_srch_bins))
        allocate(bin_lats (2,num_srch_bins))
        allocate(bin_lons (2,num_srch_bins))

        dlat = pi/num_srch_bins

        do n=1,num_srch_bins
          bin_lats(1,n) = (n-1)*dlat - pih
          bin_lats(2,n) =     n*dlat - pih
          bin_lons(1,n) = zero
          bin_lons(2,n) = pi2
          bin_addr1(1,n) = grid1_size + 1
          bin_addr1(2,n) = 0
          bin_addr2(1,n) = grid2_size + 1
          bin_addr2(2,n) = 0
        end do

        do nele=1,grid1_size
          do n=1,num_srch_bins
            if (grid1_bound_box(1,nele) <= bin_lats(2,n) .and.
     &          grid1_bound_box(2,nele) >= bin_lats(1,n)) then
              bin_addr1(1,n) = min(nele,bin_addr1(1,n))
              bin_addr1(2,n) = max(nele,bin_addr1(2,n))
            endif
          end do
        end do

        do nele=1,grid2_size
          do n=1,num_srch_bins
            if (grid2_bound_box(1,nele) <= bin_lats(2,n) .and.
     &          grid2_bound_box(2,nele) >= bin_lats(1,n)) then
              bin_addr2(1,n) = min(nele,bin_addr2(1,n))
              bin_addr2(2,n) = max(nele,bin_addr2(2,n))
            endif
          end do
        end do

      case ('latlon')
        if(l_master.and.l_test)write(SCRIP_stdout,*)
     &         'Using lat/lon boxes to restrict search.'

        dlat = pi /num_srch_bins
        dlon = pi2/num_srch_bins

        allocate(bin_addr1(2,num_srch_bins*num_srch_bins))
        allocate(bin_addr2(2,num_srch_bins*num_srch_bins))
        allocate(bin_lats (2,num_srch_bins*num_srch_bins))
        allocate(bin_lons (2,num_srch_bins*num_srch_bins))

        n = 0
        do j=1,num_srch_bins
        do i=1,num_srch_bins
          n = n + 1

          bin_lats(1,n) = (j-1)*dlat - pih
          bin_lats(2,n) =     j*dlat - pih
          bin_lons(1,n) = (i-1)*dlon
          bin_lons(2,n) =     i*dlon
          bin_addr1(1,n) = grid1_size + 1
          bin_addr1(2,n) = 0
          bin_addr2(1,n) = grid2_size + 1
          bin_addr2(2,n) = 0
        end do
        end do

        num_srch_bins = num_srch_bins**2

        do nele=1,grid1_size
          do n=1,num_srch_bins
            if (grid1_bound_box(1,nele) <= bin_lats(2,n) .and.
     &          grid1_bound_box(2,nele) >= bin_lats(1,n) .and.
     &          grid1_bound_box(3,nele) <= bin_lons(2,n) .and.
     &          grid1_bound_box(4,nele) >= bin_lons(1,n)) then
              bin_addr1(1,n) = min(nele,bin_addr1(1,n))
              bin_addr1(2,n) = max(nele,bin_addr1(2,n))
            endif
          end do
        end do

        do nele=1,grid2_size
          do n=1,num_srch_bins
            if (grid2_bound_box(1,nele) <= bin_lats(2,n) .and.
     &          grid2_bound_box(2,nele) >= bin_lats(1,n) .and.
     &          grid2_bound_box(3,nele) <= bin_lons(2,n) .and.
     &          grid2_bound_box(4,nele) >= bin_lons(1,n)) then
              bin_addr2(1,n) = min(nele,bin_addr2(1,n))
              bin_addr2(2,n) = max(nele,bin_addr2(2,n))
            endif
          end do
        end do

      case default
        stop 'unknown search restriction method'
      end select

!-----------------------------------------------------------------------
!
!     if area not read in, compute an area
!
!-----------------------------------------------------------------------

      if (.not. luse_grid1_area) then
         call SCRIP_GridComputeArea(grid1_area_in, grid1_corner_lat,
     &                              grid1_corner_lon, errorCode)

         if (SCRIP_ErrorCheck(errorCode, rtnName, 
     &                        'error computing grid1 area')) return
      endif

      if (.not. luse_grid2_area) then
         call SCRIP_GridComputeArea(grid2_area_in, grid2_corner_lat,
     &                              grid2_corner_lon, errorCode)

         if (SCRIP_ErrorCheck(errorCode, rtnName, 
     &                        'error computing grid2 area')) return
      endif

!-----------------------------------------------------------------------

      end subroutine grid_init

!***********************************************************************
!BOP
! !IROUTINE: SCRIP_GridComputeArea -- computes grid cell areas
! !INTERFACE:

      subroutine SCRIP_GridComputeArea(area, cornerLat, cornerLon,
     &                                 errorCode)

! !DESCRIPTION:
!  This routine computes a grid cell area based on corner lat/lon
!  coordinates.  It is provided in the case that a user supplied
!  area is not available.
!
! !REVISION HISTORY:
!  same as module

! !OUTPUT PARAMETERS:

      real (SCRIP_r8), dimension(:), intent(out) ::
     &   area              ! computed area for each grid cell

      integer (SCRIP_i4), intent(out) ::
     &   errorCode         ! returned error code

! !INPUT PARAMETERS:

      real (SCRIP_r8), dimension(:,:), intent(in) ::
     &   cornerLat,        ! latitude  of each cell corner
     &   cornerLon         ! longitude of each cell corner

!EOP
!BOC
!-----------------------------------------------------------------------
!
!  local variables
!
!-----------------------------------------------------------------------

      integer (SCRIP_i4) ::
     &   numCells,           ! number of grid cells
     &   numCorners,         ! number of corners in each cell
     &   nCell,              ! loop index for grid cells
     &   nCorner,            ! loop index for corners in each cell
     &   nextCorner          ! next corner around cell perimeter

      real (SCRIP_r8) ::
     &   dphi                ! delta(longitude) for this segment
     
!-----------------------------------------------------------------------
!
!  determine size of grid and initialize
!
!-----------------------------------------------------------------------

      errorCode = SCRIP_Success

      numCells   = size(CornerLat, dim=2)
      numCorners = size(CornerLat, dim=1)

!-----------------------------------------------------------------------
!
!  compute area for each cell by integrating around cell edge
!
!-----------------------------------------------------------------------

      do nCell=1,numCells

         Area(nCell) = 0.0_SCRIP_r8

         do nCorner=1,numCorners
            nextCorner = mod(nCorner,numCorners) + 1

            !*** trapezoid rule - delta(Lon) is -0.5*dx
            dphi = CornerLon(   nCorner,nCell) - 
     &             CornerLon(nextCorner,nCell)
            if (dphi > pi) then
               dphi = dphi - pi2
            else if (dphi < -pi) then
               dphi = dphi + pi2
            endif
            dphi = 0.5_SCRIP_r8*dphi

            Area(nCell) = Area(nCell) + 
     &                    dphi*(sin(CornerLat(   nCorner,nCell)) +
     &                          sin(CornerLat(nextCorner,nCell)))
         end do

      end do

!-----------------------------------------------------------------------
!EOC

      end subroutine SCRIP_GridComputeArea

!***********************************************************************

      end module scrip_grids

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

#!/bin/sh
# --------------------------------------------------------------------------- #
# ww3_gspl.sh: Shell wrapper tot split grid into subgrids, including making   #
#              all mod_def files and the relvant part of ww3_multi.inp.       #
#                                                                             #
# use        : ww3_gspl.sh [options] gridname nr_grids                        #
#              See usage function for options.                                #
#                                                                             #
# error codes : Program ends if error occurs in input.                        #
#                                                                             #
# programs used :                                                             #
#       ww3_grid : Grid preprocessor.                                         #
#       ww3_gspl : Grdi splitter.                                             #
#                                                                             #
#                                                      Hendrik L. Tolman      #
#                                                      January 2014           #
#                                                                             #
#    Copyright 2013-2014 National Weather Service (NWS),                      #
#       National Oceanic and Atmospheric Administration.  All rights          #
#       reserved.  WAVEWATCH III is a trademark of the NWS.                   #
#       No unauthorized use without permission.                               #
#                                                                             #
# --------------------------------------------------------------------------- #
# 1. Preparations                                                             #
# --------------------------------------------------------------------------- #
# 1.a Internal variables

  set -e

# 1.a.1 Setup file

  ww3_env="${HOME}/.wwatch3.env"                           # setup file
# The following line must not be removed: it is a switch for local install
# so that all bin scripts point to the local wwatch3.env
# WW3ENV
# For manual install (without install_ww3_tar or install_ww3_svn) make sure to
# either use the generic ww3_env or to add your own ww3_env="${my_directory}"

  if [ ${WWATCH3_ENV} ]; then ww3_env="${WWATCH3_ENV}"; fi # alternate setup file

  home_dir=`pwd`

   info_bot="3  2  1.0  '(12F11.3)'"
  info_obst="3  2  1.0  '(26F5.2)'"
  info_mask="3  2  1    '(66I2)'"  

# 1.a.2 Usage function

  scriptname="`basename $0`"
  optstr="ad:e:f:hil:n:o:rs:t:v"

  nr_it=350
  target='0.75'
  halo_ext=2
  comm_first='0.'
  comm_last='1.'
  frflag='T'

  usage ()
{
cat 2>&1 << EOF

Usage: $scriptname [options]  gridID nr_grid
Required:
  gridID     : name of master grid to be split up
  nr_grid    : number of sub-grids to be generated
Options:
  -a               : use entire assigned cummunicator for each grid
  -h               : help, print this.
  -i               : create template file ww3_gint.inp_tmpl for
                     later integration of output into single grid.
  -d data_dir      : directory with ww3_grid.inp and ancilary data
                      * default is working directory
                      * relative unless starting with '/'
  -e halo_ext      : set halo extension, default is 2
  -o output_dir    : directory for std out redirects
                      * default is working directory
                      * relative unless starting with '/'
  -n n_iter        : maximum number of  interations in ww3_gspl
                      * default = $nr_it
  -t target        : target accuracy in ww3_gspl (%)
                      * default = $target
  -f comm_first    : communicator fraction (first).
                      * default = $comm_first
  -l comm_last     : communicator fraction (last).
                      * default = $comm_last
  -s ww3_multi.inp : name of input file to be modified.
                      * Not set as default.
  -r               : replace file defined under -s, otherwise add .new
  -v               : verbose, show program output
EOF
}
 
# 1.a.3 Process input (part 1)

  args=`getopt $optstr $*`

  if [ $? != 0 ]
  then
    usage
    exit 1
  fi

  set -- $args

  while :
  do
    case "$1" in
    -a) frflag='F' ;;
    -c) shift; info_comm="$1" ;;
    -d) shift; data_dir="$1" ;;
    -e) shift; halo_ext="$1" ;;
    -f) shift; comm_first="$1" ;;
    -h) help=1 ;;
    -i) gint=1 ;;
    -l) shift; comm_last="$1" ;;
    -n) shift; nr_it="$1" ;;
    -o) shift; outp_dir="$1" ;;
    -r) replace=1 ;;
    -s) shift; inp_file="$1" ;;
    -t) shift; target="$1" ;;
    -v) verbose=1 ;;
    --) break ;;
    esac
    shift
  done
  shift

  if [ $help ]
  then
    usage
    exit 1
  fi

  if [ ! $# = 0 ]
  then
    modID="$1" ; shift
  else
    usage
    exit 2
  fi

  if [ ! $# = 0 ]
  then
    nr_grid="$1" ; shift
    if [ "$nr_grid" -lt '1' ] ; then
      nr_grid='1' ; fi
  else
    usage
    exit 3
  fi

# 1.a.4 Setup file processing

  if test -f $ww3_env
  then
    set `grep WWATCH3_DIR $ww3_env` ; shift
    main_dir="$*"
    set `grep WWATCH3_TMP $ww3_env` ; shift
    temp_dir="$*"
    set `grep WWATCH3_SOURCE $ww3_env` ; shift
    source="$*"
    set `grep WWATCH3_LIST $ww3_env` ; shift
    list="$*"
  else
    echo "*** Set-up file $ww3_env not found ***"; echo ' '
    exit 1
  fi

  exe_dir="$main_dir/exe"

# private temp dir to allow for parallel batch processing

  temp_dir=$home_dir/ww3_gspl.temp
 
# 1.a.5 Process input (part 2)


  if [ -z "$data_dir" ] ; then
    data_dir=$home_dir ; fi

  if [ "`echo $data_dir | cut -c1-2`" = './' ] 
  then
    len=`echo $data_dir | wc -c | awk '{print $1}'`
    data_dir="$home_dir/`echo $data_dir | cut -c3-$len`"
  fi

  if [ "`echo $data_dir | cut -c1-1`" != '/' ] ; then
    data_dir="$home_dir/$data_dir" ; fi

  if [ -z "$outp_dir" ] ; then
    outp_dir=$home_dir ; fi

  if [ "`echo $outp_dir | cut -c1-2`" = './' ] 
  then
    len=`echo $outp_dir | wc -c | awk '{print $1}'`
    outp_dir="$home_dir/`echo $outp_dir | cut -c3-$len`"
  fi

  if [ "`echo $outp_dir | cut -c1-1`" != '/' ] ; then
    outp_dir="$home_dir/$outp_dir" ; fi

  mkdir -p $outp_dir

# 1.b ID header  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

  echo ' '
  echo '                 *********************************'
  echo '               *** splitting WAVEWATCH III grids ***'
  echo '                 *********************************'
  echo ' '
  echo " Running from      : $home_dir"
  echo " Main directory    : $main_dir"
  echo " Scratch directory : $temp_dir"
  echo " Data directory    : $data_dir"
  echo " Output directory  : $outp_dir"
  echo " Model ID          : $modID"
  echo " Number of grids   : $nr_grid"
  echo ' '

  if [ "$frflag" = 'F' ] 
  then
    echo " Each grid uses maximum communicator (-a) *** ABNORMAL OPERATION ***"
    echo ' '
  fi

# 1.d Set up work space  - - - - - - - - - - - - - - - - - - - - - - - - - - - 
# 1.d.1 Genmeral preparations

#  ${main_dir}/bin/w3_clean

  cd $home_dir
  rm -f $inp_file.new
  rm -f ww3_mask.$modID.*
  rm -f mod_def.$modID
  rm -f mod_def.$modID.*
  rm -f ww3_multi.$modID.*
  rm -f part_*

  cd $data_dir
  filelist=`ls`

  cd $outp_dir
  rm -f *.out

  rm -rf $temp_dir
  mkdir -p $temp_dir
  cd $temp_dir
  rm -f *.$modID $modID.* *.$modID.*
  rm -f ww3_grid.*
  rm -f *.bot
  rm -f *.obst
  rm -f *.mask

# 1.d.2 Get files from data directory

  source1=ww3_grid.$modID
  source2=$modID.inp

  if [ -f $data_dir/$source1 ] 
  then
    cp $data_dir/$source1 . 
    echo " Found $source1 ..."
  fi

  if [ -f $data_dir/$source2 ] 
  then
    cp $data_dir/$source2 $source1 
    echo " Found $source2 [renamed $source1] ..."
  fi

  if [ ! -f $source1 ] ; then
    echo "    *** file $source1 not found ; ABORT ***" ; echo ' ' ; exit 1 ; fi

  ifiles="$source1"

  for file in $filelist
  do
    occur=`grep $file $source1 | wc -l | awk '{ print $1}'`
    if [ "$occur" != '0' ] ; then
      cp $data_dir/$file . 
      echo " Found $file ..."
      ifiles="$ifiles $file"
    fi
  done

  sed -n '/^\$.*/!p' $source1 | sed -n '5,/^END OF.*/p' > namelist.data
  echo " Made namelist.data ..."


  if [ -z "$inp_file" ]
  then
    echo " Source for ww3_multi.inp not defined ..."
  else
    echo " Using ww3_multi.inp file [$inp_file] ..."
    if [ $replace ]
    then
       echo "    Replacing this file."
       out_file=$inp_file
    else
       out_file=$inp_file.new
       echo "    New file will be $out_file."
    fi
  fi

  if [ -f $data_dir/$inp_file ] ; then
    cp $data_dir/$inp_file . ; fi

  echo ' '

# --------------------------------------------------------------------------- #
# 2. Make master mod_def file                                                 #
# --------------------------------------------------------------------------- #

  ln -s $source1 ww3_grid.inp

# if [ $verbose ]
# then
#   echo " Making master mod_def file ..."
#   $exe_dir/ww3_grid
# else
    echo " Making master mod_def file, output routed to "
    echo "        $outp_dir/ww3_grid.$modID.out ..."
    $exe_dir/ww3_grid > $outp_dir/ww3_grid.$modID.out
# fi

  rm -f ww3_grid.inp
  mv mod_def.ww3 mod_def.$modID

  for file in $ifiles
  do
    rm -f $file
  done

  echo ' '

# --------------------------------------------------------------------------- #
# 2. Run ww3_gspl                                                             #
# --------------------------------------------------------------------------- #

  if [ "$nr_grid" = '1' ] 
  then

    mv mod_def.$modID $home_dir
    echo ' No splitting of grid required'
    echo ' '
    echo '                     *************************'
    echo '                   *** end of grid splitting ***'
    echo '                     *************************'
    echo ' '
    exit 0
  fi

  if [ $verbose ]
  then
    echo " Run ww3_gspl to get information for sub-grids ..."
  else
    echo " Run ww3_gspl to get information for sub-grids, output routed to"
    echo "        $outp_dir/ww3_gspl.out ..."
  fi

cat > ww3_gspl.inp << EOF
$ -------------------------------------------------------------------- $
$ WAVEWATCH III Grid splitting input file                              $
$ -------------------------------------------------------------------- $
  '$modID'
$
  $nr_grid  $nr_it  $target $halo_ext
$
  $info_bot
  $info_obst
  $info_mask
$
  $comm_first  $comm_last  $frflag
$ -------------------------------------------------------------------- $
$ End of input file                                                    $
$ -------------------------------------------------------------------- $
EOF

  if [ $verbose ]
  then
    $exe_dir/ww3_gspl
    OK="$?"
  else
    $exe_dir/ww3_gspl > $outp_dir/ww3_gspl.out 2>&1
    OK="$?"
  fi
  rm -f ww3_gspl.inp

  if [ "$OK" != 0 ] ; then
    echo ' ' ; echo '   *** ERROR ww3_gspl (ABORT) ***', echo ' ' 
    cat $outp_dir/ww3_gspl.out
    exit 2 ; fi

# --------------------------------------------------------------------------- #
# 3. Process individual grids                                                 #
# --------------------------------------------------------------------------- #

  echo ' '
  echo " Process individual grids ..."

  for file in `ls *.tmpl`
  do
    grdID=`echo $file | sed 's/\./ /g' | awk '{ print $1 }'`
    echo "   Grid $grdID (ww3_grid.$grdID.out) ..."

    sed -e "/NAMELISTS/r namelist.data" \
        -e 's/ NAMELISTS//g' $file > ww3_grid.inp

    $exe_dir/ww3_grid > $outp_dir/ww3_grid.$grdID.out

    mv mod_def.ww3 mod_def.$grdID
    rm -f ww3_grid.inp
    rm -f $grdID.*
  done

  rm -f namelist.data

# --------------------------------------------------------------------------- #
# 4. Process ww3_gint.inp_tmpl                                                #
# --------------------------------------------------------------------------- #

  if [ "$gint" = '1' ]
  then
    echo ' '
    echo " Making ww3_gint.inp_tmpl ..."
    nr_gint=`expr $nr_grid + 1`

cat > ww3_gint.inp_tmpl << EOF
$ -------------------------------------------------------------------- $
$ WAVEWATCH III Grid integration input file                            $
$ -------------------------------------------------------------------- $
  DATE TIME TSTEP NR_STEPS
$
  $nr_gint
$
EOF

  cat ww3_multi.$modID.$nr_grid | awk '{ print $1 }' >> ww3_gint.inp_tmpl
  echo "'$modID'"                                    >> ww3_gint.inp_tmpl

cat >> ww3_gint.inp_tmpl << EOF
$ -------------------------------------------------------------------- $
$ End of input file                                                    $
$ -------------------------------------------------------------------- $
EOF

  fi

# --------------------------------------------------------------------------- #
# 5. Process ww3_multi.inp file                                               #
# --------------------------------------------------------------------------- #

  if [ -z $inp_file ]
  then
    echo ' '
    echo " No file ww3_multi.inp to process ..."
  else
    echo ' '
    echo " Processing file ww3_multi.inp [$inp_file] ..."

    sed -n '/^\$.*/!p' $inp_file > tempfile
    dataold="`head -1 tempfile`"
    rm -f tempfile
    ngrold=`echo $dataold | awk '{ print $1}'`
    ngrnew=`expr $ngrold - 1 + $nr_grid`
    datanew=`echo "$dataold" | sed "s/$ngrold/$ngrnew/"`

    data=`grep $modID $inp_file | head -1 | sed "s/'//g"`
    lev=`echo $data | awk '{ print $2 }'`
    cur=`echo $data | awk '{ print $3 }'`
    wnd=`echo $data | awk '{ print $4 }'`
    ice=`echo $data | awk '{ print $5 }'`
    dt1=`echo $data | awk '{ print $6 }'`
    dt2=`echo $data | awk '{ print $7 }'`
    dt3=`echo $data | awk '{ print $8 }'`
    rnk=`echo $data | awk '{ print $9 }'`
    grp=`echo $data | awk '{ print $10 }'`
    bfl=`echo $data | awk '{ print $13 }'`

    sed -e "s/LEV/$lev/g" \
        -e "s/CUR/$cur/g" \
        -e "s/WND/$wnd/g" \
        -e "s/ICE/$ice/g" \
        -e "s/D1/$dt1/g" \
        -e "s/D2/$dt2/g" \
        -e "s/D3/$dt3/g" \
        -e "s/RANK/$rnk/g" \
        -e "s/GROUP/$grp/g" \
        -e "s/BFLAG/$bfl/g" \
       ww3_multi.$modID.$nr_grid  > ww3_multi.part

    sed -e "s/$dataold/$datanew/g" \
        -e "/$modID/r ww3_multi.part" \
        -ne "/'$modID'/!p" $inp_file > $inp_file.temp

    rm -f ww3_multi.part
    rm -f ww3_multi.$modID.$nr_grid
    if [ "$inp_file" != "$out_file" ] ; then
      rm -f $inp_ifle ; fi
    mv $inp_file.temp $out_file

  fi

# --------------------------------------------------------------------------- #
# 6. saving files                                                             #
# --------------------------------------------------------------------------- #

  echo ' '
  echo " Saving files in $home_dir ..."

  echo "    mod_def files ..."
  mv mod_def.* $home_dir

  for file in ww3_mask.$modID.$nr_grid $out_file ww3_multi.$modID.$nr_grid \
              ww3_gint.inp_tmpl
  do
    if [ -f $file ]
    then
      echo "    file $file ..."
      mv $file $home_dir
    fi
  done

  if [ -f ww3.ctl ]
  then
      echo "    file ww3.ctl ..."
      mv ww3.ctl $home_dir
      echo "    file ww3.ww3_gspl ..."
      mv ww3.ww3_gspl $home_dir
  fi


# --------------------------------------------------------------------------- #
# 6. End of program ID / clean up                                             #
# --------------------------------------------------------------------------- #

  cd $home_dir
  rm -rf $temp_dir
  echo ' '
  echo '                     *************************'
  echo '                   *** end of grid splitting ***'
  echo '                     *************************'
  echo ' '


# End of ww3_gspl.sh -------------------------------------------------------- #

#!/bin/sh
# --------------------------------------------------------------------------- #
# make_makefile.sh : Generates the makefile for WAVEWATCH based on switch     #
#                    settings                                                 #
#                    This script is called by w3_make and therefore does      #
#                    not print header information.                            #
#                                                                             #
# programs used : w3_new  Touches the correct files if compiler switches      #
#                         have been changed.                                  #
#                                                                             #
# error codes : all error output goes directly to screen in w3_make.          #
#                                                                             #
#                                                      Hendrik L. Tolman      #
#                                                      May 2009               #
#                                                      March 2014             #
#                                                                             #
#    Copyright 2009-2014 National Weather Service (NWS),                      #
#       National Oceanic and Atmospheric Administration.  All rights          #
#       reserved.  WAVEWATCH III is a trademark of the NWS.                   #
#       No unauthorized use without permission.                               #
#                                                                             #

# --------------------------------------------------------------------------- #
# 1. Preparations                                                             #
# --------------------------------------------------------------------------- #
# 1.a Internal variables

  ww3_env="${HOME}/.wwatch3.env"                           # setup file
# The following line must not be removed: it is a switch for local install
# so that all bin scripts point to the local wwatch3.env
# WW3ENV
# For manual install (without install_ww3_tar or install_ww3_svn) make sure to
# either use the generic ww3_env or to add your own ww3_env="${my_directory}"

  if [ ${WWATCH3_ENV} ]; then ww3_env="${WWATCH3_ENV}"; fi # alternate setup file

# 1.b ID header  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

# 1.c Read data from the environment file  - - - - - - - - - - - - - - - - - -

  if [ ${WWATCH3_DIR} ] && [ ${WWATCH3_TMP} ]
  then
    main_dir=${WWATCH3_DIR}
    temp_dir=${WWATCH3_TMP}
  elif [ -f $ww3_env ]
  then
    set `grep WWATCH3_DIR $ww3_env` ; shift
    main_dir="$*"
    set `grep WWATCH3_TMP $ww3_env` ; shift
    temp_dir="$*"
  else
     "*** Set-up file $ww3_env not found ***"
    exit 1
  fi

# 1.d Check / make directories   - - - - - - - - - - - - - - - - - - - - - - -

  if [ -d $main_dir ]
  then
    cd $main_dir
  else
    echo "*** Directory $main_dir not found ***"
    exit 2
  fi

  if [ ! -d $temp_dir ]
  then
    mkdir $temp_dir
  fi
  cd $temp_dir

# --------------------------------------------------------------------------- #
# 2. Part 1, subroutine dependencies                                          #
# --------------------------------------------------------------------------- #
# 2.a File ID

  echo ' '                                        > makefile
  echo '# WAVEWATCH III executables'             >> makefile
  echo '# -------------------------'             >> makefile

  rm -f filelist.tmp

# 2.b Get info from switch file  - - - - - - - - - - - - - - - - - - - - - - -

  switch=$main_dir/bin/switch
  old_sw=$main_dir/bin/switch.old
  new_sw=$main_dir/bin/w3_new

  if [ ! -f $old_sw ]
  then
    old_sw=$switch
    $new_sw all
  fi

# NOTE: comment line with '#sort:key:" used by sort_switches, including ':'

  for type in mach nco grib mcp c90 nec lrecl netcdf scrip scripnc \
              shared mpp mpiexp thread GSE prop \
              stress s_ln source stab s_nl snls s_bot s_db miche s_tr s_bs \
              dstress s_ice s_is reflection s_xx \
              wind windx rwind curr currx mgwind mgprop mggse \
              subsec tdyn dss0 pdif tide refrx ig rotag arctic nnt mprf \
              coupl agcm ogcm trknc
  do
    case $type in
#sort:mach:
      mach   ) TY='one'
               ID='hardware or compiler'
               OK='DUM F90' ;;
#sort:nco:
      nco    ) TY='upto1'
               ID='NCO modifications'
               TS='NCO'
               OK='NCO' ;;
#sort:grib:
      grib   ) TY='one'
               ID='GRIB package'
               OK='NOGRB NCEP1 NCEP2' ;;
#sort:mcp:
      mcp    ) TY='upto2'
               ID='model coupling protocol'
               TS='NOPA'
               OK='NOPA PALM NCC' ;;
#sort:c90:
      c90    ) TY='upto1'
               ID='Cray C90 compiler directives'
               TS='C90'
               OK='C90' ;;
#sort:nec:
      nec    ) TY='upto1'
               ID='NEC compiler directives'
               TS='NEC'
               OK='NEC' ;;
#sort:lrecl:
      lrecl  ) TY='one'
               ID='word length in record length'
               OK='LRB4 LRB8' ;;
#sort:netcdf:
      netcdf ) TY='upto1'
               ID='netcdf api type'
               TS='NC4'
               OK='NC4' ;;
#sort:scrip:
      scrip  ) TY='upto1'
               ID='grid to grid interpolation'
               TS='SCRIP'
               OK='SCRIP' ;;
#sort:scripnc:
      scripnc ) TY='upto1'
               ID='use of netcdf in grid to grid interpolation'
               TS='SCRIPNC'
               OK='SCRIPNC' ;;
#sort:shared:
      shared ) TY='one'
               ID='shared / distributed memory'
               OK='SHRD DIST' ;;
#sort:mpp:
      mpp    ) TY='one'
               ID='message passing protocol'
               OK='SHRD MPI' ;;
#sort:mpiexp:
      mpiexp ) TY='upto1'
               ID='experimental MPI option'
               TS='MPIBDI'
               OK='MPIBDI' ;;
#sort:thread:
      thread ) TY='upto2'
               ID='directive controlled threading'
               TS='OMP'
               OK='OMPG OMPX OMPH' ;;
#sort:GSE:
      GSE    ) TY='one'
               ID='GSE aleviation'
               OK='PR0 PR1 PR2 PR3 PRX SMC' ;;
#sort:prop:
      prop   ) TY='one'
               ID='propagation scheme'
               OK='PR0 PR1 UQ UNO SMC' ;;
#sort:stress:
      stress ) TY='one'
               ID='stress computation'
               OK='FLX0 FLX1 FLX2 FLX3 FLX4 FLXX' ;;
#sort:dstress:
      dstress) TY='upto1'
               ID='Diagnostic stress comp'
               TS='FLD'
               OK='FLD0 FLD1 FLD2' ;;
#sort:s_ln:
      s_ln   ) TY='one'
               ID='linear input'
               OK='LN0 SEED LN1 LNX' ;;
#sort:source:
      source ) TY='one'
               ID='input/whitecapping'
               OK='ST0 ST1 ST2 ST3 ST4 ST6 STX' ;;
#sort:stab:
      stab   ) TY='upto1'
               ID='stability correction'
               TS='STAB'
               OK='STAB0 STAB2 STAB3' ;;
#sort:s_nl:
      s_nl   ) TY='one'
               ID='quadruplet interactions'
               OK='NL0 NL1 NL2 NL3 NL4 NLX' ;;
#sort:snls:
      snls   ) TY='upto1'
               ID='quadruplet smoother'
               TS='NLS'
               OK='NLS' ;;
#sort:s_bot:
      s_bot  ) TY='one'
               ID='bottom friction'
               OK='BT0 BT1 BT4 BT8 BT9 BTX' ;;
#sort:s_db:
      s_db   ) TY='one'
               ID='depth-induced breaking'
               OK='DB0 DB1 DBX' ;;
#sort:miche:
      miche  ) TY='upto1'
               ID='Miche style limiter'
               TS='MLIM'
               OK='MLIM' ;;
#sort:s_tr:
      s_tr   ) TY='one'
               ID='triad interactions'
               OK='TR0 TR1 TRX' ;;
#sort:s_bs:
      s_bs   ) TY='one'
               ID='bottom scattering'
               OK='BS0 BS1 BSX' ;;
#sort:s_ice:
      s_ice  ) TY='one'
               ID='ice sink term'
               OK='IC0 IC1 IC2 IC3 IC4' ;;
#sort:s_is:
      s_is  ) TY='one'
               ID='ice scattering term'
               OK='IS0 IS1 IS2' ;;
#sort:reflection:
  reflection ) TY='one'
               ID='wave reflections'
               OK='REF0 REF1' ;;
#sort:s_xx:
      s_xx   ) TY='one'
               ID='arbitrary source'
               OK='XX0 XXX' ;;
#sort:wind:
      wind   ) TY='one'
               ID='wind interpolation in time'
               OK='WNT0 WNT1 WNT2' ;;
#sort:windx:
      windx  ) TY='one'
               ID='wind interpolation in space'
               OK='WNX0 WNX1 WNX2' ;;
#sort:rwind:
      rwind  ) TY='upto1'
               ID='wind vs. current definition'
               TS='RWND'
               OK='RWND' ;;
#sort:curr:
      curr   ) TY='one'
               ID='current interpolation in time'
               OK='CRT0 CRT1 CRT2' ;;
#sort:currx:
      currx  ) TY='one'
               ID='current interpolation in space'
               OK='CRX0 CRX1 CRX2' ;;
#sort:mgwind:
      mgwind ) TY='upto1'
               ID='moving grid wind correction'
               TS='MGW'
               OK='MGW' ;;
#sort:mgprop:
      mgprop ) TY='upto1'
               ID='moving grid propagation correction'
               TS='MGP'
               OK='MGP' ;;
#sort:mggse:
      mggse  ) TY='upto1'
               ID='moving grid GSE correction'
               TS='MGG'
               OK='MGG' ;;
#sort:subsec:
      subsec ) TY='upto1'
               ID='sub-second time stepping'
               TS='SEC1'
               OK='SEC1' ;;
#sort:tdyn:
      tdyn   ) TY='upto1'
               ID='dynamic diffusion time'
               TS='TDYN'
               OK='TDYN' ;;
#sort:dss0:
      dss0   ) TY='upto1'
               ID='diffusion tensor'
               TS='DSS0'
               OK='DSS0' ;;
#sort:pdif:
      pdif   ) TY='upto1'
               ID='propagation diffusion'
               TS='XW'
               OK='XW0 XW1' ;;
#sort:tide:
      tide   ) TY='upto1'
               ID='use of tidal analysis'
               TS='TIDE'
               OK='TIDE' ;;
#sort:refrx:
      refrx  ) TY='upto1'
               ID='use of spectral refraction @C/@x'
               TS='REFRX'
               OK='REFRX' ;;
#sort:ig:
      ig     ) TY='upto1'
               ID='infragravity waves'
               TS='IG1'
               OK='IG1' ;;
#sort:rotag:
      rotag  ) TY='upto1'
               ID='rotated grid'
               TS='RTD'
               OK='RTD' ;;
#sort:arctic:
      arctic ) TY='upto1'
               ID='Arctic grid'
               TS='ARC'
               OK='ARC' ;;
#sort:nnt:
      nnt    ) TY='upto1'
               ID='NN training/test data generation'
               TS='NNT'
               OK='NNT' ;;
#sort:mprf:
      mprf   ) TY='upto1'
               ID='multi-grid model profiling'
               TS='MPRF'
               OK='MPRF' ;;
#sort:agcm:
      agcm   ) TY='upto1'
               ID='atmospheric circulation model'
               TS='OASACM'
               OK='OASACM' ;;
#sort:ogcm:
      ogcm   ) TY='upto1'
               ID='ocean circulation model'
               TS='OASOCM'
               OK='OASOCM' ;;
#sort:coupl:
      coupl  ) TY='upto1'
               ID='type of the coupler'
               TS='OASIS'
               OK='OASIS' ;;
#sort:trknc:
      trknc  ) TY='upto1'
               ID='use of netcdf for tracking of wave systems'
               TS='TRKNC'
               OK='TRKNC' ;;
   esac

    n_found='0'
    s_found=
    for check in $OK
    do
      if [ "`grep $check $switch | wc -w | awk '{print $1}'`" -gt '1' ]
      then
        n_found=`expr $n_found + 1`
        s_found="$s_found $check"
      fi
    done

    if [ "$n_found" != '1' ] && [ "$TY" = 'one' ]
    then
      echo ' '
      echo "   *** No valid $ID switch found  ***"
      echo "       valid : $OK"
      echo "       found : $s_found"
      echo ' ' ; exit 3
    fi

    if [ "$n_found" -gt '1' ] && [ "$TY" = 'upto1' ]
    then
      echo ' '
      echo "   *** Too many $ID switches found (max 1) ***"
      echo "       valid : $OK"
      echo "       found : $s_found"
      echo ' ' ; exit 4
    fi

    if [ "$n_found" -gt '2' ] && [ "$TY" = 'upto2' ]
    then
      echo ' '
      echo "   *** Too many $ID switches found (max 2) ***"
      echo "       valid : $OK"
      echo "       found : $s_found"
      echo ' ' ; exit 5
    fi

    if [ "$TY" = 'man' ]
    then
      echo "   w3_new $type has to be run manually"
    else
      if [ "$n_found" = '1' ]
      then
        sw="`echo $s_found | awk '{ print $1 }'`"
        if [ "`grep $sw $old_sw | wc -w | awk '{print $1}'`" -lt '1' ]
        then
          $new_sw $type
          echo "   new $ID"
        fi
      else
        if [ "`grep $TS $old_sw | wc -w | awk '{print $1}'`" -gt '1' ]
        then
          $new_sw $type
          echo "   new $ID"
        fi
      fi
    fi

    if [ "$n_found" = '1' ]
    then
      sw="`echo $s_found | awk '{ print $1 }'`"
    else
      sw=
    fi

    if [ "$type" = 'thread' ]
    then
      sw1="`echo $s_found | awk '{ print $1 }'`"
      sw2="`echo $s_found | awk '{ print $2 }'`"
    fi

    if [ "$type" = 'mcp' ] && [ "$n_found" -gt '1' ]
    then
      sw1="`echo $s_found | awk '{ print $1 }'`"
      sw2="`echo $s_found | awk '{ print $2 }'`"
      if [ "$sw1" = 'NOPA' ]
      then
        sw=$sw2
      else
        sw=$sw1
      fi
    fi

    case $type in
      shared ) shared=$sw ;;
      mpp    ) mpp=$sw ;;
      mpiexp ) mpiexp=$sw ;;
      thread ) thread1=$sw1 ; thread2=$sw2 ;;
      GSE    ) g_switch=$sw ;;
      prop   ) p_switch=$sw ;;
      s_ln   ) s_ln=$sw ;;
      source ) s_inds=$sw ;;
      stab   ) stab=$sw ;;
      stress ) stress=$sw ;;
      dstress) dstress=$sw ;;
      scrip  ) scrip=$sw ;;
      scripnc) scripnc=$sw ;;
      s_nl   ) s_nl=$sw ;;
      snls   ) snls=$sw ;;
      s_bot  ) s_bt=$sw ;;
      s_ice  ) s_ic=$sw ;;
      s_is   ) s_is=$sw ;;
      s_db   ) s_db=$sw ;;
      s_tr   ) s_tr=$sw ;;
      s_bs   ) s_bs=$sw ;;
      s_xx   ) s_xx=$sw ;;
      reflection    ) reflection=$sw ;;
      refrx  ) refrx=$sw ;;
      ig     ) ig=$sw ;;
      mcp    ) mcp=$sw ;;
      netcdf ) netcdf=$sw;;
      tide   ) tide=$sw ;;
      arctic ) arctic=$sw ;;
      mprf   ) mprf=$sw ;;
      coupl  ) coupl=$sw ;;
      agcm   ) agcm=$sw ;;
      ogcm   ) ogcm=$sw ;;
      trknc  ) trknc=$sw ;;
              *    ) ;;
    esac
  done

  if [ -n "$thread1" ] && [ -z "$thread2" ]
  then
      echo ' '
      echo "   *** !/OMPX or !/OMPH has to be used in combination with !/OMPG"
      echo ' ' ; exit 6
  fi

  if [ -n "$thread2" ] && [ "$thread1" != 'OMPG' ]
  then
      echo ' '
      echo "   *** !/OMPX or !/OMPH has to be used in combination with !/OMPG"
      echo ' ' ; exit 6
  fi

  if [ "$thread2" = 'OMPX' ] && [ "$shared" != 'SHRD' ]
  then
      echo ' '
      echo "   *** !/OMPX has to be used in combination with !/SHRD"
      echo ' ' ; exit 7
  fi

  if [ "$thread2" = 'OMPH' ] && [ "$mpp" != 'MPI' ]
  then
      echo ' '
      echo "   *** !/OMPH has to be used in combination with !/MPI"
      echo ' ' ; exit 8
  fi

  if [ "$arctic" = 'ARC' ] && [ "$p_switch" != 'SMC' ]
  then
      echo ' '
      echo "   *** !/ARC has to be used in combination with !/SMC"
      echo ' ' ; exit 9
  fi

  case $g_switch in
   PR0) pr=$NULL ;;
   PR1) pr='w3profsmd w3pro1md' ;;
   PR2) pr='w3profsmd w3pro2md' ;;
   PR3) pr='w3profsmd w3pro3md' ;;
   SMC) pr='w3psmcmd' ;;
  esac 

  case $p_switch in
   UQ ) pr="$pr w3uqckmd" ;;
   UNO) pr="$pr w3uno2md" ;;
  esac 

  case $stress in
   FLX0) str_st1='no' ; str_st2='no' ; str_st3='yes' ; str_st6='no'
         flx='w3flx1md'
         flxx=$NULL ;;
   FLX1) str_st1='OK' ; str_st2='no' ; str_st3='no' ; str_st6='OK'
         flx='w3flx1md'
         flxx=$NULL ;;
   FLX2) str_st1='OK' ; str_st2='OK' ; str_st3='no' ; str_st6='OK'
         flx='w3flx2md'
         flxx=$NULL ;;
   FLX3) str_st1='OK' ; str_st2='OK' ; str_st3='no' ; str_st6='OK'
         flx='w3flx3md'
         flxx=$NULL ;;
   FLX4) str_st1='OK' ; str_st2='no' ; str_st3='no' ; str_st6='OK'
         flx='w3flx4md'
         flxx=$NULL ;;

   FLXX) str_st1='no' ; str_st2='no' ; str_st3='no'
         flx='w3flxxmd'
         flxx=$NULL ;;
  esac

  case $dstress in
   FLD0) ds=$NULL
         dsx=$NULL ;;
   FLD1) ds=$NULL
         dsx='w3fld1md' ;;
   FLD2) ds=$NULL
         dsx='w3fld1md w3fld2md' ;;
  esac

  case $s_ln in
   LN0) ln=$NULL
        lnx=$NULL ;;
   LN1) ln='w3sln1md'
        lnx=$NULL ;;
   LNX) ln='w3slnxmd'
        lnx=$NULL ;;
  esac

  case $s_inds in
   ST0) st='w3src0md'
        stx=$NULL ;;
   ST1) st='w3src1md'
        stx=$NULL ;;
   ST2) st='w3src2md'
        stx='w3src2md' ;;
   ST3) st='w3src3md'
        stx='w3src3md' ;;
   ST4) st='w3src4md'
        stx='w3src4md' ;;
   ST6) st='w3src6md w3swldmd'
        stx='w3src6md' ;;
   STX) st='w3srcxmd'
        stx=$NULL ;;
  esac

  if [ "$stab" = 'STAB2' ] && [ "$s_inds" != 'ST2' ]
  then
      echo ' '
      echo "   *** !/STAB2 has to be used in combination with !/ST2"
      echo ' ' ; exit 10
  fi

  if [ "$stab" = 'STAB3' ] && [ "$s_inds" != 'ST3' ]
  then
      if [ "$s_inds" != 'ST4' ]
      then
        echo ' '
        echo "   *** !/STAB3 has to be used in combination with !/ST3 or !/ST4"
        echo ' ' ; exit 10
      fi
  fi

  if [ "$s_inds" = 'ST1' ] && [ "$str_st1" = 'no' ]
  then
      echo ' '
      echo "   *** !/ST1 cannot be used in combination with !/$stress"
      echo "       Choose from FLX1, FLX2, FLX3, or FLX4."
      echo ' ' ; exit 11
  fi

  if [ "$s_inds" = 'ST2' ] && [ "$str_st2" = 'no' ]
  then
      echo ' '
      echo "   *** !/ST2 cannot be used in combination with !/$stress"
      echo "       Choose from FLX2 or FLX3."
      echo ' ' ; exit 11
  fi

  if [ "$s_inds" = 'ST3' ] && [ "$str_st3" = 'no' ]
  then
      echo ' '
      echo "   *** !/ST3 cannot be used in combination with !/$stress"
      echo "       Stresses embedded in source terms, use FLX0."
      echo ' ' ; exit 11
  fi
  if [ "$s_inds" = 'ST4' ] && [ "$str_st3" = 'no' ]
  then
      echo ' '
      echo "   *** !/ST4 cannot be used in combination with !/$stress"
      echo "       Stresses embedded in source terms, use FLX0."
      echo ' ' ; exit 11
  fi
  if [ "$s_inds" = 'ST6' ] && [ "$str_st6" = 'no' ]
  then
      echo ' '
      echo "   *** !/ST6 cannot be used in combination with !/$stress"
      echo "       Choose from FLX1, FLX2, FLX3, or FLX4."
      echo ' ' ; exit 11
  fi

  case $s_nl in
   NL0) nl=$NULL
        nlx=$NULL ;;
   NL1) nl='w3snl1md'
        nlx='w3snl1md' ;;
   NL2) nl='w3snl2md mod_xnl4v5 serv_xnl4v5 mod_constants mod_fileio'
        nlx="$nl" ;;
   NL3) nl='w3snl3md'
        nlx='w3snl3md' ;;
   NL4) nl='w3snl4md'
        nlx='w3snl4md' ;;
   NLX) nl='w3snlxmd'
        nlx='w3snlxmd' ;;
  esac

  case $snls in
   NLS) nl="$nl w3snlsmd"
        nlx="$nlx w3snlsmd" ;;
  esac

  case $s_bt in
   BT0) bt=$NULL ;;
   BT1) bt='w3sbt1md' ;;
   BT2) bt='w3sbt2md mod_btffac' ;;
   BT4) bt='w3sbt4md' ;;
   BT8) bt='w3sbt8md' ;;
   BT9) bt='w3sbt9md' ;;
   BTX) bt='w3sbtxmd' ;;
  esac

  case $s_db in
   DB0) db=$NULL
        dbx=$NULL ;;
   DB1) db='w3sdb1md'
        dbx=$NULL ;;
   DBX) db='w3sdbxmd'
        dbx=$NULL ;;
  esac

  case $s_tr in
   TR0) tr=$NULL
        trx=$NULL ;;
   TR1) tr='w3str1md'
        trx=$NULL ;;
   TRX) tr='w3strxmd'
        trx=$NULL ;;
  esac

  case $s_bs in
   BS0) bs=$NULL
        bsx=$NULL ;;
   BS1) bs='w3sbs1md'
        bsx=$NULL ;;
   BSX) bs='w3sbsxmd'
        bsx=$NULL ;;
  esac

  ic=$NULL
  case $s_ic in
   IC1) ic='w3sic1md' ;;
   IC2) ic='w3sic2md' ;;
   IC3) ic='w3sic3md' ;;
   IC4) ic='w3sic4md' ;;
  esac

  is=$NULL
  case $s_is in
   IS1) is='w3sis1md' ;;
   IS2) is='w3sis2md' ;;
  esac

  refcode=$NULL
  case $reflection in
   REF1) refcode='w3ref1md'
   esac

  case $s_xx in
   XX0) xx=$NULL
        xxx=$NULL ;;
   XXX) xx='w3sxxxmd'
        xxx=$NULL ;;
  esac

  tidecode=$NULL
  tideprog=$NULL
  case $tide in
   TIDE) tidecode='w3tidemd'
         tideprog='ww3_prtide'
   esac

  case $ig in
   IG1) igcode='w3gig1md w3canomd'
   esac

  couplmd=$NULL
  case $coupl in
   OASIS) couplmd='w3oacpmd'
   esac

  if [ "$coupl" = 'OASIS' ] && [ "$str_st3" = 'no' ]
  then
      echo ' '
      echo "   *** !/OASIS cannot be used in combination with !/$stress"
      echo "       Stresses embedded in source terms, use FLX0."
      echo ' ' ; exit 11
  fi

  agcmmd=$NULL
  case $agcm in
   OASACM) agcmmd='w3agcmmd'
   esac

  ogcmmd=$NULL
  case $ogcm in
   OASOCM) ogcmmd='w3ogcmmd'
   esac

  cplcode=$NULL
  case $mcp in 
   NCC) cplcode='cmp.comm ww.comm'
  esac

  if [ -n "$thread1" ] && [ "$s_nl" = 'NL2' ]
  then
      echo ' '
      echo "   *** The present version of the WRT interactions"
      echo "       cannot be run under OpenMP (OMPG OMPX, OMPH). Use"
      echo "       SHRD or MPI options instead.                    ***"
      echo ' ' ; exit 12
  fi

  if [ "$mprf" = "MPRF" ]
  then
    mprfaux='w3getmem'
  else
    mprfaux=$NULL
  fi


# 2.c Make makefile and file list  - - - - - - - - - - - - - - - - - - - - - -

  progs="ww3_grid ww3_strt ww3_prep ww3_prnc ww3_shel ww3_multi ww3_sbs1
         ww3_outf ww3_outp ww3_trck ww3_trnc ww3_grib gx_outf gx_outp ww3_ounf 
         ww3_ounp ww3_gspl ww3_gint ww3_bound ww3_bounc ww3_systrk $tideprog"

  for prog in $progs
  do
    case $prog in
     ww3_grid) IDstring='Grid preprocessor'
               core=
               data='w3wdatmd w3gdatmd w3adatmd w3idatmd w3odatmd'
               prop=
             source="w3triamd $stx $nlx $btx $is"
                 IO='w3iogrmd'
                aux='constants w3servmd w3arrymd w3dispmd w3gsrumd w3timemd' ;;
     ww3_strt) IDstring='Initial conditions program'
               core=
               data='w3gdatmd w3wdatmd w3adatmd w3idatmd w3odatmd'
               prop=
             source="$stx $nlx $btx $is"
                 IO='w3iogrmd w3iorsmd'
                aux='constants w3triamd w3servmd w3arrymd w3dispmd w3gsrumd w3timemd' ;;
     ww3_bound) IDstring='boundary conditions program'
               core=
               data='w3adatmd w3gdatmd w3wdatmd w3idatmd w3odatmd'
               prop=
             source="$stx $nlx $btx  $is w3triamd"
                 IO='w3iobcmd w3iogrmd w3dispmd w3gsrumd'
                aux='constants w3servmd w3timemd w3cspcmd' ;;
     ww3_bounc) IDstring='NetCDF boundary conditions program'
               core=
               data='w3adatmd w3gdatmd w3wdatmd w3idatmd w3odatmd'
               prop=
             source="$stx $nlx $btx  $is w3triamd"
                 IO='w3iobcmd w3iogrmd w3dispmd w3gsrumd'
                aux='constants w3servmd w3timemd w3cspcmd' ;;
     ww3_prep) IDstring='Field preprocessor'
               core='w3fldsmd'
               data='w3gdatmd w3adatmd w3idatmd w3odatmd w3wdatmd'
               prop=
             source="w3triamd $stx $nlx $btx  $is"
                 IO="w3iogrmd $couplmd $agcmmd $ogcmmd"
                aux="constants w3servmd w3timemd $tidecode w3arrymd w3dispmd w3gsrumd" ;;
     ww3_prnc) IDstring='NetCDF field preprocessor'
               core='w3fldsmd'
               data='w3gdatmd w3adatmd w3idatmd w3odatmd w3wdatmd'
               prop=
             source="w3triamd $stx $nlx $btx $is"
                 IO="w3iogrmd $couplmd $agcmmd $ogcmmd"
                aux="constants w3servmd w3timemd w3arrymd w3dispmd w3gsrumd $tidecode" ;;
     ww3_prtide) IDstring='Tide prediction'
               core='w3fldsmd'
               data='w3gdatmd w3adatmd w3idatmd w3odatmd'
               prop=
             source="w3triamd $stx $nlx $btx $is"
                 IO="w3iogrmd $couplmd $agcmmd $ogcmmd"
                aux="constants w3servmd w3timemd w3arrymd w3dispmd w3gsrumd $tidecode" ;;
     ww3_shel) IDstring='Generic shell'
               core='w3fldsmd w3initmd w3wavemd w3wdasmd w3updtmd'
               data='wmmdatmd w3gdatmd w3wdatmd w3adatmd w3idatmd w3odatmd'
               prop="$pr"
             source="w3triamd w3srcemd $dsx $flx $ln $st $nl $bt $ic $is $db $tr $bs $xx $refcode $igcode"
                 IO="w3iogrmd w3iogomd w3iopomd w3iotrmd w3iorsmd w3iobcmd $couplmd $agcmmd $ogcmmd"
                 IO="$IO w3iosfmd w3partmd"
                aux="constants w3servmd w3timemd $tidecode w3arrymd w3dispmd w3cspcmd w3gsrumd $cplcode"
                aux="$aux w3namlmd" ;;
    ww3_multi) IDstring='Multi-grid shell'
               core='wminitmd wmwavemd wmfinlmd wmgridmd wmupdtmd wminiomd'
               core="$core w3fldsmd w3initmd w3wavemd w3wdasmd w3updtmd"
               data='wmmdatmd w3gdatmd w3wdatmd w3adatmd w3idatmd w3odatmd'
               prop="$pr"
             source="w3triamd w3srcemd $dsx $flx $ln $st $nl $bt $ic $is $db $tr $bs $xx $refcode $igcode"
                 IO='w3iogrmd w3iogomd w3iopomd wmiopomd'
                 IO="$IO w3iotrmd w3iorsmd w3iobcmd w3iosfmd w3partmd $couplmd $agcmmd $ogcmmd"
                aux="constants $tidecode w3servmd w3timemd w3arrymd w3dispmd w3cspcmd w3gsrumd $mprfaux"
                aux="$aux  wmunitmd w3namlmd" 
                if [ "$scrip" = 'SCRIP' ]
                then
                  aux="$aux scrip_constants scrip_grids scrip_iounitsmod"
                  aux="$aux scrip_remap_vars scrip_timers scrip_errormod scrip_interface"
                  aux="$aux scrip_kindsmod scrip_remap_conservative wmscrpmd"
                fi 
                if [ "$scripnc" = 'SCRIPNC' ]
                then
                  aux="$aux scrip_netcdfmod scrip_remap_write scrip_remap_read"
                fi ;;
   ww3_sbs1) IDstring='Multi-grid shell sbs version' 
               core='wminitmd wmwavemd wmfinlmd wmgridmd wmupdtmd wminiomd' 
               core="$core w3fldsmd w3initmd w3wavemd w3wdasmd w3updtmd" 
               data='wmmdatmd w3gdatmd w3wdatmd w3adatmd w3idatmd w3odatmd' 
               prop="$pr" 
               source="w3triamd w3srcemd $dsx $flx $ln $st $nl $bt $db $tr $bs $xx $refcode $igcode $is $ic" 
                 IO='w3iogrmd w3iogomd w3iopomd wmiopomd' 
                 IO="$IO w3iotrmd w3iorsmd w3iobcmd w3iosfmd w3partmd $couplmd $agcmmd $ogcmmd" 
                aux="constants w3servmd w3timemd w3arrymd w3dispmd w3cspcmd w3gsrumd $mprfaux $tidecode" 
                aux="$aux  wmunitmd w3namlmd"  
                if [ "$scrip" = 'SCRIP' ]
                then
                  aux="$aux scrip_constants scrip_grids scrip_iounitsmod"
                  aux="$aux scrip_remap_vars scrip_timers scrip_errormod scrip_interface"
                  aux="$aux scrip_kindsmod scrip_remap_conservative wmscrpmd"
                fi 
                if [ "$scripnc" = 'SCRIPNC' ]
                then
                  aux="$aux scrip_netcdfmod scrip_remap_write scrip_remap_read"
                fi ;;
     ww3_outf) IDstring='Gridded output'
               core=
               data='wmmdatmd w3gdatmd w3wdatmd w3adatmd w3idatmd w3odatmd'
               prop=
             source="$stx $nlx $btx $is"
                 IO='w3iogrmd w3iogomd'
                aux='constants w3servmd w3timemd w3arrymd w3dispmd w3gsrumd'
                aux="$aux w3namlmd" ;;
     ww3_ounf) IDstring='Gridded NetCDF output'
               core='w3initmd'
               data='wmmdatmd w3gdatmd w3wdatmd w3adatmd w3idatmd w3odatmd'
               prop=
             source="w3triamd $stx $nlx $btx  $is"
                 IO='w3iogrmd w3iogomd w3iorsmd w3iopomd'
                aux='constants w3servmd w3timemd w3arrymd w3dispmd w3gsrumd'
                aux="$aux w3namlmd" ;;
     ww3_outp) IDstring='Point output'
               core=
               data='w3triamd w3gdatmd w3wdatmd w3adatmd w3idatmd w3odatmd'
               prop=
             source="$flx $ln $st $nl $bt $ic $is $db $tr $bs $xx $igcode"
                 IO='w3bullmd w3iogrmd w3iopomd w3partmd'
                aux='constants w3servmd w3timemd w3arrymd w3dispmd w3gsrumd' ;;
     ww3_ounp) IDstring='Point NetCDF output'
               core=
               data='w3triamd w3gdatmd w3wdatmd w3adatmd w3idatmd w3odatmd'
               prop=
             source="$flx $ln $st $nl $bt $ic $is $db $tr $bs $xx $igcode"
                 IO='w3bullmd w3iogrmd w3iopomd w3partmd'
                aux='constants w3servmd w3timemd w3arrymd w3dispmd w3gsrumd' ;;
     ww3_trck) IDstring='Track output post'
               core=
               data='w3gdatmd w3odatmd'
               prop=
             source=
                 IO=
                aux="constants w3servmd w3timemd w3gsrumd" ;;
     ww3_trnc) IDstring='Track NetCDF output post'
               core=
               data='w3gdatmd w3odatmd'
               prop=
             source=
                 IO=
                aux="constants w3servmd w3timemd w3gsrumd" ;;
     ww3_grib) IDstring='Gridded output (GRIB)'
               core=
               data='wmmdatmd w3triamd w3gdatmd w3wdatmd w3adatmd w3idatmd w3odatmd'
               prop=
             source="$stx $nlx $btx $is"
                 IO='w3iogrmd w3iogomd'
                aux='constants w3servmd w3timemd w3arrymd w3dispmd w3gsrumd'
                aux="$aux w3namlmd" ;;
     ww3_gspl) IDstring='Grid splitting'
               core='w3fldsmd'
               data='w3gdatmd w3wdatmd w3adatmd w3idatmd w3odatmd'
               prop=
             source="w3triamd $stx $nlx $btx $is"
                 IO="w3iogrmd  $couplmd $agcmmd $ogcmmd"
                aux="constants w3servmd w3timemd w3arrymd w3dispmd w3gsrumd $tidecode" ;;
     ww3_gint) IDstring='Grid Interpolation'
               core=
               data='wmmdatmd w3gdatmd w3wdatmd w3adatmd w3idatmd w3odatmd'
                 IO='w3iogrmd w3iogomd'
               prop=
             source="$st $nl $is"
                aux='constants w3triamd w3servmd  w3arrymd w3dispmd w3timemd w3gsrumd'
                aux="$aux w3namlmd" ;;
      gx_outf) IDstring='GrADS input file generation (gridded fields)'
               core=
               data='wmmdatmd w3gdatmd w3wdatmd w3adatmd w3idatmd w3odatmd'
               prop=
             source="w3triamd $stx $nlx $btx $db $tr $bs $xx $is"
                 IO='w3iogrmd w3iogomd'
                aux='constants w3servmd w3timemd w3arrymd w3dispmd w3gsrumd'
                aux="$aux w3namlmd" ;;
      gx_outp) IDstring='GrADS input file generation for point output'
               core=
               data='w3triamd w3gdatmd w3wdatmd w3adatmd w3idatmd w3odatmd'
               prop=
             source="$flx $ln $st $nl $bt $ic $is $db $tr $bs $xx"
                 IO='w3iogrmd w3iopomd'
                aux='constants w3servmd w3timemd w3arrymd w3dispmd w3gsrumd' ;;
      ww3_systrk) IDstring='Wave system tracking postprocessor'
               core='w3strkmd'
               data=
               prop=
             source=
                 IO=
                aux='constants w3servmd w3timemd' ;;
    esac

    d_string='$(aPe)/'"$prog"' : $(aPo)/'

    files="$aux $core $data $prop $source $IO $prog"
    filesl="$prog $data $core $prop $source $IO $aux"

    echo "# $IDstring"                           >> makefile
    echo ' '                                     >> makefile
    for file in $files
    do
      echo "$d_string$file.o"                    >> makefile
      if [ -z "`echo $file | grep scrip 2>/dev/null`" ]
      then
      echo "$file"                               >> filelist.tmp
      fi
    done

    echo '	@$(aPb)/link '"$filesl"          >> makefile
    echo ' '                                     >> makefile
  done

  sort -u filelist.tmp                            > filelist
  rm -f filelist.tmp

# --------------------------------------------------------------------------- #
# 3. Part 2, includes in subroutines                                          #
# --------------------------------------------------------------------------- #
# 3.a File ID

  echo '   Checking all subroutines for modules (this may take a while) ...'

  echo ' '                                       >> makefile
  echo '# WAVEWATCH III subroutines'             >> makefile
  echo '# -------------------------'             >> makefile
  echo ' '                                       >> makefile

# 3.b Loop over files

  for file in `cat filelist`
  do

    suffixes="ftn f F f90 F90 c"
    fexti=none
    for s in $suffixes
    do
      if [ -f $main_dir/ftn/$file.$s ]
      then
        fexti=$s
        break
      fi
    done
    if [ "$fexti" = 'none' ]
    then
      echo '      *** make_makefile.sh error ***'
      echo "          Source file $main_dir/ftn/$file.* not found"
      echo "          Source file suffixes checked: $suffixes"
      exit 2
    fi
    if [ "$fexti" = 'ftn' ]
    then
      fexto=F90
    else
      fexto=$fexti
    fi

    string1='$(aPo)/'$file'.o : '$file.$fexti' 'w3macros.h' '
    string2='	@$(aPb)/ad3'" $file"
    string3="$NULL"

    $main_dir/bin/ad3 $file 0 1 > ad3.out 2>&1

    if [ -n "`grep error ad3.out`" ]
    then
      cat ad3.out
      exit 20
    fi
    rm -f ad3.out

    if [ "$fexto" = 'c' ]
    then
      touch check_file
    else
      grep USE $file.$fexto  > check_file
      grep use $file.$fexto >> check_file
    fi
    rm -f $file.$fexto

    for mod in W3INITMD W3WAVEMD W3WDASMD W3UPDTMD W3FLDSMD W3CSPCMD \
               W3GDATMD W3WDATMD W3ADATMD W3ODATMD W3IDATMD \
               W3FLD1MD  W3FLD2MD \
               W3IOGRMD W3IOGOMD W3IOPOMD W3IOTRMD W3IORSMD W3IOBCMD \
                        W3IOSFMD W3PARTMD W3BULLMD \
               W3TIDEMD W3CANOMD W3GIG1MD W3STRKMD \
               W3PRO1MD W3PRO2MD W3PRO3MD W3PROXMD \
                        W3UQCKMD W3UNO2MD W3PSMCMD W3PROFSMD \
               W3SRCEMD W3FLX1MD W3FLX2MD W3FLX3MD W3FLX4MD W3FLXXMD \
               W3SLN1MD W3SLNXMD \
               W3SRC0MD W3SRC1MD W3SRC2MD W3SRC3MD W3SRC4MD \
                        W3SRC6MD W3SRCXMD \
               W3SNL1MD W3SNL2MD W3SNL3MD W3SNL4MD W3SNLXMD W3SNLSMD \
                        m_xnldata serv_xnl4v5 m_fileio m_constants \
               W3SWLDMD \
               W3SBT1MD W3SBT4MD W3SBT8MD W3SBT9MD W3SBTXMD \
               W3SDB1MD W3SDBXMD \
               W3STR1MD W3STRXMD \
               W3SBS1MD W3SBSXMD \
               W3SIC1MD W3SIC2MD W3SIC3MD W3SIC4MD W3SIS1MD W3SIS2MD \
               W3REF1MD \
               W3SXXXMD \
              CONSTANTS W3SERVMD W3TIMEMD W3ARRYMD W3DISPMD W3GSRUMD W3TRIAMD \
               WMINITMD WMWAVEMD WMFINLMD WMMDATMD WMGRIDMD WMUPDTMD \
               WMUNITMD WMINIOMD WMIOPOMD WMSCRPMD \
               w3getmem WW_cc CMP_COMM W3OACPMD W3AGCMMD W3OGCMMD W3NAMLMD
      do
      case $mod in
         'W3INITMD'     ) modtest=w3initmd.o ;;
         'W3WAVEMD'     ) modtest=w3wavemd.o ;;
         'W3WDASMD'     ) modtest=w3wdasmd.o ;;
         'W3UPDTMD'     ) modtest=w3updtmd.o ;;
         'W3FLDSMD'     ) modtest=w3fldsmd.o ;;
         'W3CSPCMD'     ) modtest=w3cspcmd.o ;;
         'W3GDATMD'     ) modtest=w3gdatmd.o ;;
         'W3WDATMD'     ) modtest=w3wdatmd.o ;;
         'W3ADATMD'     ) modtest=w3adatmd.o ;;
         'W3ODATMD'     ) modtest=w3odatmd.o ;;
         'W3IDATMD'     ) modtest=w3idatmd.o ;;
         'W3FLD1MD'     ) modtest=w3fld1md.o ;;
         'W3FLD2MD'     ) modtest=w3fld2md.o ;;
         'W3IOGRMD'     ) modtest=w3iogrmd.o ;;
         'W3IOGOMD'     ) modtest=w3iogomd.o ;;
         'W3IOPOMD'     ) modtest=w3iopomd.o ;;
         'W3IOTRMD'     ) modtest=w3iotrmd.o ;;
         'W3IORSMD'     ) modtest=w3iorsmd.o ;;
         'W3IOBCMD'     ) modtest=w3iobcmd.o ;;
         'W3IOSFMD'     ) modtest=w3iosfmd.o ;;
         'W3PARTMD'     ) modtest=w3partmd.o ;;
         'W3BULLMD'     ) modtest=w3bullmd.o ;;
         'W3TIDEMD'     ) modtest=w3tidemd.o ;;
         'W3CANOMD'     ) modtest=w3canomd.o ;;
         'W3GIG1MD'     ) modtest=w3gig1md.o ;;
         'W3STRKMD'     ) modtest=w3strkmd.o ;;
         'W3PRO1MD'     ) modtest=w3pro1md.o ;;
         'W3PRO2MD'     ) modtest=w3pro2md.o ;;
         'W3PRO3MD'     ) modtest=w3pro3md.o ;;
         'W3PROXMD'     ) modtest=w3proxmd.o ;;
         'W3UQCKMD'     ) modtest=w3uqckmd.o ;;
         'W3UNO2MD'     ) modtest=w3uno2md.o ;;
         'W3PSMCMD'     ) modtest=w3psmcmd.o ;;
         'W3PROFSMD'    ) modtest=w3profsmd.o ;;
         'W3SRCEMD'     ) modtest=w3srcemd.o ;;
         'W3FLX1MD'     ) modtest=w3flx1md.o ;;
         'W3FLX2MD'     ) modtest=w3flx2md.o ;;
         'W3FLX3MD'     ) modtest=w3flx3md.o ;;
         'W3FLX4MD'     ) modtest=w3flx4md.o ;;
         'W3FLXXMD'     ) modtest=w3flxxmd.o ;;
         'W3SLN1MD'     ) modtest=w3sln1md.o ;;
         'W3SLNXMD'     ) modtest=w3slnxmd.o ;;
         'W3SRC0MD'     ) modtest=w3src0md.o ;;
         'W3SRC1MD'     ) modtest=w3src1md.o ;;
         'W3SRC2MD'     ) modtest=w3src2md.o ;;
         'W3SRC3MD'     ) modtest=w3src3md.o ;;
         'W3SRC4MD'     ) modtest=w3src4md.o ;;
         'W3SRC6MD'     ) modtest=w3src6md.o ;;
         'W3SRCXMD'     ) modtest=w3srcxmd.o ;;
         'W3SNL1MD'     ) modtest=w3snl1md.o ;;
         'W3SNL2MD'     ) modtest=w3snl2md.o ;;
         'W3SNL3MD'     ) modtest=w3snl3md.o ;;
         'W3SNL4MD'     ) modtest=w3snl4md.o ;;
         'W3SNLXMD'     ) modtest=w3snlxmd.o ;;
         'W3SNLSMD'     ) modtest=w3snlsmd.o ;;
         'm_xnldata'    ) modtest=mod_xnl4v5.o ;;
         'serv_xnl4v5'  ) modtest=serv_xnl4v5.o ;;
         'm_fileio'     ) modtest=mod_fileio.o ;;
         'm_constants'  ) modtest=mod_constants.o ;;
         'W3SWLDMD'     ) modtest=w3swldmd.o ;;
         'W3SBT1MD'     ) modtest=w3sbt1md.o ;;
         'W3SBT4MD'     ) modtest=w3sbt4md.o ;;
         'W3SBT8MD'     ) modtest=w3sbt8md.o ;;
         'W3SBT9MD'     ) modtest=w3sbt9md.o ;;
         'W3SBTXMD'     ) modtest=w3sbtxmd.o ;;
         'W3SDB1MD'     ) modtest=w3sdb1md.o ;;
         'W3SDBXMD'     ) modtest=w3sdbxmd.o ;;
         'W3STR1MD'     ) modtest=w3str1md.o ;;
         'W3STRXMD'     ) modtest=w3strxmd.o ;;
         'W3SBS1MD'     ) modtest=w3sbs1md.o ;;
         'W3SBSXMD'     ) modtest=w3sbsxmd.o ;;
         'W3SIC1MD'     ) modtest=w3sic1md.o ;;
         'W3SIC2MD'     ) modtest=w3sic2md.o ;;
         'W3SIC3MD'     ) modtest=w3sic3md.o ;;
         'W3SIC4MD'     ) modtest=w3sic4md.o ;;
         'W3SIS1MD'     ) modtest=w3sis1md.o ;;
         'W3SIS2MD'     ) modtest=w3sis2md.o ;;
         'W3REF1MD'     ) modtest=w3ref1md.o ;;
         'W3SXXXMD'     ) modtest=w3sxxxmd.o ;;
         'CONSTANTS'    ) modtest=constants.o ;;
         'W3SERVMD'     ) modtest=w3servmd.o ;;
         'W3TIMEMD'     ) modtest=w3timemd.o ;;
         'W3ARRYMD'     ) modtest=w3arrymd.o ;;
         'W3DISPMD'     ) modtest=w3dispmd.o ;;
         'W3GSRUMD'     ) modtest=w3gsrumd.o ;;
         'W3TRIAMD'     ) modtest=w3triamd.o ;;
         'WMINITMD'     ) modtest=wminitmd.o ;;
         'WMWAVEMD'     ) modtest=wmwavemd.o ;;
         'WMFINLMD'     ) modtest=wmfinlmd.o ;;
         'WMMDATMD'     ) modtest=wmmdatmd.o ;;
         'WMGRIDMD'     ) modtest=wmgridmd.o ;;
         'WMUPDTMD'     ) modtest=wmupdtmd.o ;;
         'WMINIOMD'     ) modtest=wminiomd.o ;;
         'WMUNITMD'     ) modtest=wmunitmd.o ;;
         'WMIOPOMD'     ) modtest=wmiopomd.o ;;
         'WMSCRPMD'     ) modtest=wmscrpmd.o ;;
         'w3getmem'     ) modtest=w3getmem.o ;;
         'WW_cc'        ) modtest=ww.comm.o  ;;
         'CMP_COMM'     ) modtest=cmp.comm.o  ;;
         'W3OACPMD'     ) modtest=w3oacpmd.o ;;
         'W3AGCMMD'     ) modtest=w3agcmmd.o ;;
         'W3OGCMMD'     ) modtest=w3ogcmmd.o ;;
         'W3NAMLMD'     ) modtest=w3namlmd.o ;;
      esac
      nr=`grep $mod check_file | wc -c | awk '{ print $1 }'`
      if [ "$nr" -gt '8' ]
      then
        if [ "$modtest" != "$file.o" ]
        then
          string3="$string3 "'$(aPo)/'"$modtest"
        fi
      fi
    done
    rm -f check_file

    string_scripnc='$(aPo)/scrip_netcdfmod.o $(aPo)/scrip_remap_write.o $(aPo)/scrip_remap_read.o'
    if  [ "$scrip" = 'SCRIP' ] && [ "$file" = 'wmscrpmd' ]
    then
       S_string2='$(aPo)/scrip_constants.o $(aPo)/scrip_grids.o $(aPo)/scrip_iounitsmod.o  $(aPo)/scrip_remap_vars.o $(aPo)/scrip_timers.o $(aPo)/scrip_errormod.o $(aPo)/scrip_interface.o $(aPo)/scrip_kindsmod.o $(aPo)/scrip_remap_conservative.o'
       if  [ "$scripnc" = 'SCRIPNC' ]
       then
           S_string2="$S_string2 $string_scripnc"
       fi
       string3="$string3 $S_string2"
    fi

    if  [ "$scrip" = 'SCRIP' ] && [ "$file" = 'wmgridmd' ]
    then
        S_string2='$(aPo)/scrip_constants.o $(aPo)/scrip_grids.o $(aPo)/scrip_iounitsmod.o  $(aPo)/scrip_remap_vars.o $(aPo)/scrip_timers.o $(aPo)/scrip_errormod.o $(aPo)/scrip_interface.o $(aPo)/scrip_kindsmod.o $(aPo)/scrip_remap_conservative.o'
       if  [ "$scripnc" = 'SCRIPNC' ]
       then
           S_string2="$S_string2 $string_scripnc"
       fi
        string3="$string3 $S_string2"
    fi

    echo "$string1$string3"                      >> makefile
    echo "$string2"                              >> makefile
    echo ' '                                     >> makefile

  done

  echo '# end of WAVEWATCH III subroutines'      >> makefile
  rm -f filelist

  if  [ "$scrip" = 'SCRIP' ]
  then
    echo ' '                                       >> makefile
    echo ' '                                       >> makefile
    echo '# SCRIP subroutines'                     >> makefile
    echo '# -----------------'                     >> makefile
    echo ' '                                       >> makefile

    scrip_dir=$main_dir/ftn/SCRIP
    if [ ! -d $scrip_dir ]
    then
      echo "*** SCRIP directory $scrip_dir not found ***"
      exit 21
    fi

    if  [ "$scripnc" = 'SCRIPNC' ]
    then 
       scrip_mk=$scrip_dir/SCRIP_NC.mk
    else 
       scrip_mk=$scrip_dir/SCRIP.mk
    fi
    if [ ! -e $scrip_mk ]
    then
      echo "*** SCRIP makefile fragment $scrip_mk not found ***"
      exit 22
    fi

    cat $scrip_mk >> makefile

    echo '# end of SCRIP subroutines'              >> makefile
  fi

# --------------------------------------------------------------------------- #
# 4. Move makefile to proper place                                            #
# --------------------------------------------------------------------------- #

  mv makefile $main_dir/ftn/makefile

# end of script ------------------------------------------------------------- #

tar -cvf rt_visumain.tar  visu.pro initmain.pro rt_visumain.pro read_timeseries.pro julday.pro mapping.pro gridbuild.pro  bathytool.pro editspecials.pro maketransect.pro raytracer.pro parametros.pro   palette.pro xloadpalette.pro  
tar -uvf rt_visumain.tar palettes/*
tar -uvf rt_visumain.tar rayp.f90  raypfc.f90  raypf.f90  raypg.f90 
tar -uvf rt_visumain.tar TWIST_init.txt
gzip rt_visumain.tar

#!/bin/bash -e


if [ $# -ne 1 ]
then
  echo '  [ERROR] need ww3_multi input filename in argument [ww3_multi.inp]'
  exit 1
fi
inp=$1


version=$(bash --version | cut -d ' ' -f4)
version4=$(echo $version | cut -d '.' -f1)
echo $version4
if [ "$version4" != "4" ]
then
  echo '  [ERROR] need a version of bash at least 4'
  exit 1
fi


declare -A flginp
declare -A flggrd
declare -A fielddates
declare -A fieldlists
declare -A pointdates
declare -A pointfiles
declare -A trackdates
declare -A trackflags
declare -A restartdates
declare -A boundarydates
declare -A partitiondates
declare -A partfields
declare -A datafields


#------------------------------
# clean up inp file from all $ lines

rm -f ww3_multi_clean.inp

cat $inp | while read line
do
  
  if [ "$(echo $line | cut -c1)" = "$" ] 
  then
    continue
  fi

  echo $line >> ww3_multi_clean.inp

done

#------------------------------
# get all values from clean inp file

cat ww3_multi_clean.inp | while read line
do
  
echo $line

# model definition  
nrgrd="$(echo $line | cut -d ' ' -f1 | cut -d \" -f2  | cut -d \' -f2)"
nrinp="$(echo $line | cut -d ' ' -f2 | cut -d \" -f2  | cut -d \' -f2)"
unipts="$(echo $line | cut -d ' ' -f3 | cut -d \" -f2  | cut -d \' -f2)"
iostyp="$(echo $line | cut -d ' ' -f4 | cut -d \" -f2  | cut -d \' -f2)"
upproc="$(echo $line | cut -d ' ' -f5 | cut -d \" -f2  | cut -d \' -f2)"
pshare="$(echo $line | cut -d ' ' -f6 | cut -d \" -f2  | cut -d \' -f2)"


# input grids
for irinp in $(seq 1 $nrinp)
do
  read line
  inpid[$irinp]="$(echo $line | cut -d ' ' -f1 | cut -d \" -f2  | cut -d \' -f2)"
  numvar="$(echo $line | wc -w)"
  for iflag in $(seq 2  $numvar)
  do
    ind=$(expr $iflag - 1)
    flginp[$irinp,$ind]="$(echo $line | cut -d ' ' -f${iflag} | cut -d \" -f2  | cut -d \' -f2)"
    echo ${flginp[$irinp,$ind]}
  done
done

# unified point
if [ "$unipts" = "T" ]
then
  read line
  pointname="$(echo $line | cut -d \" -f2  | cut -d \' -f2)"
  echo $pointname
else
  pointname='points'
fi

# model grids
for irgrd in $(seq 1 $nrgrd)
do
  read line
  echo $line
  modid[$irgrd]="$(echo $line | cut -d ' ' -f1 | cut -d \" -f2  | cut -d \' -f2)"
  numvar=8
  for iflag in $(seq 2 $numvar)
  do
    ind=$(expr $iflag - 1)
    flggrd[$irgrd,$ind]="$(echo $line | cut -d ' ' -f${iflag} | cut -d \" -f2  | cut -d \' -f2)"
    echo ${flggrd[$irgrd,$ind]}
  done
  rank[$irgrd]="$(echo $line | cut -d ' ' -f$(expr $numvar + 1 ) | cut -d \" -f2  | cut -d \' -f2)"
  echo ${rank[$irgrd]}
  group[$irgrd]="$(echo $line | cut -d ' ' -f$(expr $numvar + 2 ) | cut -d \" -f2  | cut -d \' -f2)"
  echo ${group[$irgrd]}
  comm0[$irgrd]="$(echo $line | cut -d ' ' -f$(expr $numvar + 3 ) | cut -d \" -f2  | cut -d \' -f2)"
  echo ${comm0[$irgrd]}
  comm1[$irgrd]="$(echo $line | cut -d ' ' -f$(expr $numvar + 4 ) | cut -d \" -f2  | cut -d \' -f2)"
  echo ${comm1[$irgrd]}
  bound[$irgrd]="$(echo $line | cut -d ' ' -f$(expr $numvar + 5 ) | cut -d \" -f2  | cut -d \' -f2)"
  echo ${bound[$irgrd]}
done


# start stop dates
read line
start[1]="$(echo $line | cut -d ' ' -f1 | cut -d \" -f2  | cut -d \' -f2)"
start[2]="$(echo $line | cut -d ' ' -f2 | cut -d \" -f2  | cut -d \' -f2)"
stop[1]="$(echo $line | cut -d ' ' -f3 | cut -d \" -f2  | cut -d \' -f2)"
stop[2]="$(echo $line | cut -d ' ' -f4 | cut -d \" -f2  | cut -d \' -f2)"
echo ${start[@]}
echo ${stop[@]}

# masking flags
read line
flghg1="$(echo $line | cut -d ' ' -f1 | cut -d \" -f2  | cut -d \' -f2)"
flghg2="$(echo $line | cut -d ' ' -f2 | cut -d \" -f2  | cut -d \' -f2)"


# field date
echo 'field date'
read line
for i in $(seq 1 5)
do
  fielddate[$i]="$(echo $line | cut -d ' ' -f${i} | cut -d \" -f2  | cut -d \' -f2)"
done
echo ${fielddate[@]}

# field list
if [ ${fielddate[3]} -ne 0 ]
then
  read line
  fieldformat="$(echo $line)"

  if [ "${fieldformat}" = "N" ]
  then
    read line
    fieldlist="$(echo $line)"
  else
    echo "OLD FORMAT ! please use name format with N"
    exit 1
  fi
fi


# point date
echo 'point date'
read line
for i in $(seq 1 5)
do
  pointdate[$i]="$(echo $line | cut -d ' ' -f${i} | cut -d \" -f2  | cut -d \' -f2)"
done
echo ${pointdate[@]}

# point list
if [ ${pointdate[3]} -ne 0 ]
then
  pointfile="${pointname}.list"
  rm -f $pointfile
  read line
  tmpname="$(echo $line | cut -d ' ' -f3 | cut -d \" -f2  | cut -d \' -f2)"
  echo ${tmpname}
  while [ "${tmpname}" != "STOPSTRING" ]
  do
    echo $line >> $pointfile
    read line
    tmpname="$(echo $line | cut -d ' ' -f3 | cut -d \" -f2  | cut -d \' -f2)"
  done
fi


# track date
echo 'track date'
read line
for i in $(seq 1 5)
do
  trackdate[$i]="$(echo $line | cut -d ' ' -f${i} | cut -d \" -f2  | cut -d \' -f2)"
done
echo ${trackdate[@]}

# track flag
if [ ${trackdate[3]} -ne 0 ]
then
  read line
  trackflag="$(echo $line)"
fi


# restart date
echo 'restart date'
read line
for i in $(seq 1 5)
do
  restartdate[$i]="$(echo $line | cut -d ' ' -f${i} | cut -d \" -f2  | cut -d \' -f2)"
done
echo ${restartdate[@]}


# boundary date
echo 'boundary date'
read line
for i in $(seq 1 5)
do
  boundarydate[$i]="$(echo $line | cut -d ' ' -f${i} | cut -d \" -f2  | cut -d \' -f2)"
done
echo ${boundarydate[@]}


# partition date
echo 'partition date'
read line
for i in $(seq 1 5)
do
  partitiondate[$i]="$(echo $line | cut -d ' ' -f${i} | cut -d \" -f2  | cut -d \' -f2)"
done
echo ${partitiondate[@]}

# partition info
if [ ${partitiondate[3]} -ne 0 ]
then
  read line
  for i in $(seq 1 7)
  do
    partfield[$i]="$(echo $line | cut -d ' ' -f${i} | cut -d \" -f2  | cut -d \' -f2)"
  done
fi


# fill all model grids outputs
for j in $(seq 1 $nrgrd)
do
  for key in "${!fielddate[@]}"
  do
    fielddates[$j,$key]=${fielddate[$key]}
    pointdates[$j,$key]=${pointdate[$key]}
    trackdates[$j,$key]=${trackdate[$key]}
    restartdates[$j,$key]=${restartdate[$key]}
    boundarydates[$j,$key]=${boundarydate[$key]}
    partitiondates[$j,$key]=${partitiondate[$key]}
  done
  pointfiles[$j]=$pointfile
  fieldformats[$j]=$fieldformat
  fieldlists[$j]=$fieldlist
  trackflags[$j]=$trackflag
  for key in "${!partfield[@]}"
  do
    partfields[$j,$key]=${partfield[$key]}
  done
done


# output per model grid
read line
grdname="$(echo $line | cut -d ' ' -f1 | cut -d \" -f2  | cut -d \' -f2)"
grdnum="$(echo $line | cut -d ' ' -f2 | cut -d \" -f2  | cut -d \' -f2)"
while [ "$grdname" != 'the_end' ]
do
  for irgrd in $(seq 1 $nrgrd)
  do
    if [ "${modid[$irgrd]}" = "$grdname" ]
    then
      # field output
      if [ "${grdnum}" = "1" ]
      then
        read line
        for i in $(seq 1 5)
        do
          fielddates[$irgrd,$i]="$(echo $line | cut -d ' ' -f${i} | cut -d \" -f2  | cut -d \' -f2)"
        done
        if [ ${fielddates[$irgrd,3]} != 0 ]
        then
          read line
          fieldformats[$irgrd]="$(echo $line)"

          if [ "${fieldformats[$irgrd]}" = "N" ]
          then
            read line
            fieldlists[$irgrd]="$(echo $line)"
          else
            echo "OLD FORMAT ! please use name format with N"
            exit 1
          fi
        fi

      # point output
      elif [ "${grdnum}" = "2" ] 
      then
        read line
        for i in $(seq 1 5)
        do
          pointdates[$irgrd,$i]="$(echo $line | cut -d ' ' -f${i} | cut -d \" -f2  | cut -d \' -f2)"
        done
        if [ ${pointdates[$irgrd,3]} != 0 ]
        then
          pointfiles[$irgrd]="points_${irgrd}.list"
          rm -f ${pointfiles[$irgrd]}
          read line
          tmpname="$(echo $line | cut -d ' ' -f3 | cut -d \" -f2  | cut -d \' -f2)"
          while [ "$tmpname" != "STOPSTRING" ]
          do
            echo $line >> ${pointfiles[$irgrd]}
            read line
            tmpname="$(echo $line | cut -d ' ' -f3 | cut -d \" -f2  | cut -d \' -f2)"
          done
        fi

      # track output
      elif [ "${grdnum}" = "3" ] 
      then
        read line
        for i in $(seq 1 5)
        do
          trackdates[$irgrd,$i]="$(echo $line | cut -d ' ' -f${i} | cut -d \" -f2  | cut -d \' -f2)"
        done
        if [ ${trackdates[$irgrd,3]} != 0 ]
        then
          read line
          trackflags[$irgrd]="$(echo $line)"
        fi

      # restart output
      elif [ "${grdnum}" = "4" ] 
      then
        read line
        for i in $(seq 1 5)
        do
          restartdates[$irgrd,$i]="$(echo $line | cut -d ' ' -f${i} | cut -d \" -f2  | cut -d \' -f2)"
        done

      # boundary output
      elif [ "${grdnum}" = "5" ] 
      then
        read line
        for i in $(seq 1 5)
        do
          boundarydates[$irgrd,$i]="$(echo $line | cut -d ' ' -f${i} | cut -d \" -f2  | cut -d \' -f2)"
        done

      # partition output
      elif [ "${grdnum}" = "6" ] 
      then
        read line
        for i in $(seq 1 5)
        do
          partitiondates[$irgrd,$i]="$(echo $line | cut -d ' ' -f${i} | cut -d \" -f2  | cut -d \' -f2)"
        done
        if [ ${partitiondates[$irgrd,3]} != 0 ]
        then
          read line
          for i in $(seq 1 7)
          do
            partfields[$irgrd,$i]="$(echo $line | cut -d ' ' -f${i} | cut -d \" -f2  | cut -d \' -f2)"
          done
        fi
      fi
    fi
  done
  echo $grdname
  read line
  grdname="$(echo $line | cut -d ' ' -f1 | cut -d \" -f2  | cut -d \' -f2)"
  grdnum="$(echo $line | cut -d ' ' -f2 | cut -d \" -f2  | cut -d \' -f2)"
done
echo $grdname


# moving grid data
read line
dataname="$(echo $line | cut -d ' ' -f1 | cut -d \" -f2  | cut -d \' -f2)"
imove=0
while [ "$dataname" != 'STP' ]
do
  imove=$(expr $imove + 1 )
  echo $dataname
  datafields[$imove,1]="$(echo $line | cut -d ' ' -f1 | cut -d \" -f2  | cut -d \' -f2)"
  datafields[$imove,2]="$(echo $line | cut -d ' ' -f2 | cut -d \" -f2  | cut -d \' -f2)"
  datafields[$imove,3]="$(echo $line | cut -d ' ' -f3 | cut -d \" -f2  | cut -d \' -f2)"
  datafields[$imove,4]="$(echo $line | cut -d ' ' -f4 | cut -d \" -f2  | cut -d \' -f2)"
  datafields[$imove,5]="$(echo $line | cut -d ' ' -f5 | cut -d \" -f2  | cut -d \' -f2)"
  read line
  dataname="$(echo $line | cut -d ' ' -f1 | cut -d \" -f2  | cut -d \' -f2)"
done
nmove=$imove
echo $dataname




#------------------------------
# write value in a new nml file

nmlfile=$(basename $inp .inp).nml



# domain def namelist
cat > $nmlfile << EOF
! -------------------------------------------------------------------- !
! Define top-level model parameters via domain_def_nml namelist
! * namelist must be terminated with /
! * definitions & defaults:
!     domain%nrinp  =  0  ! Number of grids defining input fields.
!     domain%nrgrd  =  1  ! Number of wave model grids.
!     domain%nmove  =  0  ! Number of moving grid inputs.
!     domain%unipts =  F  ! Flag for using unified point output file.
!     domain%iostyp =  1  ! Output server type as in ww3_shel.nml
!     domain%upproc =  F  ! Flag for dedicated process for unified point output.
!     domain%pshare =  F  ! Flag for grids sharing dedicated output processes.
!     domain%flghg1 =  T  ! Flag for masking computation in two-way nesting
!     domain%flghg2 =  T  ! Flag for masking at printout time
!     domain%start  = '19680606 000000'  ! Start date for the entire model 
!     domain%stop   = '19680607 000000'  ! Stop date for the entire model
! -------------------------------------------------------------------- !
&domain_def_nml
EOF

if [ "$nrinp" != 0 ];                       then  echo "  domain%nrinp  = $nrinp" >> $nmlfile; fi
if [ "$nrgrd" != 1 ];                       then  echo "  domain%nrgrd  = $nrgrd" >> $nmlfile; fi
if [ "$nmove" != 0 ];                       then  echo "  domain%nmove  = $nmove" >> $nmlfile; fi
if [ "$unipts" != "F" ];                    then  echo "  domain%unipts = $unipts" >> $nmlfile; fi
if [ "$iostyp" != 1 ];                      then  echo "  domain%iostyp = $iostyp" >> $nmlfile; fi
if [ "$upproc" != "F" ];                    then  echo "  domain%upproc = $upproc" >> $nmlfile; fi
if [ "$pshare" != "F" ];                    then  echo "  domain%pshare = $pshare" >> $nmlfile; fi
if [ "$flghg1" != "T" ];                    then  echo "  domain%flghg1 = $flghg1" >> $nmlfile; fi
if [ "$flghg2" != "T" ];                    then  echo "  domain%flghg2 = $flghg2" >> $nmlfile; fi
if [ "${start[*]}" != "19680606 000000" ];  then  echo "  domain%start  = '${start[@]}'" >> $nmlfile; fi
if [ "${stop[*]}" != "19680607 000000" ];   then  echo "  domain%stop   = '${stop[@]}'" >> $nmlfile; fi




# input grid namelist
cat >> $nmlfile << EOF
/

! -------------------------------------------------------------------- !
! Define each input grid via the input_grid_nml namelist
! * namelist must be terminated with /
! * input(i)%name must be set for each active input grid i
! * definitions & defaults:
!     input(i)%name                  = 'unset'
!     input(i)%forcing%water_levels  = F
!     input(i)%forcing%currents      = F
!     input(i)%forcing%winds         = F
!     input(i)%forcing%ice_conc      = F
!     input(i)%forcing%ice_param1    = F
!     input(i)%forcing%ice_param2    = F
!     input(i)%forcing%ice_param3    = F
!     input(i)%forcing%ice_param4    = F
!     input(i)%forcing%ice_param5    = F
!     input(i)%forcing%mud_density   = F
!     input(i)%forcing%mud_thickness = F
!     input(i)%forcing%mud_viscosity = F
!     input(i)%assim%mean            = F
!     input(i)%assim%spec1d          = F
!     input(i)%assim%spec2d          = F
! -------------------------------------------------------------------- !
&input_grid_nml
EOF

for irinp in $(seq 1 $nrinp)
do
  if [ "${inpid[$irinp]}" != 'unset' ] 
  then
                                              echo "  input($irinp)%name                  = '${inpid[$irinp]}'" >> $nmlfile
    if [ "${flginp[$irinp,1]}" != 'F' ];then  echo "  input($irinp)%forcing%water_levels  = ${flginp[$irinp,1]}" >> $nmlfile; fi
    if [ "${flginp[$irinp,2]}" != 'F' ];then  echo "  input($irinp)%forcing%currents      = ${flginp[$irinp,2]}" >> $nmlfile; fi
    if [ "${flginp[$irinp,3]}" != 'F' ];then  echo "  input($irinp)%forcing%winds         = ${flginp[$irinp,3]}" >> $nmlfile; fi
    if [ "${flginp[$irinp,4]}" != 'F' ];then  echo "  input($irinp)%forcing%ice_conc      = ${flginp[$irinp,4]}" >> $nmlfile; fi
    if [ "${flginp[$irinp,5]}" != 'F' ];then  echo "  input($irinp)%assim%mean            = ${flginp[$irinp,5]}" >> $nmlfile; fi
    if [ "${flginp[$irinp,6]}" != 'F' ];then  echo "  input($irinp)%assim%spec1d          = ${flginp[$irinp,6]}" >> $nmlfile; fi
    if [ "${flginp[$irinp,7]}" != 'F' ];then  echo "  input($irinp)%assim%spec2d          = ${flginp[$irinp,7]}" >> $nmlfile; fi
  fi
done


# model grid namelist
cat >> $nmlfile << EOF
/

! -------------------------------------------------------------------- !
! Define each model grid via the model_grid_nml namelist
! * namelist must be terminated with /
! * model(i)%name must be set for each active model grid i
! * definitions & defaults:
!     model(i)%name                  = 'unset'
!     model(i)%forcing%water_levels  = 'no'
!     model(i)%forcing%currents      = 'no'
!     model(i)%forcing%winds         = 'no'
!     model(i)%forcing%ice_conc      = 'no'
!     model(i)%forcing%ice_param1    = 'no'
!     model(i)%forcing%ice_param2    = 'no'
!     model(i)%forcing%ice_param3    = 'no'
!     model(i)%forcing%ice_param4    = 'no'
!     model(i)%forcing%ice_param5    = 'no'
!     model(i)%forcing%mud_density   = 'no'
!     model(i)%forcing%mud_thickness = 'no'
!     model(i)%forcing%mud_viscosity = 'no'
!     model(i)%assim%mean            = 'no'
!     model(i)%assim%spec1d          = 'no'
!     model(i)%assim%spec2d          = 'no'
!     model(i)%resource%rank_id      = i
!     model(i)%resource%group_id     = 1
!     model(i)%resource%sibling_id   = 0
!     model(i)%resource%comm_frac    = 0.00,1.00
!     model(i)%resource%bound_flag   = F
!
!     model(i)%forcing = 'no' 'no' 'no' 'no' 'no' 'no'
!
!     model(i)%resource = i 1 0 0.00 1.00 f
! -------------------------------------------------------------------- !
&model_grid_nml
EOF

for irgrd in $(seq 1 $nrgrd)
do
  if [ "${modid[$irgrd]}" != 'unset' ] 
  then
                                                echo "  model($irgrd)%name                  = '${modid[$irgrd]}'" >> $nmlfile
    if [ "${flggrd[$irgrd,1]}" != 'no' ]; then  echo "  model($irgrd)%forcing%water_levels  = '${flggrd[$irgrd,1]}'" >> $nmlfile; fi
    if [ "${flggrd[$irgrd,2]}" != 'no' ]; then  echo "  model($irgrd)%forcing%currents      = '${flggrd[$irgrd,2]}'" >> $nmlfile; fi
    if [ "${flggrd[$irgrd,3]}" != 'no' ]; then  echo "  model($irgrd)%forcing%winds         = '${flggrd[$irgrd,3]}'" >> $nmlfile; fi
    if [ "${flggrd[$irgrd,4]}" != 'no' ]; then  echo "  model($irgrd)%forcing%ice_conc      = '${flggrd[$irgrd,4]}'" >> $nmlfile; fi
    if [ "${flggrd[$irgrd,5]}" != 'no' ]; then  echo "  model($irgrd)%assim%mean            = '${flggrd[$irgrd,5]}'" >> $nmlfile; fi
    if [ "${flggrd[$irgrd,6]}" != 'no' ]; then  echo "  model($irgrd)%assim%spec1d          = '${flggrd[$irgrd,6]}'" >> $nmlfile; fi
    if [ "${flggrd[$irgrd,7]}" != 'no' ]; then  echo "  model($irgrd)%assim%spec2d          = '${flggrd[$irgrd,7]}'" >> $nmlfile; fi
    if [ "${rank[$irgrd]}" != "$irgrd" ]; then  echo "  model($irgrd)%resource%rank_id      = ${rank[$irgrd]}" >> $nmlfile; fi
    if [ "${group[$irgrd]}" != 1 ];       then  echo "  model($irgrd)%resource%group_id     = ${group[$irgrd]}" >> $nmlfile; fi
    if [ "${comm0[$irgrd]},${comm1[$irgrd]}" != '0.00,1.00' ];then  
                                                echo "  model($irgrd)%resource%comm_frac    = ${comm0[$irgrd]},${comm1[$irgrd]}" >> $nmlfile; fi
    if [ "${bound[$irgrd]}" != 'F' ];     then  echo "  model($irgrd)%resource%bound_flag   = ${bound[$irgrd]}" >> $nmlfile; fi
  fi
done


# output type namelist
cat >> $nmlfile << EOF
/

! -------------------------------------------------------------------- !
! Define the output types point parameters via output_type_nml namelist
! * namelist must be terminated with /
! * alltype will apply the output types for all the model grids
! * itype(i) will apply the output types for the model grid number i
! * the full list of field names is : 
!  DPT CUR WND AST WLV ICE IBG D50 IC1 IC5 HS LM T02 T0M1 T01 FP DIR SPR
!  DP HIG EF TH1M STH1M TH2M STH2M WN PHS PTP PLP PDIR PSPR PWS TWS PNR
!  UST CHA CGE FAW TAW TWA WCC WCF WCH WCM SXY TWO BHD FOC TUS USS P2S
!  USF P2L TWI FIC ABR UBR BED FBB TBB MSS MSC DTD FC CFX CFD CFK U1 U2 
! * need domain%unipts equal true to use a unified point output file
! * the point file is a space separated values per line : lon lat 'name'
! * output track file formatted (t) or unformated (f)
! * definitions & defaults:
!     alltype%field%list         =  'unset'
!     alltype%point%name         =  'unset'
!     alltype%point%file         =  'unset'
!     alltype%track%format       =  T
!     alltype%partition%x0       =  0
!     alltype%partition%xn       =  0
!     alltype%partition%nx       =  0
!     alltype%partition%y0       =  0
!     alltype%partition%yn       =  0
!     alltype%partition%ny       =  0
!     alltype%partition%format   =  T
!
!     itype(i)%track%format      =  T
!
!     alltype%partition          =  0 0 0 0 0 0 T
! -------------------------------------------------------------------- !
&output_type_nml
EOF

if [ "${fielddate[3]}" != 0 ];    then  echo "  alltype%field%list       = '$fieldlist'" >> $nmlfile; fi

if [ "${pointdate[3]}" != 0 ]
then
  if [ "$pointname" != 'unset' ] && [ "$unipts" = "T" ]; then  
                                        echo "  alltype%point%name       = '$pointname'" >> $nmlfile; fi
  if [ "$pointfile" != 'unset' ]; then  echo "  alltype%point%file       = '$pointfile'" >> $nmlfile; fi
fi

if [ "${trackdate[3]}" != 0 ] && [ "$trackflag" != T ];    then  
                                        echo "  alltype%track%format     = $trackflag" >> $nmlfile; fi
if [ "${partitiondate[3]}" != 0 ]
then
#  if [ "${partfield[1]}" != 0 ];  then  echo "  alltype%partition%x0     = ${partfield[1]}" >> $nmlfile; fi
#  if [ "${partfield[2]}" != 0 ];  then  echo "  alltype%partition%xn     = ${partfield[2]}" >> $nmlfile; fi
#  if [ "${partfield[3]}" != 0 ];  then  echo "  alltype%partition%nx     = ${partfield[3]}" >> $nmlfile; fi
#  if [ "${partfield[4]}" != 0 ];  then  echo "  alltype%partition%y0     = ${partfield[4]}" >> $nmlfile; fi
#  if [ "${partfield[5]}" != 0 ];  then  echo "  alltype%partition%yn     = ${partfield[5]}" >> $nmlfile; fi
#  if [ "${partfield[6]}" != 0 ];  then  echo "  alltype%partition%ny     = ${partfield[6]}" >> $nmlfile; fi
#  if [ "${partfield[7]}" != T ];  then  echo "  alltype%partition%format = ${partfield[7]}" >> $nmlfile; fi
  if [ "${partfield[1]}" != 0 ] || [ "${partfield[2]}" != 0 ] || [ "${partfield[3]}" != 0 ] || [ "${partfield[4]}" != 0 ] || \
     [ "${partfield[5]}" != 0 ] || [ "${partfield[6]}" != 0 ] || [ "${partfield[7]}" != T ];  then
  echo "  alltype%partition        = ${partfield[1]} ${partfield[2]} ${partfield[3]} ${partfield[4]} ${partfield[5]} ${partfield[6]} ${partfield[7]}" >> $nmlfile; fi
fi

for irgrd in $(seq 1 $nrgrd)
do
  if [ "${fieldlist}" != "${fieldlists[$irgrd]}" ]; then
    echo "  itype(${irgrd})%field%list      = ${fieldlists[$irgrd]}" >> $nmlfile; fi

  if [ "${pointfile}" != "${pointfiles[$irgrd]}" ]; then
    echo "  itype(${irgrd})%point%file      = '${pointfiles[$irgrd]}'" >> $nmlfile; fi

  if [ "${trackflag}" != "${trackflags[$irgrd]}" ]; then
    echo "  itype(${irgrd})%track%format    = ${trackflags[$irgrd]}" >> $nmlfile; fi

#  if [ "${partfield[1]}" != "${partfields[$irgrd,1]}" ]; then
#    echo "  type(${irgrd})%partition%x0     = ${partfields[$irgrd,1]}" >> $nmlfile; fi
#  if [ "${partfield[2]}" != "${partfields[$irgrd,2]}" ]; then
#    echo "  type(${irgrd})%partition%xn     = ${partfields[$irgrd,2]}" >> $nmlfile; fi
#  if [ "${partfield[3]}" != "${partfields[$irgrd,3]}" ]; then
#    echo "  type(${irgrd})%partition%nx     = ${partfields[$irgrd,3]}" >> $nmlfile; fi
#  if [ "${partfield[4]}" != "${partfields[$irgrd,4]}" ]; then
#    echo "  type(${irgrd})%partition%y0     = ${partfields[$irgrd,4]}" >> $nmlfile; fi
#  if [ "${partfield[5]}" != "${partfields[$irgrd,5]}" ]; then
#    echo "  type(${irgrd})%partition%yn     = ${partfields[$irgrd,5]}" >> $nmlfile; fi
#  if [ "${partfield[6]}" != "${partfields[$irgrd,6]}" ]; then
#    echo "  type(${irgrd})%partition%ny     = ${partfields[$irgrd,6]}" >> $nmlfile; fi
#  if [ "${partfield[7]}" != "${partfields[$irgrd,7]}" ]; then
#    echo "  type(${irgrd})%partition%format = ${partfields[$irgrd,7]}" >> $nmlfile; fi
  if [ "${partfield[1]}" != "${partfields[$irgrd,1]}" ] || [ "${partfield[2]}" != "${partfields[$irgrd,2]}" ] || \
     [ "${partfield[3]}" != "${partfields[$irgrd,3]}" ] || [ "${partfield[4]}" != "${partfields[$irgrd,4]}" ] || \
     [ "${partfield[5]}" != "${partfields[$irgrd,5]}" ] || [ "${partfield[6]}" != "${partfields[$irgrd,6]}" ] || \
     [ "${partfield[7]}" != "${partfields[$irgrd,7]}" ]; then
  echo "  itype(${irgrd})%partition       = ${partfields[$irgrd,1]} ${partfields[$irgrd,2]} ${partfields[$irgrd,3]} ${partfields[$irgrd,4]} ${partfields[$irgrd,5]} ${partfields[$irgrd,6]} ${partfields[$irgrd,7]}" >> $nmlfile; fi

done

# output date namelist
cat >> $nmlfile << EOF
/

! -------------------------------------------------------------------- !
! Define output dates via output_date_nml namelist
! * namelist must be terminated with /
! * alldate will apply the output dates for all the model grids
! * idate(i) will apply the output dates for the model grid number i
! * start and stop times are with format 'yyyymmdd hhmmss'
! * if time stride is equal '0', then output is disabled
! * time stride is given in seconds
! * it is possible to overwrite a global output date for a given grid
! * definitions & defaults:
!     alldate%field%start          =  '19680606 000000'
!     alldate%field%stride         =  '0'
!     alldate%field%stop           =  '19680607 000000'
!     alldate%point%start          =  '19680606 000000'
!     alldate%point%stride         =  '0'
!     alldate%point%stop           =  '19680607 000000'
!     alldate%track%start          =  '19680606 000000'
!     alldate%track%stride         =  '0'
!     alldate%track%stop           =  '19680607 000000'
!     alldate%restart%start        =  '19680606 000000'
!     alldate%restart%stride       =  '0'
!     alldate%restart%stop         =  '19680607 000000'
!     alldate%boundary%start       =  '19680606 000000'
!     alldate%boundary%stride      =  '0'
!     alldate%boundary%stop        =  '19680607 000000'
!     alldate%partition%start      =  '19680606 000000'
!     alldate%partition%stride     =  '0'
!     alldate%partition%stop       =  '19680607 000000'
!     
!     idate(i)%partition%startdate =  '19680606 000000' 
!
!     alldate%restart              =  '19680606 000000' '0' '19680607 000000'
! -------------------------------------------------------------------- !
&output_date_nml
EOF

if [ "${fielddate[1]}" != '19680606' ] || [ "${fielddate[2]}" != '000000' ] || [ "${fielddate[3]}" != '0' ] || \
   [ "${fielddate[4]}" != '19680607' ] || [ "${fielddate[5]}" != '000000' ]; then  
      echo "  alldate%field          = '${fielddate[1]} ${fielddate[2]}' '${fielddate[3]}' '${fielddate[4]} ${fielddate[5]}'" >> $nmlfile; fi

if [ "${pointdate[1]}" != '19680606' ] || [ "${pointdate[2]}" != '000000' ] || [ "${pointdate[3]}" != '0' ] || \
   [ "${pointdate[4]}" != '19680607' ] || [ "${pointdate[5]}" != '000000' ]; then  
      echo "  alldate%point          = '${pointdate[1]} ${pointdate[2]}' '${pointdate[3]}' '${pointdate[4]} ${pointdate[5]}'" >> $nmlfile; fi

if [ "${trackdate[1]}" != '19680606' ] || [ "${trackdate[2]}" != '000000' ] || [ "${trackdate[3]}" != '0' ] || \
   [ "${trackdate[4]}" != '19680607' ] || [ "${trackdate[5]}" != '000000' ]; then  
      echo "  alldate%track          = '${trackdate[1]} ${trackdate[2]}' '${trackdate[3]}' '${trackdate[4]} ${trackdate[5]}'" >> $nmlfile; fi

if [ "${restartdate[1]}" != '19680606' ] || [ "${restartdate[2]}" != '000000' ] || [ "${restartdate[3]}" != '0' ] || \
   [ "${restartdate[4]}" != '19680607' ] || [ "${restartdate[5]}" != '000000' ]; then  
      echo "  alldate%restart        = '${restartdate[1]} ${restartdate[2]}' '${restartdate[3]}' '${restartdate[4]} ${restartdate[5]}'" >> $nmlfile; fi

if [ "${boundarydate[1]}" != '19680606' ] || [ "${boundarydate[2]}" != '000000' ] || [ "${boundarydate[3]}" != '0' ] || \
   [ "${boundarydate[4]}" != '19680607' ] || [ "${boundarydate[5]}" != '000000' ]; then  
      echo "  alldate%boundary       = '${boundarydate[1]} ${boundarydate[2]}' '${boundarydate[3]}' '${boundarydate[4]} ${boundarydate[5]}'" >> $nmlfile; fi

if [ "${partitiondate[1]}" != '19680606' ] || [ "${partitiondate[2]}" != '000000' ] || [ "${partitiondate[3]}" != '0' ] || \
   [ "${partitiondate[4]}" != '19680607' ] || [ "${partitiondate[5]}" != '000000' ]; then  
      echo "  alldate%partition      = '${partitiondate[1]} ${partitiondate[2]}' '${partitiondate[3]}' '${partitiondate[4]} ${partitiondate[5]}'" >> $nmlfile; fi


for irgrd in $(seq 1 $nrgrd)
do
  if [ "${fielddate[1]}" != "${fielddates[$irgrd,1]}" ] || [ "${fielddate[2]}" != "${fielddates[$irgrd,2]}" ] || \
     [ "${fielddate[3]}" != "${fielddates[$irgrd,3]}" ] || [ "${fielddate[4]}" != "${fielddates[$irgrd,4]}" ] || \
     [ "${fielddate[5]}" != "${fielddates[$irgrd,5]}" ]; then  
        echo "  idate($irgrd)%field         = '${fielddates[$irgrd,1]} ${fielddates[$irgrd,2]}' '${fielddates[$irgrd,3]}' '${fielddates[$irgrd,4]} ${fielddates[$irgrd,5]}'" >> $nmlfile; fi

  if [ "${pointdate[1]}" != "${pointdates[$irgrd,1]}" ] || [ "${pointdate[2]}" != "${pointdates[$irgrd,2]}" ] || \
     [ "${pointdate[3]}" != "${pointdates[$irgrd,3]}" ] || [ "${pointdate[4]}" != "${pointdates[$irgrd,4]}" ] || \
     [ "${pointdate[5]}" != "${pointdates[$irgrd,5]}" ]; then  
        echo "  idate($irgrd)%point         = '${pointdates[$irgrd,1]} ${pointdates[$irgrd,2]}' '${pointdates[$irgrd,3]}' '${pointdates[$irgrd,4]} ${pointdates[$irgrd,5]}'" >> $nmlfile; fi

  if [ "${trackdate[1]}" != "${trackdates[$irgrd,1]}" ] || [ "${trackdate[2]}" != "${trackdates[$irgrd,2]}" ] || \
     [ "${trackdate[3]}" != "${trackdates[$irgrd,3]}" ] || [ "${trackdate[4]}" != "${trackdates[$irgrd,4]}" ] || \
     [ "${trackdate[5]}" != "${trackdates[$irgrd,5]}" ]; then  
        echo "  idate($irgrd)%track         = '${trackdates[$irgrd,1]} ${trackdates[$irgrd,2]}' '${trackdates[$irgrd,3]}' '${trackdates[$irgrd,4]} ${trackdates[$irgrd,5]}'" >> $nmlfile; fi

  if [ "${restartdate[1]}" != "${restartdates[$irgrd,1]}" ] || [ "${restartdate[2]}" != "${restartdates[$irgrd,2]}" ] || \
     [ "${restartdate[3]}" != "${restartdates[$irgrd,3]}" ] || [ "${restartdate[4]}" != "${restartdates[$irgrd,4]}" ] || \
     [ "${restartdate[5]}" != "${restartdates[$irgrd,5]}" ]; then   
        echo "  idate($irgrd)%restart       = '${restartdates[$irgrd,1]} ${restartdates[$irgrd,2]}' '${restartdates[$irgrd,3]}' '${restartdates[$irgrd,4]} ${restartdates[$irgrd,5]}'" >> $nmlfile; fi

  if [ "${boundarydate[1]}" != "${boundarydates[$irgrd,1]}" ] || [ "${boundarydate[2]}" != "${boundarydates[$irgrd,2]}" ] || \
     [ "${boundarydate[3]}" != "${boundarydates[$irgrd,3]}" ] || [ "${boundarydate[4]}" != "${boundarydates[$irgrd,4]}" ] || \
     [ "${boundarydate[5]}" != "${boundarydates[$irgrd,5]}" ]; then  
        echo "  idate($irgrd)%boundary      = '${boundarydates[$irgrd,1]} ${boundarydates[$irgrd,2]}' '${boundarydates[$irgrd,3]}' '${boundarydates[$irgrd,4]} ${boundarydates[$irgrd,5]}'" >> $nmlfile; fi

  if [ "${partitiondate[1]}" != "${partitiondates[$irgrd,1]}" ] || [ "${partitiondate[2]}" != "${partitiondates[$irgrd,2]}" ] || \
     [ "${partitiondate[3]}" != "${partitiondates[$irgrd,3]}" ] || [ "${partitiondate[4]}" != "${partitiondates[$irgrd,4]}" ] || \
     [ "${partitiondate[5]}" != "${partitiondates[$irgrd,5]}" ]; then  
        echo "  idate($irgrd)%partition     = '${partitiondates[$irgrd,1]} ${partitiondates[$irgrd,2]}' '${partitiondates[$irgrd,3]}' '${partitiondates[$irgrd,4]} ${partitiondates[$irgrd,5]}'" >> $nmlfile; fi
done

# homogeneous input namelist
cat >> $nmlfile << EOF
/

! -------------------------------------------------------------------- !
! Define homogeneous input via homonegenous_input_nml namelist
! * namelist must be terminated with /
! * the number of moving grid inputs is defined by domain_def%nmove
! * each homogeneous input must start from index imove = 1 to nmove
! * if speed is equal 0, then the moving grid is desactivated
! * definitions & defaults:
!     homogeneous(imove)%moving%start      =  '19680606 000000'
!     homogeneous(imove)%moving%speed      =  0
!     homogeneous(imove)%moving%direction  =  0
! -------------------------------------------------------------------- !
&homogeneous_input_nml
EOF

for imove in $(seq 1 $nmove)
do
  if [ "${datafields[$imove,2]} ${datafields[$imove,3]}" != '19680606 000000' ]; then
  echo "  homogeneous($imove)%moving%start         = '${datafields[$imove,2]} ${datafields[$imove,3]}'" >> $nmlfile; fi
  if [ "${datafields[$imove,4]}" != '0' ]; then
  echo "  homogeneous($imove)%moving%speed         = ${datafields[$imove,4]}" >> $nmlfile; fi
  if [ "${datafields[$imove,5]}" != '0' ]; then
  echo "  homogeneous($imove)%moving%direction     = ${datafields[$imove,5]}" >> $nmlfile; fi
done

cat >> $nmlfile << EOF
/

EOF

done # must be closed here to keep the variables values locally

rm -f ww3_multi_clean.inp
#------------------------------
